// PlatformIO compatible header file ML5.h 20210823.
// For Nuvoton ML51 ML54 ML56 series.

#ifndef ML5_H
#define ML5_H
#include <compiler.h>

/*  ML56 SFR BYTE page 0  */

SFR(P0, 0x80);
   SBIT(P00, 0x80, 0); //Port 0 Bit 0
   SBIT(P01, 0x80, 1); //Port 0 Bit 1
   SBIT(P02, 0x80, 2); //Port 0 Bit 2
   SBIT(P03, 0x80, 3); //Port 0 Bit 3
   SBIT(P04, 0x80, 4); //Port 0 Bit 4
   SBIT(P05, 0x80, 5); //Port 0 Bit 5
   SBIT(P06, 0x80, 6); //Port 0 Bit 6
   SBIT(P07, 0x80, 7); //Port 0 Bit 7
   SBIT(P0_0, 0x80, 0); //Port 0 Bit 0
   SBIT(P0_1, 0x80, 1); //Port 0 Bit 1
   SBIT(P0_2, 0x80, 2); //Port 0 Bit 2
   SBIT(P0_3, 0x80, 3); //Port 0 Bit 3
   SBIT(P0_4, 0x80, 4); //Port 0 Bit 4
   SBIT(P0_5, 0x80, 5); //Port 0 Bit 5
   SBIT(P0_6, 0x80, 6); //Port 0 Bit 6
   SBIT(P0_7, 0x80, 7); //Port 0 Bit 7
   // See data sheet for additional pin names.
SFR(SP, 0x81);
SFR(DPTR, 0x82);
SFR(DPL,  0x82);
SFR(DPH, 0x83);
SFR(RCTRIM0, 0x84);
SFR(RCTRIM1, 0x85);
SFR(RWKL, 0x86);
SFR(PCON, 0x87);
SFR(TCON, 0x88);
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag
SFR(TMOD, 0x89);
SFR(TL0, 0x8A);
SFR(TL1, 0x8B);
SFR(TH0, 0x8C);
SFR(TH1, 0x8D);
SFR(CKCON, 0x8E);
SFR(WKCON, 0x8F);
SFR(P1, 0x90);
   SBIT(P10, 0x90, 0); //Port 1 Bit 0
   SBIT(P11, 0x90, 1); //Port 1 Bit 1
   SBIT(P12, 0x90, 2); //Port 1 Bit 2
   SBIT(P13, 0x90, 3); //Port 1 Bit 3
   SBIT(P14, 0x90, 4); //Port 1 Bit 4
   SBIT(P15, 0x90, 5); //Port 1 Bit 5
   SBIT(P16, 0x90, 6); //Port 1 Bit 6
   SBIT(P17, 0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
   // See data sheet for additional pin names.
SFR(SFRS, 0x91);
SFR(DMA0CR0, 0x92);
SFR(DMA0MAL, 0x93);
SFR(DMA0CNT, 0x94);
SFR(DMA0CCNT, 0x95);
SFR(CKSWT, 0x96);
SFR(CKEN, 0x97);
SFR(SCON, 0x98);
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //Serial Mode 0
   SBIT(FE,  0x98, 7); //Framing Error
SFR(SBUF, 0x99);
SFR(SBUF1, 0x9A);
SFR(EIE0, 0x9B);
SFR(EIE1, 0x9C);
SFR(RSR, 0x9D);
SFR(CHPCON, 0x9F);
SFR(P2, 0xA0);
   SBIT(ACMP0_N1, 0xA0, 0); //Analog Comparator 0 Negative 1
   SBIT(ACMP_P2,  0xA0, 1); //Analog Comparator Positive 2
   SBIT(ACMP1_N0, 0xA0, 2); //Analog Comparator 1 Negative 0
   SBIT(ACMP_P1,  0xA0, 3); //Analog Comparator Positive 1
   SBIT(ACMP0_N0, 0xA0, 4); //Analog Comparator 0 Negative 0
   SBIT(ACMP_P0,  0xA0, 5); //Analog Comparator Positive 0
   SBIT(ADC_CH5,  0xA0, 0); //ADC Channel 5
   SBIT(ACH5,     0xA0, 0); //ADC Channel 5
   SBIT(ADC5,     0xA0, 0); //AtoD Channel 5
   SBIT(AIN5,     0xA0, 0); //Analog Input 5
   SBIT(ADC_CH4,  0xA0, 1); //ADC Channel 4
   SBIT(ACH4,     0xA0, 1); //ADC Channel 4
   SBIT(ADC4,     0xA0, 1); //AtoD Channel 4
   SBIT(AIN4,     0xA0, 1); //Analog Input 4
   SBIT(ADC_CH3,  0xA0, 2); //ADC Channel 3
   SBIT(ACH3,     0xA0, 2); //ADC Channel 3
   SBIT(ADC3,     0xA0, 2); //AtoD Channel 3
   SBIT(AIN3,     0xA0, 2); //Analog Input 3
   SBIT(ADC_CH2,  0xA0, 3); //ADC Channel 2
   SBIT(ACH2,     0xA0, 3); //ADC Channel 2
   SBIT(ADC2,     0xA0, 3); //AtoD Channel 2
   SBIT(AIN2,     0xA0, 3); //Analog Input 2
   SBIT(ADC_CH1,  0xA0, 4); //ADC Channel 1
   SBIT(ACH1,     0xA0, 4); //ADC Channel 1
   SBIT(ADC1,     0xA0, 4); //AtoD Channel 1
   SBIT(AIN1,     0xA0, 4); //Analog Input 1
   SBIT(ADC_CH0,  0xA0, 5); //ADC Channel 0
   SBIT(ACH0,     0xA0, 5); //ADC Channel 0
   SBIT(ADC0,     0xA0, 5); //AtoD Channel 0
   SBIT(AIN0,     0xA0, 5); //Analog Input 0
   SBIT(ADC_CH15, 0xA0, 7); //ADC Channel 15
   SBIT(ACH15,    0xA0, 7); //ADC Channel 15
   SBIT(ADC15,    0xA0, 7); //AtoD Channel 15
   SBIT(AIN15,    0xA0, 7); //Analog Input 15
   SBIT(P20, 0xA0, 0); //Port 2 Bit 0
   SBIT(P21, 0xA0, 1); //Port 2 Bit 1
   SBIT(P22, 0xA0, 2); //Port 2 Bit 2
   SBIT(P23, 0xA0, 3); //Port 2 Bit 3
   SBIT(P24, 0xA0, 4); //Port 2 Bit 4
   SBIT(P25, 0xA0, 5); //Port 2 Bit 5
   SBIT(P26, 0xA0, 6); //Port 2 Bit 6
   SBIT(P27, 0xA0, 7); //Port 2 Bit 7
   SBIT(P2_0, 0xA0, 0); //Port 2 Bit 0
   SBIT(P2_1, 0xA0, 1); //Port 2 Bit 1
   SBIT(P2_2, 0xA0, 2); //Port 2 Bit 2
   SBIT(P2_3, 0xA0, 3); //Port 2 Bit 3
   SBIT(P2_4, 0xA0, 4); //Port 2 Bit 4
   SBIT(P2_5, 0xA0, 5); //Port 2 Bit 5
   SBIT(P2_6, 0xA0, 6); //Port 2 Bit 6
   SBIT(P2_7, 0xA0, 7); //Port 2 Bit 7
   // See data sheet for additional pin names.
SFR(ADCCON0, 0xA1);
SFR(AUXR0, 0xA2);
SFR(BODCON0, 0xA3);
SFR(IAPTRG, 0xA4);
SFR(IAPUEN, 0xA5);
SFR(IAPAL, 0xA6);
SFR(IAPAH, 0xA7); //(only byte addressable)
SFR(IE, 0xA8);
   SBIT(EX0,  0xA8, 0); //Enable External 0
   SBIT(ET0,  0xA8, 1); //Enable Timer 0
   SBIT(EX1,  0xA8, 2); //Enable External 1
   SBIT(ET1,  0xA8, 3); //Enable Timer 1
   SBIT(ES,   0xA8, 4); //Enable Serial
   SBIT(EBOD, 0xA8, 5); //Enable Brown Out Detector
   SBIT(EADC, 0xA8, 6); //Enable Analog Digital Converter
   SBIT(EA,   0xA8, 7); //Enable All
SFR(SADDR0, 0xA9);
SFR(WDCON, 0xAA);
SFR(BODCON1, 0xAB);
SFR(EIP2, 0xAC);
SFR(EIPH2, 0xAD);
SFR(IAPFD, 0xAE);
SFR(IAPCN, 0xAF);
SFR(P3, 0xB0);
   SBIT(ACMP_P3,  0xB0, 0); //Analog Comparator Positive 3
   SBIT(ACMP1_N1, 0xB0, 1); //Analog Comparator 1 Negative 1
   SBIT(ADC_CH10, 0xB0, 0); //ADC Channel 10
   SBIT(ACH10,    0xB0, 0); //ADC Channel 10
   SBIT(ADC10,    0xB0, 0); //AtoD Channel 10
   SBIT(AIN10,    0xB0, 0); //Analog Input 10
   SBIT(ADC_CH6,  0xB0, 1); //ADC Channel 6
   SBIT(ACH6,     0xB0, 1); //ADC Channel 6
   SBIT(ADC6,     0xB0, 1); //AtoD Channel 6
   SBIT(AIN6,     0xB0, 1); //Analog Input 6
   SBIT(ADC_CH7,  0xB0, 2); //ADC Channel 7
   SBIT(ACH7,     0xB0, 2); //ADC Channel 7
   SBIT(ADC7,     0xB0, 2); //AtoD Channel 7
   SBIT(AIN7,     0xB0, 2); //Analog Input 7
   SBIT(P30, 0xB0, 0); //Port 3 Bit 0
   SBIT(P31, 0xB0, 1); //Port 3 Bit 1
   SBIT(P32, 0xB0, 2); //Port 3 Bit 2
   SBIT(P33, 0xB0, 3); //Port 3 Bit 3
   SBIT(P34, 0xB0, 4); //Port 3 Bit 4
   SBIT(P35, 0xB0, 5); //Port 3 Bit 5
   SBIT(P36, 0xB0, 6); //Port 3 Bit 6
   SBIT(P37, 0xB0, 7); //Port 3 Bit 7
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_1, 0xB0, 1); //Port 3 Bit 1
   SBIT(P3_2, 0xB0, 2); //Port 3 Bit 2
   SBIT(P3_3, 0xB0, 3); //Port 3 Bit 3
   SBIT(P3_4, 0xB0, 4); //Port 3 Bit 4
   SBIT(P3_5, 0xB0, 5); //Port 3 Bit 5
   SBIT(P3_6, 0xB0, 6); //Port 3 Bit 6
   SBIT(P3_7, 0xB0, 7); //Port 3 Bit 7
   // See data sheet for additional pin names.
SFR(P5, 0xB1); //(only byte addressable)
   #define P50  0x01 //Port 5 Bit 0
   #define P51  0x02 //Port 5 Bit 1
   #define P52  0x04 //Port 5 Bit 2
   #define P53  0x08 //Port 5 Bit 3
   #define P54  0x10 //Port 5 Bit 4
   #define P55  0x20 //Port 5 Bit 5
   #define P56  0x40 //Port 5 Bit 6
   #define P57  0x80 //Port 5 Bit 7
   #define P5_0 0x01 //Port 5 Bit 0
   #define P5_1 0x02 //Port 5 Bit 1
   #define P5_2 0x04 //Port 5 Bit 2
   #define P5_3 0x08 //Port 5 Bit 3
   #define P5_4 0x10 //Port 5 Bit 4
   #define P5_5 0x20 //Port 5 Bit 5
   #define P5_6 0x40 //Port 5 Bit 6
   #define P5_7 0x80 //Port 5 Bit 7
   // See data sheet for additional pin names.
SFR(I2C1ADDR0, 0xB2);
SFR(I2C1DAT, 0xB3);
SFR(I2C1STAT, 0xB4);
SFR(I2C1CLK, 0xB5);
SFR(I2C1TOC, 0xB6);
SFR(IPH, 0xB7);
SFR(IP, 0xB8);
   SBIT(PX0,  0xB8, 0); //Priority External 0
   SBIT(PT0,  0xB8, 1); //Priority Timer 0
   SBIT(PX1,  0xB8, 2); //Priority External 1
   SBIT(PT1,  0xB8, 3); //Priority Timer 1
   SBIT(PS,   0xB8, 4); //Priority Serial
   SBIT(PBOD, 0xB8, 5); //Priority Brown Out Detection
   SBIT(PADC, 0xB8, 6); //Priority Analog Digital Converter
SFR(SADEN, 0xB9);
SFR(SADEN1, 0xBA);
SFR(SADDR1, 0xBB);
SFR(I2C0DAT, 0xBC);
SFR(I2C0STAT, 0xBD);
SFR(I2C0CLK, 0xBE);
SFR(I2C0TOC, 0xBF);
SFR(I2C0CON, 0xC0);
   SBIT(I2CPX0, 0xC0, 0); //Inter-Integrated Circuit Pin eXchange 0
   SBIT(AA0,    0xC0, 2); //Acknowledge Assert 0
   SBIT(SI0,    0xC0, 3); //Status Interrupt 0
   SBIT(STO0,   0xC0, 4); //Stop 0
   SBIT(STA0,   0xC0, 5); //Start 0
   SBIT(I2CEN0, 0xC0, 6); //Inter-Integrated Circuit Enable 0
   SBIT(I0,     0xC0, 7); //Increase 0
SFR(I2C0ADDR0, 0xC1);
SFR(ADCRL, 0xC2);
SFR(ADCRH, 0xC3);
SFR(T3CON, 0xC4);
SFR(RL3, 0xC5);
SFR(RH3, 0xC6);
SFR(TA, 0xC7);
SFR(T2CON, 0xC8);
   SBIT(CM_RL2, 0xC8, 0); //Compare Reload 2
   SBIT(TR2,    0xC8, 2); //Timer 2 Run
   SBIT(TF2,    0xC8, 7); //Timer 2 Flag
SFR(T2MOD, 0xC9);
SFR(PIF, 0xCA);
SFR(ADCBAL, 0xCB);
SFR(TL2, 0xCC);
SFR(TH2, 0xCD);
SFR(ADCMPL, 0xCE);
SFR(ADCMPH, 0xCF);
SFR(PSW, 0xD0);
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry
SFR(PWM0CON0, 0xD1);
SFR(ACMPCR0, 0xD2);
SFR(ACMPCR1, 0xD3);
SFR(ACMPSR, 0xD4);
SFR(ACMPVREF, 0xD5);
SFR(SC0CR0, 0xD6);
SFR(SC0CR1, 0xD7);
SFR(P4, 0xD8);
   SBIT(P40, 0xD8, 0); //Port 4 Bit 0
   SBIT(P41, 0xD8, 1); //Port 4 Bit 1
   SBIT(P42, 0xD8, 2); //Port 4 Bit 2
   SBIT(P43, 0xD8, 3); //Port 4 Bit 3
   SBIT(P44, 0xD8, 4); //Port 4 Bit 4
   SBIT(P45, 0xD8, 5); //Port 4 Bit 5
   SBIT(P46, 0xD8, 6); //Port 4 Bit 6
   SBIT(P47, 0xD8, 7); //Port 4 Bit 7
   SBIT(P4_0, 0xD8, 0); //Port 4 Bit 0
   SBIT(P4_1, 0xD8, 1); //Port 4 Bit 1
   SBIT(P4_2, 0xD8, 2); //Port 4 Bit 2
   SBIT(P4_3, 0xD8, 3); //Port 4 Bit 3
   SBIT(P4_4, 0xD8, 4); //Port 4 Bit 4
   SBIT(P4_5, 0xD8, 5); //Port 4 Bit 5
   SBIT(P4_6, 0xD8, 6); //Port 4 Bit 6
   SBIT(P4_7, 0xD8, 7); //Port 4 Bit 7
   // See data sheet for additional pin names.
SFR(SC0DR, 0xD9);
SFR(SC0EGT, 0xDA);
SFR(SC0ETURD0, 0xDB);
SFR(SC0ETURD1, 0xDC);
SFR(SC0IE, 0xDD);
SFR(SC0IS, 0xDE);
SFR(SC0TSR, 0xDF);
SFR(ACC, 0xE0);
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7
SFR(ADCCON1, 0xE1);
SFR(ADCCON2, 0xE2);
SFR(ADCDLY, 0xE3);
SFR(ADCBAH, 0xE4);
SFR(ADCSN, 0xE5);
SFR(ADCCN, 0xE6);
SFR(ADCSR, 0xE7);
SFR(I2C1CON, 0xE8);
   SBIT(I2CPX1, 0xE8, 0); //Inter-Integrated Circuit Pin eXchange 1
   SBIT(AA1,    0xE8, 2); //Acknowledge Assert 1
   SBIT(SI1,    0xE8, 3); //Status Interrupt 1
   SBIT(STO1,   0xE8, 4); //Stop 1
   SBIT(STA1,   0xE8, 5); //Start 1
   SBIT(I2CEN1, 0xE8, 6); //Inter-Integrated Circuit Enable 1
   SBIT(I1,     0xE8, 7); //Increase 1
SFR(DMA0TSR, 0xE9);
SFR(MTM0DAL, 0xEA);
SFR(DMA1CR0, 0xEB);
SFR(DMA1MAL, 0xEC);
SFR(DMA1CNT, 0xED);
SFR(DMA1CCNT, 0xEE);
SFR(EIP0, 0xEF);
SFR(B, 0xF0);
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7
SFR(DMA1TSR, 0xF1);
SFR(MTM1DAL, 0xF2);
SFR(SPI0CR0, 0xF3);
SFR(SPI0SR, 0xF4);
SFR(SPI0DR, 0xF5);
SFR(DMA0BAH, 0xF6);
SFR(EIPH0, 0xF7);
SFR(S1CON,  0xF8);
SFR(SCON_1, 0xF8);
   SBIT(RI_1,  0xF8, 0); //Receive Interrupt UART-1
   SBIT(TI_1,  0xF8, 1); //Transmit Interrupt UART-1
   SBIT(RB8_1, 0xF8, 2); //Receive Bit 8 UART-1
   SBIT(TB8_1, 0xF8, 3); //Transmit Bit 8 UART-1
   SBIT(REN_1, 0xF8, 4); //Receive Enable UART-1
   SBIT(SM2_1, 0xF8, 5); //Serial Mode 2 UART-1
   SBIT(SM1_1, 0xF8, 6); //Serial Mode 1 UART-1
   SBIT(SM0_1, 0xF8, 7); //(WR)Serial Mode 0 UART-1
   SBIT(FE_1,  0xF8, 7); //(RD)Framing Error UART-1
SFR(SPI1CR0, 0xF9);
SFR(SPI1CR1, 0xFA);
SFR(SPI1SR, 0xFB);
SFR(SPI1DR, 0xFC);
SFR(DMA1BAH, 0xFD);
SFR(EIP1, 0xFE);
SFR(EIPH1, 0xFF);

/*  ML56 SFR BYTE page 1  */

SFR(LIRCTRIM, 0x84);
SFR(XLTCON, 0x85);
SFR(CWKL, 0x86);
SFR(P0DW, 0x8A);
SFR(P1DW, 0x8B);
SFR(P2DW, 0x8C);
SFR(P3DW, 0x8D);
SFR(P4DW, 0x8E);
SFR(P5DW, 0x8F);

SFR(P0UP, 0x92);
SFR(P1UP, 0x93);
SFR(P2UP, 0x94);
SFR(P3UP, 0x95);
SFR(P4UP, 0x96);
SFR(P5UP, 0x97);
SFR(P0S, 0x99);
SFR(P0SR, 0x9A);
SFR(P1S, 0x9B);
SFR(P1SR, 0x9C);
SFR(P2S, 0x9D);
SFR(P2SR, 0x9E);

SFR(PIPS0, 0xA1);
SFR(PIPS1, 0xA2);
SFR(PIPS2, 0xA3);
SFR(PIPS3, 0xA4);
SFR(PIPS4, 0xA5);
SFR(PIPS5, 0xA6);
SFR(PIPS6, 0xA7);
SFR(VRFCON, 0xA9);
SFR(VRFTRIM, 0xAA);
SFR(ACMPCR2, 0xAB);
SFR(P3S, 0xAC);
SFR(P3SR, 0xAD);
SFR(P5SR, 0xAE);
SFR(PIPS7, 0xAF);

SFR(P0M1, 0xB1);
SFR(P0M2, 0xB2);
SFR(P1M1, 0xB3);
SFR(P1M2, 0xB4);
SFR(P2M1, 0xB5);
SFR(P2M2, 0xB6);
SFR(PWM0INTC, 0xB7);
SFR(P4M1, 0xB9);
SFR(P4M2, 0xBA);
SFR(P4S, 0xBB);
SFR(P4SR, 0xBC);
SFR(P5M1, 0xBD);
SFR(P5M2, 0xBE);
SFR(P5S, 0xBF);

SFR(CKDIV, 0xC1);
SFR(P3M1, 0xC2);
SFR(P3M2, 0xC3);
SFR(PWM0C4H, 0xC4);
SFR(PWM0C5H, 0xC5);
SFR(PORDIS, 0xC6);
SFR(AUXR1, 0xC9);
SFR(RCMP2L, 0xCA);
SFR(RCMP2H, 0xCB);
SFR(PWM0C4L, 0xCC);
SFR(PWM0C5L, 0xCD);
SFR(AINDIDS0, 0xCE);

SFR(PWM0PH, 0xD1);
SFR(PWM0C0H, 0xD2);
SFR(PWM0C1H, 0xD3);
SFR(PWM0C2H, 0xD4);
SFR(PWM0C3H, 0xD5);
SFR(PWM0NP, 0xD6);
SFR(PWM0FBD, 0xD7);
SFR(PWM0PL, 0xD9);
SFR(PWM0C0L, 0xDA);
SFR(PWM0C1L, 0xDB);
SFR(PWM0C2L, 0xDC);
SFR(PWM0C3L, 0xDD);
SFR(PWM0CON1, 0xDF);

SFR(CAPCON0, 0xE1);
SFR(CAPCON1, 0xE2);
SFR(CAPCON2, 0xE3);
SFR(C0L, 0xE4);
SFR(C0H, 0xE5);
SFR(C1L, 0xE6);
SFR(C1H, 0xE7);
SFR(PICON, 0xE9);
SFR(PINEN, 0xEA);
SFR(PIPEN, 0xEB);
SFR(C2L, 0xED);
SFR(C2H, 0xEE);
SFR(LDOTRIM, 0xEF);

SFR(SPI0CR1, 0xF3);
SFR(PWM0DTEN, 0xF9);
SFR(PWM0DTCNT, 0xFA);
SFR(PWM0MEN, 0xFB);
SFR(PWM0MD, 0xFC);
SFR(LVRFLTEN, 0xFD);
SFR(LVRDIS, 0xFF);

/*  ML56 SFR BYTE page 2  */

SFR(P6M1, 0x84);
SFR(P6M2, 0x85);
SFR(PWM1PH, 0x86);
SFR(PWM1C0H, 0x8A);
SFR(PWM1C1H, 0x8B);
SFR(PWM1MD, 0x8C);
SFR(PWM1MEN, 0x8D);
SFR(P6SR, 0x8E);
SFR(P6DW, 0x8F);

SFR(P6MF10, 0x92);
SFR(P6MF32, 0x93);
SFR(P6MF54, 0x94);
SFR(P6MF76, 0x95);
SFR(P6S, 0x96);
SFR(P6UP, 0x97);
SFR(PWM1PL, 0x99);
SFR(PWM1C0L, 0x9A);
SFR(PWM1C1L, 0x9B);
SFR(PWM1CON0, 0x9C);
SFR(PWM1CON1, 0x9D);
SFR(PWM1INTC, 0x9E);

SFR(I2C0ADDR1, 0xA1);
SFR(I2C0ADDR2, 0xA2);
SFR(I2C0ADDR3, 0xA3);
SFR(I2C1ADDR1, 0xA4);
SFR(I2C1ADDR2, 0xA5);
SFR(I2C1ADDR3, 0xA6);
SFR(P6, 0xA7);
   #define ADC_CH14 0x10 //ADC Channel 14
   #define ACH14    0x10 //ADC Channel 14
   #define ADC14    0x10 //AtoD Channel 14
   #define AIN14    0x10 //Analog Input 14
   #define ADC_CH13 0x20 //ADC Channel 13
   #define ACH13    0x20 //ADC Channel 13
   #define ADC13    0x20 //AtoD Channel 13
   #define AIN13    0x20 //Analog Input 13
   #define ADC_CH12 0x40 //ADC Channel 12
   #define ACH12    0x40 //ADC Channel 12
   #define ADC12    0x40 //AtoD Channel 12
   #define AIN12    0x40 //Analog Input 12
   #define ADC_CH11 0x80 //ADC Channel 11
   #define ACH11    0x80 //ADC Channel 11
   #define ADC11    0x80 //AtoD Channel 11
   #define AIN11    0x80 //Analog Input 11
   #define P60  0x01 //Port 6 Bit 0
   #define P61  0x02 //Port 6 Bit 1
   #define P62  0x04 //Port 6 Bit 2
   #define P63  0x08 //Port 6 Bit 3
   #define P64  0x10 //Port 6 Bit 4
   #define P65  0x20 //Port 6 Bit 5
   #define P66  0x40 //Port 6 Bit 6
   #define P67  0x80 //Port 6 Bit 7
   #define P6_0 0x01 //Port 6 Bit 0
   #define P6_1 0x02 //Port 6 Bit 1
   #define P6_2 0x04 //Port 6 Bit 2
   #define P6_3 0x08 //Port 6 Bit 3
   #define P6_4 0x10 //Port 6 Bit 4
   #define P6_5 0x20 //Port 6 Bit 5
   #define P6_6 0x40 //Port 6 Bit 6
   #define P6_7 0x80 //Port 6 Bit 7
   // See data sheet for additional pin names.
SFR(DMA3TSR, 0xA9);
SFR(DMA3BAH, 0xAA);
SFR(DMA3CR0, 0xAB);
SFR(DMA3MAL, 0xAC);
SFR(DMA3CNT, 0xAD);
SFR(DMA3CCNT, 0xAE);
SFR(MTM3DAL, 0xAF);

SFR(DMA2TSR, 0xB1);
SFR(DMA2BAH, 0xB2);
SFR(DMA2CR0, 0xB3);
SFR(DMA2MAL, 0xB4);
SFR(DMA2CNT, 0xB5);
SFR(DMA2CCNT, 0xB6);
SFR(MTM2DAL, 0xB7);
SFR(PWM2PH, 0xB9);
SFR(PWM2C0H, 0xBA);
SFR(PWM2C1H, 0xBB);
SFR(PWM2MD, 0xBC);
SFR(PWM2MEN, 0xBD);
SFR(CWKH, 0xBE);
SFR(RWKH, 0xBF);

SFR(PWM2PL, 0xC1);
SFR(PWM2C0L, 0xC2);
SFR(PWM2C1L, 0xC3);
SFR(PWM2CON0, 0xC4);
SFR(PWM2CON1, 0xC5);
SFR(PWM2INTC, 0xC6);
SFR(PWM3PH, 0xC9);
SFR(PWM3C0H, 0xCA);
SFR(PWM3C1H, 0xCB);
SFR(PWM3MD, 0xCC);
SFR(PWM3MEN, 0xCD);
SFR(AINDIDS1, 0xCE);
SFR(I2C0ADDRM, 0xCF);

SFR(PWM3PL, 0xD1);
SFR(PWM3C0L, 0xD2);
SFR(PWM3C1L, 0xD3);
SFR(PWM3CON0, 0xD4);
SFR(PWM3CON1, 0xD5);
SFR(PWM3INTC, 0xD6);
SFR(I2C1ADDRM, 0xD7);
SFR(SC1DR, 0xD9);
SFR(SC1EGT, 0xDA);
SFR(SC1ETURD0, 0xDB);
SFR(SC1ETURD1, 0xDC);
SFR(SC1IE, 0xDD);
SFR(SC1IS, 0xDE);
SFR(SC1TSR, 0xDF);

SFR(P5MF32, 0xE1);
SFR(P5MF54, 0xE2);
SFR(P5MF76, 0xE3);
SFR(BRCTRIM, 0xE4);
SFR(ADCCAL, 0xE5);
SFR(SC1CR0, 0xE6);
SFR(SC1CR1, 0xE7);
SFR(P3MF54, 0xE9);
SFR(P3MF76, 0xEA);
SFR(P4MF10, 0xEB);
SFR(P4MF32, 0xEC);
SFR(P4MF54, 0xED);
SFR(P4MF76, 0xEE);
SFR(P5MF10, 0xEF);

SFR(P1MF76, 0xF1);
SFR(P2MF10, 0xF2);
SFR(P2MF32, 0xF3);
SFR(P2MF54, 0xF4);
SFR(P2MF76, 0xF5);
SFR(P3MF10, 0xF6);
SFR(P3MF32, 0xF7);
SFR(P0MF10, 0xF9);
SFR(P0MF32, 0xFA);
SFR(P0MF54, 0xFB);
SFR(P0MF76, 0xFC);
SFR(P1MF10, 0xFD);
SFR(P1MF32, 0xFE);
SFR(P1MF54, 0xFF);

/*  ML56 SFR BYTE page 3  */

SFR(DMA0CR1, 0x8A);
SFR(DMA1CR1, 0x8B);
SFR(DMA2CR1, 0x8C);
SFR(DMA3CR1, 0x8D);

SFR(DMA0CRC, 0x92);
SFR(DMA1CRC, 0x93);
SFR(DMA2CRC, 0x94);
SFR(DMA3CRC, 0x95);
SFR(WDCONH, 0x99);
SFR(DMA0SEED, 0x9A);
SFR(DMA1SEED, 0x9B);
SFR(DMA2SEED, 0x9C);
SFR(DMA3SEED, 0x9D);

SFR(RTCINIT, 0xA1);
SFR(RTCRWEN, 0xA2);
SFR(RTCCLKSEL, 0xA3);
SFR(RTCFREQADJ0, 0xA4);
SFR(RTCFREQADJ1, 0xA5);
SFR(RTCINTEN, 0xA6);
SFR(RTCINTSTS, 0xA7);
SFR(RTCTIMESEC, 0xA9);
SFR(RTCTIMEMIN, 0xAA);
SFR(RTCTIMEHR, 0xAB);
SFR(RTCCALDAY, 0xAD);
SFR(RTCCALMON, 0xAE);
SFR(RTCCALYEAR, 0xAF);

SFR(RTCTALMSEC, 0xB1);
SFR(RTCTALMMIN, 0xB2);
SFR(RTCTALMHR, 0xB3);
SFR(RTCTALMHZ, 0xB4);
SFR(RTCCALMDAY, 0xB5);
SFR(RTCCALMMON, 0xB6);
SFR(RTCCALMYEAR, 0xB7);
SFR(RTCCLKFMT, 0xB9);
SFR(RTCWEEKDAY, 0xBB);
SFR(RTCLEAPYEAR, 0xBC);
SFR(RTCTICK, 0xBD);
SFR(RTCTAMSK, 0xBE);
SFR(RTCCAMSK, 0xBF);

SFR(PWM0FBS, 0xCE);
SFR(AUXR3, 0xCF);

SFR(LCDCPALCT1, 0xE9);
SFR(LCDCPCT1, 0xEA);

SFR(LCDCPUMP, 0xF1);
SFR(LCDCON1, 0xF4);
SFR(LCDCPALCT0, 0xF5);
SFR(LCDCPCT0, 0xF6);
SFR(LCDCON0, 0xF9);
SFR(LCDCLK, 0xFA);
SFR(LCDPTR, 0xFB);
SFR(LCDDAT, 0xFC);
SFR(LCDPWR, 0xFD);
SFR(LCDBL, 0xFE);
SFR(LCDMODE, 0xFF);

//Interrupt numbers: Address = ( Number * 8 ) + 3
//Vectors are named after their corresponding interrupt
//enable register bit, so that we don't have to make up
//names and can be consisten across different 8051 MCUs
   #define X0_VECTOR   0  // 0x03 External Interrupt 0
   #define T0_VECTOR   1  // 0x0B Timer 0
   #define X1_VECTOR   2  // 0x13 External Interrupt 1
   #define T1_VECTOR   3  // 0x1B Timer 1
   #define S_VECTOR    4  // 0x23 Serial Port 0
   #define T2_VECTOR   5  // 0x2B Timer 2
   #define I2C0_VECTOR 6  // 0x33 Inter-Integrated Circuit 0
   #define PI_VECTOR   7  // 0x3B Pin Interrupt
   #define BOD_VECTOR  8  // 0x43 Brown-out
   #define SPI0_VECTOR 9  // 0x4B Serial Peripheral Interface 0
   #define WDT_VECTOR  10 // 0x53 Watchdog timer
   #define ADC_VECTOR  11 // 0x5B Analog Digital Converter
   #define CAP_VECTOR  12 // 0x63 Input Capture
   #define PWM0_VECTOR 13 // 0x6B Pulse Width Modulator 0
   #define FB_VECTOR   14 // 0x73 Fault Brake Event
   #define S1_VECTOR   15 // 0x7B Serial Port 1
   #define T3_VECTOR   16 // 0x83 Timer 3
   #define WKT_VECTOR  17 // 0x8B Self Wake-up Timer
   #define HF_VECTOR   18 // 0x93 CPU Hard Fault
   #define SMC0_VECTOR 19 // 0x9B Smart Card 0
   #define DMA0_VECTOR 20 // 0xA3 Direct Memory Access 0
   #define DMA1_VECTOR 21 // 0xAB Direct Memory Access 1
   #define SPI1_VECTOR 22 // 0xB3 Serial Peripheral Interface 1
   #define ACMP_VECTOR 23 // 0xBB Analog Comparator
   #define I2C1_VECTOR 24 // 0xC3 Inter-Integrated Circuit 1
   #define PWM_VECTOR  25 // 0xCB Pulse Width Modulator 123
   #define TK_VECTOR   26 // 0xD3 Touch Key
   #define SMC1_VECTOR 27 // 0xDB Smart Card 1
   #define DMA2_VECTOR 28 // 0xE3 Direct Memory Access 2
   #define DMA3_VECTOR 29 // 0xEB Direct Memory Access 3
   #define RTC_VECTOR  30 // 0xF3 Real Time Clock

#endif