// PlatformIO compatible header file MS51_16K.h 20210823.
// For Nuvoton MS51_16K series.

#ifndef MS51_16K_H
#define MS51_16K_H
#include <compiler.h>

SFR(P0, 0x80);
   SBIT(IC3_P00,      0x80, 0); //Input Capture 3
   SBIT(MOSI,         0x80, 0); //Master Out Slave In
   SBIT(PWM0_CH3_P00, 0x80, 0); //Pulse Width Modulator 0 Channel 3
   SBIT(T1,           0x80, 0); //Timer 1
   SBIT(IC4,          0x80, 1); //Input Capture 4
   SBIT(MISO,         0x80, 1); //Master In Slave Out
   SBIT(PWM0_CH4,     0x80, 1); //Pulse Width Modulator 0 Channel 4
   SBIT(ICE_CLK,      0x80, 2); //In Circuit Emulator Clock
   SBIT(RXD_1,        0x80, 2); //Receive Data 1
   SBIT(SCL_P02,      0x80, 2); //Serial Clock
   SBIT(ADC_CH6,      0x80, 3); //Analog Digital Converter Channel 6
   SBIT(ACH6,         0x80, 3); //ADC Channel 6
   SBIT(ADC6,         0x80, 3); //AtoD Channel 6
   SBIT(AIN6,         0x80, 3); //Analog Input 6
   SBIT(IC5,          0x80, 3); //Input Capture 5
   SBIT(PWM0_CH5_P03, 0x80, 3); //Pulse Width Modulator 0 Channel 5
   SBIT(ADC_CH5,      0x80, 4); //Analog Digital Converter Channel 5
   SBIT(ACH5,         0x80, 4); //ADC Channel 5
   SBIT(ADC5,         0x80, 4); //AtoD Channel 5
   SBIT(AIN5,         0x80, 4); //Analog Input 5
   SBIT(IC3_P04,      0x80, 4); //Input Capture 3
   SBIT(PWM0_CH3_P04, 0x80, 4); //Pulse Width Modulator 0 Channel 3
   SBIT(STADC,        0x80, 4); //Start Analog to Digital Conversion
   SBIT(ADC_CH4,      0x80, 5); //Analog Digital Converter Channel 4
   SBIT(ACH4,         0x80, 5); //ADC Channel 4
   SBIT(ADC4,         0x80, 5); //AtoD Channel 4
   SBIT(AIN4,         0x80, 5); //Analog Input 4
   SBIT(IC6,          0x80, 5); //Input Capture 6
   SBIT(PWM0_CH2_P05, 0x80, 5); //Pulse Width Modulator 0 Channel 2
   SBIT(T0,           0x80, 5); //Timer 0
   SBIT(ADC_CH3,      0x80, 6); //Analog Digital Converter Channel 3
   SBIT(ACH3,         0x80, 6); //ADC Channel 3
   SBIT(ADC3,         0x80, 6); //AtoD Channel 3
   SBIT(AIN3,         0x80, 6); //Analog Input 3
   SBIT(RXD_P06,      0x80, 6); //Receive Data
   SBIT(TXD,          0x80, 6); //Transmit Data
   SBIT(ADC_CH2,      0x80, 7); //Analog Digital Converter Channel 2
   SBIT(ACH2,         0x80, 7); //ADC Channel 2
   SBIT(ADC2,         0x80, 7); //AtoD Channel 2
   SBIT(AIN2,         0x80, 7); //Analog Input 2
   SBIT(RXD,          0x80, 7); //Receive Data
   SBIT(TXD_P07,      0x80, 7); //Transmit Data
   SBIT(P00, 0x80, 0); //Port 0 Bit 0
   SBIT(P01, 0x80, 1); //Port 0 Bit 1
   SBIT(P02, 0x80, 2); //Port 0 Bit 2
   SBIT(P03, 0x80, 3); //Port 0 Bit 3
   SBIT(P04, 0x80, 4); //Port 0 Bit 4
   SBIT(P05, 0x80, 5); //Port 0 Bit 5
   SBIT(P06, 0x80, 6); //Port 0 Bit 6
   SBIT(P07, 0x80, 7); //Port 0 Bit 7
   SBIT(P0_0, 0x80, 0); //Port 0 Bit 0
   SBIT(P0_1, 0x80, 1); //Port 0 Bit 1
   SBIT(P0_2, 0x80, 2); //Port 0 Bit 2
   SBIT(P0_3, 0x80, 3); //Port 0 Bit 3
   SBIT(P0_4, 0x80, 4); //Port 0 Bit 4
   SBIT(P0_5, 0x80, 5); //Port 0 Bit 5
   SBIT(P0_6, 0x80, 6); //Port 0 Bit 6
   SBIT(P0_7, 0x80, 7); //Port 0 Bit 7
SFR(SP, 0x81);
SFR(DPTR, 0x82);
SFR(DPL,  0x82);
SFR(DPH, 0x83);
SFR(RCTRIM0, 0x84);
SFR(RCTRIM1, 0x85);
SFR(RWK, 0x86);
SFR(PCON, 0x87);
SFR(TCON, 0x88);
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag
SFR(TMOD, 0x89);
SFR(TL0, 0x8A);
SFR(TL1, 0x8B);
SFR(TH0, 0x8C);
SFR(TH1, 0x8D);
SFR(CKCON, 0x8E);
SFR(WKCON, 0x8F);
SFR(P1, 0x90);
   SBIT(IC2,          0x90, 0); //Input Capture 2
   SBIT(PWM0_CH2_P00, 0x90, 0); //Pulse Width Modulator 0 Channel 2
   SBIT(SPCLK,        0x90, 0); //Serial Peripheral Clock
   SBIT(ADC_CH7,      0x90, 1); //Analog Digital Converter Channel 7
   SBIT(ACH7,         0x90, 1); //ADC Channel 7
   SBIT(ADC7,         0x90, 1); //AtoD Channel 7
   SBIT(AIN7,         0x90, 1); //Analog Input 7
   SBIT(CLKO,         0x90, 1); //Clock Out
   SBIT(IC1,          0x90, 1); //Input Capture 1
   SBIT(PWM0_CH1_P11, 0x90, 1); //Pulse Width Modulator 0 Channel 1
   SBIT(IC0,          0x90, 2); //Input Capture 0
   SBIT(PWM0_CH0,     0x90, 2); //Pulse Width Modulator 0 Channel 0
   SBIT(SCL,          0x90, 3); //Serial Clock
   SBIT(STADC_P13,    0x90, 3); //Start Analog to Digital Conversion
   SBIT(PWM0_CH1_P14, 0x90, 4); //Pulse Width Modulator 0 Channel 1
   SBIT(PWM0_BRAKE,   0x90, 4); //Pulse Width Modulator 0 Brake
   SBIT(SDA,          0x90, 4); //Serial Data
   SBIT(IC7,          0x90, 5); //Input Capture 7
   SBIT(PWM0_CH5_P15, 0x90, 5); //Pulse Width Modulator 0 Channel 5
   SBIT(SS,           0x90, 5); //Slave Select
   SBIT(ICE_DAT,      0x90, 6); //In Circuit Emulator Data
   SBIT(SDA_P16,      0x90, 6); //Serial Data
   SBIT(TXD_1,        0x90, 6); //Transmit Data 1
   SBIT(ADC_CH0,      0x90, 7); //Analog Digital Converter Channel 0
   SBIT(ACH0,         0x90, 7); //ADC Channel 0
   SBIT(ADC0,         0x90, 7); //AtoD Channel 0
   SBIT(AIN0,         0x90, 7); //Analog Input 0
   SBIT(INT1,         0x90, 7); //Interrupt 1
   SBIT(P10,  0x90, 0); //Port 1 Bit 0
   SBIT(P11,  0x90, 1); //Port 1 Bit 1
   SBIT(P12,  0x90, 2); //Port 1 Bit 2
   SBIT(P13,  0x90, 3); //Port 1 Bit 3
   SBIT(P14,  0x90, 4); //Port 1 Bit 4
   SBIT(P15,  0x90, 5); //Port 1 Bit 5
   SBIT(P16,  0x90, 6); //Port 1 Bit 6
   SBIT(P17,  0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
SFR(SFRS, 0x91); //TA Protection
SFR(CAPCON0, 0x92);
SFR(CAPCON1, 0x93);
SFR(CAPCON2, 0x94);
SFR(CKDIV, 0x95);
SFR(CKSWT, 0x96); //TA Protection
SFR(CKEN, 0x97); //TA Protection
SFR(SCON, 0x98);
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //Serial Mode 0
   SBIT(FE,  0x98, 7); //Framing Error
SFR(SBUF, 0x99);
SFR(SBUF_1, 0x9A);
SFR(EIE, 0x9B);
SFR(EIE1, 0x9C);
SFR(CHPCON, 0x9F); //TA Protection
SFR(P2, 0xA0);
   SBIT(NRESET, 0xA0, 0); //Reset
   SBIT(RST,    0xA0, 0); //Reset
   SBIT(P20, 0xA0, 0); //Port 2 Bit 0
   SBIT(P2_0, 0xA0, 0); //Port 2 Bit 0
SFR(AUXR1, 0xA2);
SFR(BODCON0, 0xA3); //TA Protection
SFR(IAPTRG, 0xA4); //TA Protection
SFR(IAPUEN, 0xA5); //TA Protection
SFR(IAPAL, 0xA6);
SFR(IAPAH, 0xA7);
SFR(IE, 0xA8);
   SBIT(EX0,  0xA8, 0); //Enable External 0
   SBIT(ET0,  0xA8, 1); //Enable Timer 0
   SBIT(EX1,  0xA8, 2); //Enable External 1
   SBIT(ET1,  0xA8, 3); //Enable Timer 1
   SBIT(ES,   0xA8, 4); //Enable Serial
   SBIT(EBOD, 0xA8, 5); //Enable Brown Out Detection
   SBIT(EADC, 0xA8, 6); //Enable Analog Digital Converter
   SBIT(EA,   0xA8, 7); //Enable All
SFR(SADDR, 0xA9);
SFR(WDCON, 0xAA); //TA Protection
SFR(BODCON1, 0xAB); //TA Protection
SFR(P3M1, 0xAC);
SFR(P3S, 0xAC); //Page1
SFR(P3M2, 0xAD);
SFR(P3SR, 0xAD); //Page1
SFR(IAPFD, 0xAE);
SFR(IAPCN, 0xAF);
SFR(P3, 0xB0);
   SBIT(ADC_CH1, 0xB0, 0); //Analog Digital Converter Channel 1
   SBIT(ACH1,    0xB0, 0); //ADC Channel 1
   SBIT(ADC1,    0xB0, 0); //AtoD Channel 1
   SBIT(AIN1,    0xB0, 0); //Analog Input 1
   SBIT(INT0,    0xB0, 0); //Interrupt 0
   SBIT(OSCIN,   0xB0, 0); //Oscillator In
   SBIT(P30, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
SFR(P0M1, 0xB1);
SFR(P0S, 0xB1); //Page1
SFR(P0M2, 0xB2);
SFR(P0SR, 0xB2); //Page1
SFR(P1M1, 0xB3);
SFR(P1S, 0xB3); //Page1
SFR(P1M2, 0xB4);
SFR(P1SR, 0xB4); //Page1
SFR(P2S, 0xB5);
SFR(IPH, 0xB7);
SFR(PWMINTC, 0xB7); //Page1
SFR(IP, 0xB8);
   SBIT(PX0,  0xB8, 0); //Priority External 0
   SBIT(PT0,  0xB8, 1); //Priority Timer 0
   SBIT(PX1,  0xB8, 2); //Priority External 1
   SBIT(PT1,  0xB8, 3); //Priority Timer 1
   SBIT(PS,   0xB8, 4); //Priority Serial
   SBIT(PBOD, 0xB8, 5); //Priority Brown Out Detection
   SBIT(PADC, 0xB8, 6); //Priority Analog Digital Converter
SFR(SADEN, 0xB9);
SFR(SADEN_1, 0xBA);
SFR(SADDR_1, 0xBB);
SFR(I2DAT, 0xBC);
SFR(I2STAT, 0xBD);
SFR(I2CLK, 0xBE);
SFR(I2TOC, 0xBF);
SFR(I2CON, 0xC0);
   SBIT(I2CPX, 0xC0, 0); //Inter-Integrated Circuit Pin eXchange
   SBIT(AA,    0xC0, 2); //Acknowledge Assert
   SBIT(SI,    0xC0, 3); //Status Interrupt
   SBIT(STO,   0xC0, 4); //Stop
   SBIT(STA,   0xC0, 5); //Start
   SBIT(I2CEN, 0xC0, 6); //Inter-Integrated Circuit Enable
   SBIT(I,     0xC0, 7); //Increase
SFR(I2ADDR, 0xC1);
SFR(ADCRL, 0xC2);
SFR(ADCRH, 0xC3);
SFR(T3CON, 0xC4);
SFR(PWM4H, 0xC4); //Page1
SFR(RL3, 0xC5);
SFR(PWM5H, 0xC5); //Page1
SFR(RH3, 0xC6);
SFR(PIOCON1, 0xC6); //Page1
SFR(TA, 0xC7);
SFR(T2CON, 0xC8);
   SBIT(CM_RL2, 0xC8, 0); //Compare Reload 2
   SBIT(TR2,    0xC8, 2); //Timer 2 Run
   SBIT(TF2,    0xC8, 7); //Timer 2 Flag
SFR(T2MOD, 0xC9);
SFR(RCMP2L, 0xCA);
SFR(RCMP2H, 0xCB);
SFR(TL2, 0xCC);
SFR(PWM4L, 0xCC); //Page1
SFR(TH2, 0xCD);
SFR(PWM5L, 0xCD); //Page1
SFR(ADCMPL, 0xCE);
SFR(ADCMPH, 0xCF);
SFR(PSW, 0xD0);
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry
SFR(PWMPH, 0xD1);
SFR(PWM0H, 0xD2);
SFR(PWM1H, 0xD3);
SFR(PWM2H, 0xD4);
SFR(PWM3H, 0xD5);
SFR(PNP, 0xD6);
SFR(FBD, 0xD7);
SFR(PWMCON0, 0xD8);
   SBIT(CLRPWM, 0xD8, 4); //Clear Pulse Width Modulator
   SBIT(PWMF,   0xD8, 5); //Pusle Width Modulator Flan
   SBIT(LOAD,   0xD8, 6); //Load
   SBIT(PWMRUN, 0xD8, 7); //Pusle Width Modulator Run
SFR(PWMPL, 0xD9);
SFR(PWM0L, 0xDA);
SFR(PWM1L, 0xDB);
SFR(PWM2L, 0xDC);
SFR(PWM3L, 0xDD);
SFR(PIOCON0, 0xDE);
SFR(PWMCON1, 0xDF);
SFR(ACC, 0xE0);
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7
SFR(ADCCON1, 0xE1);
SFR(ADCCON2, 0xE2);
SFR(ADCDLY, 0xE3);
SFR(C0L, 0xE4);
SFR(C0H, 0xE5);
SFR(C1L, 0xE6);
SFR(C1H, 0xE7);
SFR(ADCCON0, 0xE8);
   SBIT(ADCHS0,  0xE8, 0); //Analog Digital Channel Select 0
   SBIT(ADCHS1,  0xE8, 1); //Analog Digital Channel Select 1
   SBIT(ADCHS2,  0xE8, 2); //Analog Digital Channel Select 2
   SBIT(ADCHS3,  0xE8, 3); //Analog Digital Channel Select 3
   SBIT(ETGSEL0, 0xE8, 4); //External Trigger Select 0
   SBIT(ETGSEL1, 0xE8, 5); //External Trigger Select 1
   SBIT(ADCS,    0xE8, 6); //Analog Digital Converter Start
   SBIT(ADCF,    0xE8, 7); //Analog Digital Converter Flag
SFR(PICON, 0xE9);
SFR(PINEN, 0xEA);
SFR(PIPEN, 0xEB);
SFR(PIF, 0xEC);
SFR(C2L, 0xED);
SFR(C2H, 0xEE);
SFR(EIP, 0xEF);
SFR(B, 0xF0);
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7
SFR(CAPCON3, 0xF1);
SFR(CAPCON4, 0xF2);
SFR(SPCR, 0xF3);
SFR(SPCR2, 0xF3); //Page1
SFR(SPSR, 0xF4);
SFR(SPDR, 0xF5);
SFR(AINDIDS, 0xF6);
SFR(EIPH, 0xF7);
SFR(SCON_1, 0xF8);
   SBIT(RI_1,  0xF8, 0); //Receive Interrupt UART-1
   SBIT(TI_1,  0xF8, 1); //Transmit Interrupt UART-1
   SBIT(RB8_1, 0xF8, 2); //Receive Bit 8 UART-1
   SBIT(TB8_1, 0xF8, 3); //Transmit Bit 8 UART-1
   SBIT(REN_1, 0xF8, 4); //Receive Enable UART-1
   SBIT(SM2_1, 0xF8, 5); //Serial Mode 2 UART-1
   SBIT(SM1_1, 0xF8, 6); //Serial Mode 1 UART-1
   SBIT(SM0_1, 0xF8, 7); //Serial Mode 0 UART-1
   SBIT(FE_1,  0xF8, 7); //Framing Error UART-1
SFR(PDTEN, 0xF9); //TA Protection
SFR(PDTCNT, 0xFA); //TA Protection
SFR(PMEN, 0xFB);
SFR(PMD, 0xFC);
SFR(EIP1, 0xFE);
SFR(EIPH1, 0xFF);

//Interrupt numbers: Address = ( Number * 8 ) + 3
//Vectors are named after their corresponding interrupt
//enable register bit, so that we don't have to make up
//names and can be consisten across different 8051 MCUs
   #define X0_VECTOR  0  // 0x03 External Interrupt 0
   #define T0_VECTOR  1  // 0x0B Timer 0
   #define X1_VECTOR  2  // 0x13 External Interrupt 1
   #define T1_VECTOR  3  // 0x1B Timer 1
   #define S_VECTOR   4  // 0x23 Serial Port 0
   #define T2_VECTOR  5  // 0x2B Timer 2
   #define I2C_VECTOR 6  // 0x33 Inter-Integrated Circuit
   #define PI_VECTOR  7  // 0x3B Pin Interrupt
   #define BOD_VECTOR 8  // 0x43 Brown-out
   #define SPI_VECTOR 9  // 0x4B Serial Peripheral Interface
   #define WDT_VECTOR 10 // 0x53 Watchdog timer
   #define ADC_VECTOR 11 // 0x5B Analog Digital Converter
   #define CAP_VECTOR 12 // 0x63 Input Capture
   #define PWM_VECTOR 13 // 0x6B Pulse Width Modulator
   #define FB_VECTOR  14 // 0x73 Fault Brake Event
   #define S1_VECTOR  15 // 0x7B Serial Port 1
   #define T3_VECTOR  16 // 0x83 Timer 3
   #define WKT_VECTOR 17 // 0x8B Self Wake-up Timer

#endif