// PlatformIO compatible header file MS51_32K.h 20210823.
// For Nuvoton MS51_32K series.

#ifndef MS51_32K_H
#define MS51_32K_H
#include <compiler.h>

/*  MS51_32K SFR BYTE page 0  */

SFR(P0, 0x80);
   SBIT(IC3_P00,      0x80, 0); //Input Capture 3
   SBIT(MOSI,         0x80, 0); //Master Out Slave In
   SBIT(OSCIN_10,     0x80, 0); //Oscillator In
   SBIT(PWM0_CH3,     0x80, 0); //Pulse Width Modulator 0 Channel 3
   SBIT(PWM2_CH1_10,  0x80, 0); //Pulse Width Modulator 2 Channel 1
   SBIT(RXD_1_11,     0x80, 0); //Receive Data 1
   SBIT(T1,           0x80, 0); //Timer 1
   SBIT(IC4,          0x80, 1); //Input Capture 4
   SBIT(MISO,         0x80, 1); //Master In Slave Out
   SBIT(PWM0_CH4,     0x80, 1); //Pulse Width Modulator 0 Channel 4
   SBIT(PWM3_CH0_10,  0x80, 1); //Pulse Width Modulator 3 Channel 0
   SBIT(ICE_CLK,      0x80, 2); //In Circuit Emulator Clock
   SBIT(RXD_1_01,     0x80, 2); //Receive Data 1
   SBIT(SCL_P02,      0x80, 2); //Serial Clock
   SBIT(ADC_CH6,      0x80, 3); //Analog Digital Converter Channel 6
   SBIT(ACH6,         0x80, 3); //ADC Channel 6
   SBIT(ADC6,         0x80, 3); //AtoD Channel 6
   SBIT(AIN6,         0x80, 3); //Analog Input 6
   SBIT(IC5,          0x80, 3); //Input Capture 5
   SBIT(PWM0_CH5_P03, 0x80, 3); //Pulse Width Modulator 0 Channel 5
   SBIT(PWM3_CH1_11,  0x80, 3); //Pulse Width Modulator 3 Channel 1
   SBIT(SC0_CLK_01,   0x80, 3); //Smart Card 0 Clock
   SBIT(TXD_2_01,     0x80, 3); //Transmit Data 2
   SBIT(ADC_CH5,      0x80, 4); //Analog Digital Converter Channel 5
   SBIT(ACH5,         0x80, 4); //ADC Channel 5
   SBIT(ADC5,         0x80, 4); //AtoD Channel 5
   SBIT(AIN5,         0x80, 4); //Analog Input 5
   SBIT(IC3_P04,      0x80, 4); //Input Capture 3
   SBIT(PWM0_CH3_P04, 0x80, 4); //Pulse Width Modulator 0 Channel 3
   SBIT(PWM2_CH1_11,  0x80, 4); //Pulse Width Modulator 2 Channel 1
   SBIT(RXD_2_01,     0x80, 4); //Receive Data 2
   SBIT(SC0_DAT_01,   0x80, 4); //Smart Card 0 Data
   SBIT(STADC,        0x80, 4); //Start Analog to Digital Conversion
   SBIT(ADC_CH4,      0x80, 5); //Analog Digital Converter Channel 4
   SBIT(ACH4,         0x80, 5); //ADC Channel 4
   SBIT(ADC4,         0x80, 5); //AtoD Channel 4
   SBIT(AIN4,         0x80, 5); //Analog Input 4
   SBIT(IC6,          0x80, 5); //Input Capture 6
   SBIT(PWM0_CH2_P05, 0x80, 5); //Pulse Width Modulator 0 Channel 2
   SBIT(PWM2_CH0_11,  0x80, 5); //Pulse Width Modulator 2 Channel 0
   SBIT(SC1_CLK_11,   0x80, 5); //Smart Card 1 Clock
   SBIT(T0,           0x80, 5); //Timer 0
   SBIT(TXD_3_11,     0x80, 5); //Transmit Data 3
   SBIT(ADC_CH3,      0x80, 6); //Analog Digital Converter Channel 3
   SBIT(ACH3,         0x80, 6); //ADC Channel 3
   SBIT(ADC3,         0x80, 6); //AtoD Channel 3
   SBIT(AIN3,         0x80, 6); //Analog Input 3
   SBIT(RXD_P06,      0x80, 6); //Receive Data
   SBIT(TXD,          0x80, 6); //Transmit Data
   SBIT(ADC_CH2,      0x80, 7); //Analog Digital Converter Channel 2
   SBIT(ACH2,         0x80, 7); //ADC Channel 2
   SBIT(ADC2,         0x80, 7); //AtoD Channel 2
   SBIT(AIN2,         0x80, 7); //Analog Input 2
   SBIT(RXD,          0x80, 7); //Receive Data
   SBIT(TXD_P07,      0x80, 7); //Transmit Data
   SBIT(P00, 0x80, 0); //Port 0 Bit 0
   SBIT(P01, 0x80, 1); //Port 0 Bit 1
   SBIT(P02, 0x80, 2); //Port 0 Bit 2
   SBIT(P03, 0x80, 3); //Port 0 Bit 3
   SBIT(P04, 0x80, 4); //Port 0 Bit 4
   SBIT(P05, 0x80, 5); //Port 0 Bit 5
   SBIT(P06, 0x80, 6); //Port 0 Bit 6
   SBIT(P07, 0x80, 7); //Port 0 Bit 7
   SBIT(P0_0, 0x80, 0); //Port 0 Bit 0
   SBIT(P0_1, 0x80, 1); //Port 0 Bit 1
   SBIT(P0_2, 0x80, 2); //Port 0 Bit 2
   SBIT(P0_3, 0x80, 3); //Port 0 Bit 3
   SBIT(P0_4, 0x80, 4); //Port 0 Bit 4
   SBIT(P0_5, 0x80, 5); //Port 0 Bit 5
   SBIT(P0_6, 0x80, 6); //Port 0 Bit 6
   SBIT(P0_7, 0x80, 7); //Port 0 Bit 7
SFR(SP, 0x81);
SFR(DPTR, 0x82);
SFR(DPL,  0x82);
SFR(DPH, 0x83);
SFR(RCTRIM0, 0x84);
SFR(RCTRIM1, 0x85);
SFR(RWKL, 0x86);
SFR(PCON, 0x87);
SFR(TCON, 0x88);
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag
SFR(TMOD, 0x89);
SFR(TL0, 0x8A);
SFR(TL1, 0x8B);
SFR(TH0, 0x8C);
SFR(TH1, 0x8D);
SFR(CKCON, 0x8E);
SFR(WKCON, 0x8F);
SFR(P1, 0x90);
   SBIT(IC2,            0x90, 0); //Input Capture 2
   SBIT(PWM0_CH2_P10,   0x90, 0); //Pulse Width Modulator 0 Channel 2
   SBIT(PWM2_CH0_10,    0x90, 0); //Pulse Width Modulator 2 Channel 0
   SBIT(SPCLK,          0x90, 0); //Serial Peripheral Clock
   SBIT(TXD_1_11,       0x90, 0); //Transmit Data 1
   SBIT(ADC_CH7,        0x90, 1); //Analog Digital Converter Channel 7
   SBIT(ACH7,           0x90, 1); //ADC Channel 7
   SBIT(ADC7,           0x90, 1); //AtoD Channel 7
   SBIT(AIN7,           0x90, 1); //Analog Input 7
   SBIT(CLKO,           0x90, 1); //Clock Out
   SBIT(IC1,            0x90, 1); //Input Capture 1
   SBIT(PWM0_CH1_P11,   0x90, 1); //Pulse Width Modulator 0 Channel 1
   SBIT(PWM1_CH1_11,    0x90, 1); //Pulse Width Modulator 1 Channel 1
   SBIT(RXD_3_01,       0x90, 1); //Receive Data 3
   SBIT(SC1_DAT_01,     0x90, 1); //Smart Card 1 Data
   SBIT(IC0,            0x90, 2); //Input Capture 0
   SBIT(PWM0_CH0,       0x90, 2); //Pulse Width Modulator 0 Channel 0
   SBIT(PWM1_CH0_10,    0x90, 2); //Pulse Width Modulator 1 Channel 0
   SBIT(SC1_CLK_01,     0x90, 2); //Smart Card 1 Clock
   SBIT(TXD_3_01,       0x90, 2); //Transmit Data 3
   SBIT(ADC_CH13,       0x90, 3); //Analog Digital Converter Channel 13
   SBIT(ACH13,          0x90, 3); //ADC Channel 13
   SBIT(ADC13,          0x90, 3); //AtoD Channel 13
   SBIT(AIN13,          0x90, 3); //Analog Input 13
   SBIT(SCL,            0x90, 3); //Serial Clock
   SBIT(STADC_P13,      0x90, 3); //Start Analog to Digital Conversion
   SBIT(ADC_CH14,       0x90, 4); //Analog Digital Converter Channel 14
   SBIT(ACH14,          0x90, 4); //ADC Channel 14
   SBIT(ADC14,          0x90, 4); //AtoD Channel 14
   SBIT(AIN14,          0x90, 4); //Analog Input 14
   SBIT(PWM0_BRAKE_P14, 0x90, 4); //Pulse Width Modulator 0 Brake
   SBIT(PWM0_CH1_P14,   0x90, 4); //Pulse Width Modulator 0 Channel 1
   SBIT(PWM1_CH1_10,    0x90, 4); //Pulse Width Modulator 1 Channel 1
   SBIT(SDA,            0x90, 4); //Serial Data
   SBIT(IC7,            0x90, 5); //Input Capture 7
   SBIT(PWM0_CH5_P15,   0x90, 5); //Pulse Width Modulator 0 Channel 5
   SBIT(PWM3_CH1_10,    0x90, 5); //Pulse Width Modulator 3 Channel 1
   SBIT(SC1_CLK_10,     0x90, 5); //Smart Card 1 Clock
   SBIT(SS,             0x90, 5); //Slave Select
   SBIT(TXD_3_10,       0x90, 5); //Transmit Data 3
   SBIT(ICE_DAT,        0x90, 6); //In Circuit Emulator Data
   SBIT(SDA_P16,        0x90, 6); //Serial Data
   SBIT(TXD_1_01,       0x90, 6); //Transmit Data 1
   SBIT(ADC_CH0,        0x90, 7); //Analog Digital Converter Channel 0
   SBIT(ACH0,           0x90, 7); //ADC Channel 0
   SBIT(ADC0,           0x90, 7); //AtoD Channel 0
   SBIT(AIN0,           0x90, 7); //Analog Input 0
   SBIT(INT1,           0x90, 7); //Interrupt 1
   SBIT(PWM3_CH0,       0x90, 7); //Pulse Width Modulator 3 Channel 0
   SBIT(RXD_2_10,       0x90, 7); //Receive Data 2
   SBIT(SC0_DAT_10,     0x90, 7); //Smart Card 0 Data
   SBIT(SPCLK_P17,      0x90, 7); //Serial Peripheral Clock
   SBIT(P10,  0x90, 0); //Port 1 Bit 0
   SBIT(P11,  0x90, 1); //Port 1 Bit 1
   SBIT(P12,  0x90, 2); //Port 1 Bit 2
   SBIT(P13,  0x90, 3); //Port 1 Bit 3
   SBIT(P14,  0x90, 4); //Port 1 Bit 4
   SBIT(P15,  0x90, 5); //Port 1 Bit 5
   SBIT(P16,  0x90, 6); //Port 1 Bit 6
   SBIT(P17,  0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
SFR(SFRS, 0x91);
SFR(CAPCON0, 0x92);
SFR(CAPCON1, 0x93);
SFR(CAPCON2, 0x94);
SFR(CKDIV, 0x95);
SFR(CKSWT, 0x96);
SFR(CKEN, 0x97);
SFR(SCON, 0x98);
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //Serial Mode 0
   SBIT(FE,  0x98, 7); //Framing Error
SFR(SBUF, 0x99);
SFR(SBUF_1, 0x9A);
SFR(EIE, 0x9B);
SFR(EIE1, 0x9C);
SFR(CHPCON, 0x9F);
SFR(P2, 0xA0);
   SBIT(NRESET,      0xA0, 0); //Reset
   SBIT(RST,         0xA0, 0); //Reset
   SBIT(ADC_CH9,     0xA0, 1); //Analog Digital Converter Channel 9
   SBIT(ACH9,        0xA0, 1); //ADC Channel 9
   SBIT(ADC9,        0xA0, 1); //AtoD Channel 9
   SBIT(AIN9,        0xA0, 1); //Analog Input 9
   SBIT(PWM2_CH0_01, 0xA0, 1); //Pulse Width Modulator 2 Channel 0
   SBIT(ADC_CH10,    0xA0, 2); //Analog Digital Converter Channel 10
   SBIT(ACH10,       0xA0, 2); //ADC Channel 10
   SBIT(ADC10,       0xA0, 2); //AtoD Channel 10
   SBIT(AIN10,       0xA0, 2); //Analog Input 10
   SBIT(PWM1_CH1_01, 0xA0, 2); //Pulse Width Modulator 1 Channel 1
   SBIT(RXD_4_01,    0xA0, 2); //Receive Data UART-4
   SBIT(SC2_DAT_01,  0xA0, 2); //Smart Card 2 Data
   SBIT(ADC_CH11,    0xA0, 2); //Analog Digital Converter Channel 11
   SBIT(ACH11,       0xA0, 2); //ADC Channel 11
   SBIT(ADC11,       0xA0, 2); //AtoD Channel 11
   SBIT(AIN11,       0xA0, 2); //Analog Input 11
   SBIT(PWM1_CH0_01, 0xA0, 3); //Pulse Width Modulator 1 Channel 0
   SBIT(SC2_CLK_01,  0xA0, 3); //Smart Card 2 Clock
   SBIT(TXD_4_01,    0xA0, 3); //Transmit Data UART-4
   SBIT(ADC_CH12,    0xA0, 3); //Analog Digital Converter Channel 12
   SBIT(ACH12,       0xA0, 3); //ADC Channel 12
   SBIT(ADC12,       0xA0, 3); //AtoD Channel 12
   SBIT(AIN12,       0xA0, 3); //Analog Input 12
   SBIT(T0_P24,      0xA0, 4); //Timer 0
   SBIT(ADC_CH15,    0xA0, 5); //Analog Digital Converter Channel 15
   SBIT(ACH15,       0xA0, 5); //ADC Channel 15
   SBIT(ADC15,       0xA0, 5); //AtoD Channel 15
   SBIT(AIN15,       0xA0, 5); //Analog Input 15
   SBIT(MISO_P25,    0xA0, 5); //Master In Slave Out
   SBIT(RXD_3_10,    0xA0, 5); //Receive Data UART-3
   SBIT(SC1_DAT_10,  0xA0, 5); //Smart Card 1 Data
   SBIT(P20,  0xA0, 0); //Port 0 Bit 0
   SBIT(P21,  0xA0, 1); //Port 2 Bit 1
   SBIT(P22,  0xA0, 2); //Port 2 Bit 2
   SBIT(P23,  0xA0, 3); //Port 2 Bit 3
   SBIT(P24,  0xA0, 4); //Port 2 Bit 4
   SBIT(P25,  0xA0, 5); //Port 2 Bit 5
   SBIT(P2_0, 0xA0, 0); //Port 2 Bit 0
   SBIT(P2_1, 0xA0, 1); //Port 2 Bit 1
   SBIT(P2_2, 0xA0, 2); //Port 2 Bit 2
   SBIT(P2_3, 0xA0, 3); //Port 2 Bit 3
   SBIT(P2_4, 0xA0, 4); //Port 2 Bit 4
   SBIT(P2_5, 0xA0, 5); //Port 2 Bit 5
SFR(AUXR1, 0xA2);
SFR(BODCON0, 0xA3);
SFR(IAPTRG, 0xA4);
SFR(IAPUEN, 0xA5);
SFR(IAPAL, 0xA6);
SFR(IAPAH, 0xA7);
SFR(IE, 0xA8);
   SBIT(EX0,  0xA8, 0); //Enable External 0
   SBIT(ET0,  0xA8, 1); //Enable Timer 0
   SBIT(EX1,  0xA8, 2); //Enable External 1
   SBIT(ET1,  0xA8, 3); //Enable Timer 1
   SBIT(ES,   0xA8, 4); //Enable Serial
   SBIT(EBOD, 0xA8, 5); //Enable Brown Out Detection
   SBIT(EADC, 0xA8, 6); //Enable Analog Digital Converter
   SBIT(EA,   0xA8, 7); //Enable All
SFR(SADDR, 0xA9);
SFR(WDCON, 0xAA);
SFR(BODCON1, 0xAB);
SFR(P3M1, 0xAC);
SFR(P3M2, 0xAD);
SFR(IAPFD, 0xAE);
SFR(IAPCN, 0xAF);
SFR(P3, 0xB0);
   SBIT(ADC_CH1,        0xB0, 0); //Analog Digital Converter Channel 1
   SBIT(ACH1,           0xB0, 0); //ADC Channel 1
   SBIT(ADC1,           0xB0, 0); //AtoD Channel 1
   SBIT(AIN1,           0xB0, 0); //Analog Input 1
   SBIT(INT0,           0xB0, 0); //Interrupt 0
   SBIT(MOSI_P30,       0xB0, 0); //Master In Slave Out
   SBIT(PWM2_CH1,       0xB0, 0); //Pulse Width Modulator 2 Channel 1
   SBIT(SC0_CLK_10,     0xB0, 0); //Smart Card 0 Clock
   SBIT(TXD_2_10,       0xB0, 0); //Transmit Data UART-2
   SBIT(OSCIN_11,       0xB0, 0); //Oscillator In
   SBIT(PWM2_CH1_01,    0xB0, 1); //Pulse Width Modulator 2 Channel 1
   SBIT(PWM3_CH0_01,    0xB0, 2); //Pulse Width Modulator 3 Channel 0
   SBIT(PWM0_BRAKE_P33, 0xB0, 3); //Pulse Width Modulator 0 Brake
   SBIT(CLO_P33,        0xB0, 3); //Clock Out
   SBIT(PWM3_CH1_01,    0xB0, 4); //Pulse Width Modulator 3 Channel 1
   SBIT(RXD_3_11,       0xB0, 4); //Receive Data UART-3
   SBIT(SC1_DAT_11,     0xB0, 4); //Smart Card 1 Data
   SBIT(SS_P_35,        0xB0, 5); //Slave Select
   SBIT(TXD_1_10,       0xB0, 6); //Transmit Data UART-1
   SBIT(RXD_1_10,       0xB0, 7); //Receive Data UART-1
   SBIT(P30,  0xB0, 0); //Port 3 Bit 0
   SBIT(P31,  0xB0, 1); //Port 3 Bit 1
   SBIT(P32,  0xB0, 2); //Port 3 Bit 2
   SBIT(P33,  0xB0, 3); //Port 3 Bit 3
   SBIT(P34,  0xB0, 4); //Port 3 Bit 4
   SBIT(P35,  0xB0, 5); //Port 3 Bit 5
   SBIT(P36,  0xB0, 6); //Port 3 Bit 6
   SBIT(P37,  0xB0, 7); //Port 3 Bit 7
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_1, 0xB0, 1); //Port 3 Bit 1
   SBIT(P3_2, 0xB0, 2); //Port 3 Bit 2
   SBIT(P3_3, 0xB0, 3); //Port 3 Bit 3
   SBIT(P3_4, 0xB0, 4); //Port 3 Bit 4
   SBIT(P3_5, 0xB0, 5); //Port 3 Bit 5
   SBIT(P3_6, 0xB0, 6); //Port 3 Bit 6
   SBIT(P3_7, 0xB0, 7); //Port 3 Bit 7
SFR(P0M1, 0xB1);
SFR(P0M2, 0xB2);
SFR(P1M1, 0xB3);
SFR(P1M2, 0xB4);
SFR(TOE, 0xB5);
SFR(IPH, 0xB7);
SFR(IP, 0xB8);
   SBIT(PX0,  0xB8, 0); //Priority External 0
   SBIT(PT0,  0xB8, 1); //Priority Timer 0
   SBIT(PX1,  0xB8, 2); //Priority External 1
   SBIT(PT1,  0xB8, 3); //Priority Timer 1
   SBIT(PS,   0xB8, 4); //Priority Serial
   SBIT(PBOD, 0xB8, 5); //Priority Brown Out Detection
   SBIT(PADC, 0xB8, 6); //Priority Analog Digital Converter
SFR(SADEN, 0xB9);
SFR(SADEN_1, 0xBA);
SFR(SADDR_1, 0xBB);
SFR(I2DAT, 0xBC);
SFR(I2STAT, 0xBD);
SFR(I2CLK, 0xBE);
SFR(I2TOC, 0xBF);
SFR(I2CON, 0xC0);
   SBIT(I2CPX, 0xC0, 0); //Inter-Integrated Circuit Pin eXchange
   SBIT(AA,    0xC0, 2); //Acknowledge Assert
   SBIT(SI,    0xC0, 3); //Status Interrupt
   SBIT(STO,   0xC0, 4); //Stop
   SBIT(STA,   0xC0, 5); //Start
   SBIT(I2CEN, 0xC0, 6); //Inter-Integrated Circuit Enable
   SBIT(I,     0xC0, 7); //Increase
SFR(I2ADDR, 0xC1);
SFR(ADCRL, 0xC2);
SFR(ADCRH, 0xC3);
SFR(T3CON, 0xC4);
SFR(RL3, 0xC5);
SFR(RH3, 0xC6);
SFR(TA, 0xC7);
SFR(T2CON, 0xC8);
   SBIT(CM_RL2, 0xC8, 0); //Compare Reload 2
   SBIT(TR2,    0xC8, 2); //Timer 2 Run
   SBIT(TF2,    0xC8, 7); //Timer 2 Flag
SFR(T2MOD, 0xC9);
SFR(RCMP2L, 0xCA);
SFR(RCMP2H, 0xCB);
SFR(TL2, 0xCC);
SFR(TH2, 0xCD);
SFR(ADCMPL, 0xCE);
SFR(ADCMPH, 0xCF);
SFR(PSW, 0xD0);
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry
SFR(PWM0PH, 0xD1);
SFR(PWM0C0H, 0xD2);
SFR(PWM0C1H, 0xD3);
SFR(PWM0C2H, 0xD4);
SFR(PWM0C3H, 0xD5);
SFR(PNP, 0xD6);
SFR(PWM0FBD, 0xD7);
SFR(PWM0CON0, 0xD8);
   SBIT(CLRPWM, 0xD8, 4); //Clear Pulse Width Modulator
   SBIT(PWMF,   0xD8, 5); //Pusle Width Modulator Flan
   SBIT(LOAD,   0xD8, 6); //Load
   SBIT(PWMRUN, 0xD8, 7); //Pusle Width Modulator Run
SFR(PWM0PL, 0xD9);
SFR(PWM0C0L, 0xDA);
SFR(PWM0C1L, 0xDB);
SFR(PWM0C2L, 0xDC);
SFR(PWM0C3L, 0xDD);
SFR(PIOCON0, 0xDE);
SFR(PWM0CON1, 0xDF);
SFR(ACC, 0xE0);
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7
SFR(ADCCON1, 0xE1);
SFR(ADCCON2, 0xE2);
SFR(ADCDLY, 0xE3);
SFR(C0L, 0xE4);
SFR(C0H, 0xE5);
SFR(C1L, 0xE6);
SFR(C1H, 0xE7);
SFR(ADCCON0, 0xE8);
   SBIT(ADCHS0,  0xE8, 0); //Analog Digital Channel Select 0
   SBIT(ADCHS1,  0xE8, 1); //Analog Digital Channel Select 1
   SBIT(ADCHS2,  0xE8, 2); //Analog Digital Channel Select 2
   SBIT(ADCHS3,  0xE8, 3); //Analog Digital Channel Select 3
   SBIT(ETGSEL0, 0xE8, 4); //External Trigger Select 0
   SBIT(ETGSEL1, 0xE8, 5); //External Trigger Select 1
   SBIT(ADCS,    0xE8, 6); //Analog Digital Converter Start
   SBIT(ADCF,    0xE8, 7); //Analog Digital Converter Flag
SFR(PICON, 0xE9);
SFR(PINEN, 0xEA);
SFR(PIPEN, 0xEB);
SFR(PIF, 0xEC);
SFR(C2L, 0xED);
SFR(C2H, 0xEE);
SFR(EIP, 0xEF);
SFR(B, 0xF0);
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7
SFR(CAPCON3, 0xF1);
SFR(CAPCON4, 0xF2);
SFR(SPCR, 0xF3);
SFR(SPSR, 0xF4);
SFR(SPDR, 0xF5);
SFR(AINDIDS0, 0xF6);
SFR(EIPH, 0xF7);
SFR(SCON_1, 0xF8);
   SBIT(RI_1,  0xF8, 0); //Receive Interrupt UART-1
   SBIT(TI_1,  0xF8, 1); //Transmit Interrupt UART-1
   SBIT(RB8_1, 0xF8, 2); //Receive Bit 8 UART-1
   SBIT(TB8_1, 0xF8, 3); //Transmit Bit 8 UART-1
   SBIT(REN_1, 0xF8, 4); //Receive Enable UART-1
   SBIT(SM2_1, 0xF8, 5); //Serial Mode 2 UART-1
   SBIT(SM1_1, 0xF8, 6); //Serial Mode 1 UART-1
   SBIT(SM0_1, 0xF8, 7); //Serial Mode 0 UART-1
   SBIT(FE_1,  0xF8, 7); //Framing Error UART-1
SFR(PWM0DTEN, 0xF9);
SFR(PWM0DTCNT, 0xFA);
SFR(PWM0MEN, 0xFB);
SFR(PWM0MD, 0xFC);
SFR(PORDIS, 0xFD);
SFR(EIP1, 0xFE);
SFR(EIPH1, 0xFF);

/*  MS51_32K SFR BYTE page 1  */

SFR(P3S, 0xAC);
SFR(P3SR, 0xAD);

SFR(P0S, 0xB1);
SFR(P0SR, 0xB2);
SFR(P1S, 0xB3);
SFR(P1SR, 0xB4);
SFR(PWM0INTC, 0xB7);

SFR(PWM0C4H, 0xC4);
SFR(PWM0C5H, 0xC5);
SFR(PIOCON1, 0xC6);
SFR(PWM0C4L, 0xCC);
SFR(PWM0C5L, 0xCD);

SFR(SPCR2, 0xF3);

SFR(LVRDIS, 0xFF);

/*  MS51_32K SFR BYTE page 2  */

SFR(ADCBAL, 0x84);
SFR(ADCBAH, 0x85);
SFR(ADCCON3, 0x86);
SFR(P2M1, 0x89);
SFR(P2M2, 0x8A);
SFR(P2SR, 0x8B);
SFR(P2S, 0x8C);
SFR(ADCSN, 0x8D);
SFR(ADCCN, 0x8E);
SFR(ADCSR, 0x8F);

SFR(P0UP, 0x92);
SFR(P1UP, 0x93);
SFR(P2UP, 0x94);
SFR(P3UP, 0x95);
SFR(RWKH, 0x97);
SFR(AINDIDS1, 0x99);
SFR(P0DW, 0x9A);
SFR(P1DW, 0x9B);
SFR(P2DW, 0x9C);
SFR(P3DW, 0x9D);

SFR(AUXR2, 0xA1);
SFR(AUXR3, 0xA2);
SFR(AUXR4, 0xA3);
SFR(AUXR5, 0xA4);
SFR(AUXR6, 0xA5);
SFR(AUXR7, 0xA6);
SFR(AUXR8, 0xA7);
SFR(PWM1PH, 0xA9);
SFR(PWM1C0H, 0xAA);
SFR(PWM1C1H, 0xAB);
SFR(PWM1MD, 0xAC);
SFR(PWM1MEN, 0xAD);

SFR(PWM1PL, 0xB1);
SFR(PWM1C0L, 0xB2);
SFR(PWM1C1L, 0xB3);
SFR(PWM1CON0, 0xB4);
SFR(PWM1CON1, 0xB5);
SFR(PWM1INTC, 0xB6);
SFR(PIOCON2, 0xB7);
SFR(PWM2PH, 0xB9);
SFR(PWM2C0H, 0xBA);
SFR(PWM2C1H, 0xBB);
SFR(PWM2MD, 0xBC);
SFR(PWM2MEN, 0xBD);

SFR(PWM2PL, 0xC1);
SFR(PWM2C0L, 0xC2);
SFR(PWM2C1L, 0xC3);
SFR(PWM2CON0, 0xC4);
SFR(PWM2CON1, 0xC5);
SFR(PWM2INTC, 0xC6);
SFR(PWM3PH, 0xC9);
SFR(PWM3C0H, 0xCA);
SFR(PWM3C1H, 0xCB);
SFR(PWM3MD, 0xCC);
SFR(PWM3MEN, 0xCD);
SFR(EIP2, 0xCE);
SFR(EIPH2, 0xCF);

SFR(PWM3PL, 0xD1);
SFR(PWM3C0L, 0xD2);
SFR(PWM3C1L, 0xD3);
SFR(PWM3CON0, 0xD4);
SFR(PWM3CON1, 0xD5);
SFR(PWM3INTC, 0xD6);
SFR(XTLCON, 0xD7);
SFR(SC0DR, 0xD9);
SFR(SC0EGT, 0xDA);
SFR(SC0ETURD0, 0xDB);
SFR(SC0ETURD1, 0xDC);
SFR(SC0IE, 0xDD);
SFR(SC0IS, 0xDE);
SFR(SC0TSR, 0xDF);

SFR(SC1DR, 0xE1);
SFR(SC1EGT, 0xE2);
SFR(SC1ETURD0, 0xE3);
SFR(SC1ETURD1, 0xE4);
SFR(SC1IE, 0xE5);
SFR(SC1IS, 0xE6);
SFR(SC1TSR, 0xE7);
SFR(SC2DR, 0xE9);
SFR(SC2EGT, 0xEA);
SFR(SC2ETURD0, 0xEB);
SFR(SC2ETURD1, 0xEC);
SFR(SC2IE, 0xED);
SFR(SC2IS, 0xEE);
SFR(SC2TSR, 0xEF);

SFR(SC0CR0, 0xF1);
SFR(SC0CR1, 0xF2);
SFR(SC1CR0, 0xF3);
SFR(SC1CR1, 0xF4);
SFR(SC2CR0, 0xF5);
SFR(SC2CR1, 0xF6);
SFR(PIPS7, 0xF7);
SFR(PIPS0, 0xF9);
SFR(PIPS1, 0xFA);
SFR(PIPS2, 0xFB);
SFR(PIPS3, 0xFC);
SFR(PIPS4, 0xFD);
SFR(PIPS5, 0xFE);
SFR(PIPS6, 0xFF);

//Interrupt numbers: Address = ( Number * 8 ) + 3
//Vectors are named after their corresponding interrupt
//enable register bit, so that we don't have to make up
//names and can be consisten across different 8051 MCUs
   #define X0_VECTOR   0  // 0x03 External Interrupt 0
   #define T0_VECTOR   1  // 0x0B Timer 0
   #define X1_VECTOR   2  // 0x13 External Interrupt 1
   #define T1_VECTOR   3  // 0x1B Timer 1
   #define S_VECTOR    4  // 0x23 Serial Port 0
   #define T2_VECTOR   5  // 0x2B Timer 2
   #define I2C_VECTOR  6  // 0x33 Inter-Integrated Circuit
   #define PI_VECTOR   7  // 0x3B Pin Interrupt
   #define BOD_VECTOR  8  // 0x43 Brown-out
   #define SPI_VECTOR  9  // 0x4B Serial Peripheral Interface
   #define WDT_VECTOR  10 // 0x53 Watchdog timer
   #define ADC_VECTOR  11 // 0x5B Analog Digital Converter
   #define CAP_VECTOR  12 // 0x63 Input Capture
   #define PWM0_VECTOR 13 // 0x6B Pulse Width Modulator 0
   #define FB_VECTOR   14 // 0x73 Fault Brake Event
   #define S1_VECTOR   15 // 0x7B Serial Port 1
   #define T3_VECTOR   16 // 0x83 Timer 3
   #define WKT_VECTOR  17 // 0x8B Self Wake-up Timer
   #define PWM1_VECTOR 18 // 0x93 Pulse Width Modulator 1
   #define PWM2_VECTOR 19 // 0x9B Pulse Width Modulator 2
   #define PWM3_VECTOR 20 // 0xA3 Pulse Width Modulator 3
   #define SC0_VECTOR  21 // 0xAB Smart Card 0
   #define SC1_VECTOR  22 // 0xB3 Smart Card 1
   #define SC2_VECTOR  23 // 0xBB Smart Card 2

#endif