// PlatformIO compatible header file N76E003.h 20210823.
// For Nuvoton N76E003.

#ifndef N76E003_H
#define N76E003_H
#include <compiler.h>

//SFR DEFINITION | NOTE | POR RESET VALUE  |  DESCRIPTION

SFR(P0, 0x80); //               1111'1111|XXXX'XXXX Port 0
   SBIT(IC3_P00,  0x80, 0); //Input Capture 3
   SBIT(MOSI,     0x80, 0); //Master Out Slave In
   SBIT(PWM3_P00, 0x80, 0); //Pulse Width Modulator 3
   SBIT(T1,       0x80, 0); //Timer 1
   SBIT(IC4,      0x80, 1); //Input Capture 4
   SBIT(MISO,     0x80, 1); //Master In Slave Out
   SBIT(PWM4,     0x80, 1); //Pulse Width Modulator 4
   SBIT(ICPCK,    0x80, 2); //In Circuit Programming Clock
   SBIT(OCDCK,    0x80, 2); //On Chip Debugging Clock
   SBIT(RXD_1,    0x80, 2); //Receive Data 1
   SBIT(SCL_P02,  0x80, 2); //Serial Clock
   SBIT(ACH6,     0x80, 3); //ADC Channel 6
   SBIT(ADC6,     0x80, 3); //AtoD Channel 6
   SBIT(AIN6,     0x80, 3); //Analog In 6
   SBIT(IC5,      0x80, 3); //Input Capture 5
   SBIT(PWM5_P03, 0x80, 3); //Pulse Width Modulator 5
   SBIT(ACH5,     0x80, 4); //ADC Channel 5
   SBIT(ADC5,     0x80, 4); //AtoD Channel 5
   SBIT(AIN5,     0x80, 4); //Analog In 5
   SBIT(IC3_P04,  0x80, 4); //Input Capture 3
   SBIT(PWM3_P04, 0x80, 4); //Pulse Width Modulator 3
   SBIT(STADC,    0x80, 4); //Start Analog Digital Conversion
   SBIT(ACH4,     0x80, 5); //ADC Channel 4
   SBIT(ADC4,     0x80, 5); //AtoD Channel 4
   SBIT(AIN4,     0x80, 5); //Analog In 4
   SBIT(IC6,      0x80, 5); //Input Capture 6
   SBIT(PWM2_P05, 0x80, 5); //Pulse Width Modulator 2
   SBIT(T0,       0x80, 5); //Timer 0
   SBIT(ACH3,     0x80, 6); //ADC Channel 3
   SBIT(ADC3,     0x80, 6); //AtoD Channel 3
   SBIT(AIN3,     0x80, 6); //Analog In 3
   SBIT(RXD_P06,  0x80, 6); //Receive Data
   SBIT(TXD,      0x80, 6); //Transmit Data
   SBIT(ACH2,     0x80, 7); //ADC Channel 2
   SBIT(ADC2,     0x80, 7); //AtoD Channel 2
   SBIT(AIN2,     0x80, 7); //Analog In 2
   SBIT(RXD,      0x80, 7); //Receive Data
   SBIT(TXD_P07,  0x80, 7); //Transmit Data
   SBIT(P00, 0x80, 0); //Port 0 Bit 0
   SBIT(P01, 0x80, 1); //Port 0 Bit 1
   SBIT(P02, 0x80, 2); //Port 0 Bit 2
   SBIT(P03, 0x80, 3); //Port 0 Bit 3
   SBIT(P04, 0x80, 4); //Port 0 Bit 4
   SBIT(P05, 0x80, 5); //Port 0 Bit 5
   SBIT(P06, 0x80, 6); //Port 0 Bit 6
   SBIT(P07, 0x80, 7); //Port 0 Bit 7
   SBIT(P0_0, 0x80, 0); //Port 0 Bit 0
   SBIT(P0_1, 0x80, 1); //Port 0 Bit 1
   SBIT(P0_2, 0x80, 2); //Port 0 Bit 2
   SBIT(P0_3, 0x80, 3); //Port 0 Bit 3
   SBIT(P0_4, 0x80, 4); //Port 0 Bit 4
   SBIT(P0_5, 0x80, 5); //Port 0 Bit 5
   SBIT(P0_6, 0x80, 6); //Port 0 Bit 6
   SBIT(P0_7, 0x80, 7); //Port 0 Bit 7
SFR(SP, 0x81); //               0000'0111 Stack Pointer
SFR(DPTR, 0x82); //             0000'0000 Data Pointer Word
SFR(DPL,  0x82); //             0000'0000 Data Pointer Low byte
SFR(DPH, 0x83); //              0000'0000 Data Pointer High byte
SFR(RCTRIM0, 0x84); //          0000'0000 Internal RC trim value high byte
SFR(RCTRIM1, 0x85); //          0000'0000 Internal RC trim value low byte
SFR(RWK, 0x86); //              0000'0000 Wake-up Timer Reload byte
SFR(PCON, 0x87); //             0001'0000|000U'0000 Power Control
   #define IDL   0x01 //Idle
   #define PD    0x02 //Power Down
   #define STOP  0x02 //Stop
   #define GF0   0x04 //General Flag 0
   #define GF1   0x08 //General Flag 1
   #define POF   0x10 //Power On Flag
   #define SMOD0 0x40 //Serial Mode 0
   #define SMOD  0x80 //Serial Mode
SFR(TCON, 0x88); //             0000'0000 Timer Control
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag
SFR(TMOD, 0x89); //             0000'0000 Timer Mode control
   #define T0_M0   0x01 //Timer 0 Mode 0
   #define T0_M1   0x02 //Timer 0 Mode 1
   #define T0_M    0x03 //Timer 0 Mode
   #define T0_CT   0x04 //Timer 0 Counter Timer
   #define T0_GATE 0x08 //Timer 0 Gate
   #define T1_M0   0x10 //Timer 1 Mode 0
   #define T1_M1   0x20 //Timer 1 Mode 1
   #define T1_M    0x30 //Timer 1 Mode
   #define T1_CT   0x40 //Timer 1 Counter Timer
   #define T1_GATE 0x80 //Timer 1 Gate
   #define M00   0x01 //Mode 0 Timer 0
   #define M10   0x02 //Mode 1 Timer 0
   #define M0    0x03 //Timer 0 Mode
   #define CT0   0x04 //Counter Timer 0
   #define GATE0 0x08 //Gate 0
   #define M01   0x10 //Mode 1 Timer 1
   #define M11   0x20 //Mode 1 Timer 1
   #define M1    0x30 //Timer 1 Mode
   #define CT1   0x40 //Counter Timer 1
   #define GATE1 0x80 //Gate 1
SFR(TL0, 0x8A); //              0000'0000 Timer 0 Low byte
SFR(TL1, 0x8B); //              0000'0000 Timer 1 Low byte
SFR(TH0, 0x8C); //              0000'0000 Timer 0 High byte
SFR(TH1, 0x8D); //              0000'0000 Timer 1 High byte
SFR(CKCON, 0x8E); //            0000'0000 Clock Control
   #define CLOEN  0x02
   #define T0M    0x08 //Timer 0 Mode
   #define T1M    0x10 //Timer 1 Mode
   #define PWMCKS 0x40 //Pulse Width Modulator Clock Source
SFR(WKCON, 0x8F); //            0000'0000 Self wake-up timer control
   #define WKPS 0x07 //Wake-up Timer Prescaler
   #define WKTR 0x08 //Wake-up Timer Run
   #define WKTF 0x10 //Wake-up Timer Flag
SFR(P1, 0x90); //               1111'1111|XXXX'XXXX Port 1
   SBIT(IC2,       0x90, 0); //Input Capture 2
   SBIT(PWM2_P10,  0x90, 0); //Pulse Width Modulator 2
   SBIT(SPCLK,     0x90, 0); //Serial Peripheral Clock
   SBIT(ACH7,      0x90, 1); //ADC Channel 7
   SBIT(ADC7,      0x90, 1); //AtoD Channel 7
   SBIT(AIN7,      0x90, 1); //Analog In 7
   SBIT(CLO,       0x90, 1); //Clock Out
   SBIT(IC1,       0x90, 1); //Input Capture 1
   SBIT(PWM1_P11,  0x90, 1); //Pulse Width Modulator 1
   SBIT(IC0,       0x90, 2); //Input Capture 0
   SBIT(PWM0,      0x90, 2); //Pulse Width Modulator 0
   SBIT(SCL,       0x90, 3); //Serial Clock
   SBIT(STADC_P13, 0x90, 3); //Start Analog Digital Conversion
   SBIT(FB,        0x90, 4); //Fault Brake
   SBIT(PWM1_P14,  0x90, 4); //Pulse Width Modulator 1
   SBIT(SDA,       0x90, 4); //Serial Data
   SBIT(IC7,       0x90, 5); //Input Capture 7
   SBIT(PWM5_P15,  0x90, 5); //Pulse Width Modulator 5
   SBIT(SS,        0x90, 5); //Slave Select
   SBIT(ICPDA,     0x90, 6); //In Circuit Programming Data
   SBIT(OCDDA,     0x90, 6); //On Chip Debugger Data
   SBIT(SDA_P16,   0x90, 6); //Serial Data
   SBIT(TXD_1,     0x90, 6); //Transmit Data 1
   SBIT(ACH0,      0x90, 7); //ADC Channel 0
   SBIT(ADC0,      0x90, 7); //AtoD Channel 0
   SBIT(AIN0,      0x90, 7); //Analog In 0
   SBIT(INT1,      0x90, 7); //Interrupt 1
   SBIT(P10, 0x90, 0); //Port 1 Bit 0
   SBIT(P11, 0x90, 1); //Port 1 Bit 1
   SBIT(P12, 0x90, 2); //Port 1 Bit 2
   SBIT(P13, 0x90, 3); //Port 1 Bit 3
   SBIT(P14, 0x90, 4); //Port 1 Bit 4
   SBIT(P15, 0x90, 5); //Port 1 Bit 5
   SBIT(P16, 0x90, 6); //Port 1 Bit 6
   SBIT(P17, 0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
SFR(SFRS, 0x91); //TA           0000'0000 SFR Page Selection
   #define SFRPSEL 0x01 //SFR Page Select
   #define SFRPAGE 0x01 //SFR Page
SFR(CAPCON0, 0x92); //          0000'0000 Input Capture Control 0
   #define CAPF0  0x01 //Input Capture Flag 0
   #define CAPF1  0x02 //Input Capture Flag 1
   #define CAPF2  0x04 //Input Capture Flag 2
   #define CAPEN0 0x10 //Input Capture 0 Enable
   #define CAPEN1 0x20 //Input Capture 1 Enable
   #define CAPEN2 0x40 //Input Capture 2 Enable
SFR(CAPCON1, 0x93); //          0000'0000 Input Capture Control 1
   #define CAP0LS 0x03 //Input Capture 0 Level Select
   #define CAP1LS 0x0C //Input Capture 1 Level Select
   #define CAP2LS 0x30 //Input Capture 2 Level Select
SFR(CAPCON2, 0x94); //          0000'0000 Input Capture Control 2
   #define ENF0 0x10 //Enable Noise Filer on Input Capture 0
   #define ENF1 0x20 //Enable Noise Filer on Input Capture 1
   #define ENF2 0x40 //Enable Noise Filer on Input Capture 2
SFR(CKDIV, 0x95); //            0000'0000 Clock Divider
SFR(CKSWT, 0x96); //TA          0011'0000 Clock Switch
   #define OSC    0x06 //Oscillator Selection Bits
   #define ECLKST 0x08 //External Clock Input Status
   #define LIRCST 0x10 //Low-speed Internal Resistor Capacitor Oscillator Status
   #define HIRCST 0x20 //High-speed Internal Resistor Capacitor Oscillator Status
SFR(CKEN, 0x97); //TA           0011'0000 Clock Enable
   #define CKSWTF 0x01 //Clock Switch Fault Flag
   #define HIRCEN 0x20 //High-speed Internal Oscillator Enable
   #define EXTEN  0xC0 //External Clock Source Enable
SFR(SCON, 0x98); //             0000'0000 Serial Port 0 Control
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //(WR)Serial Mode 0
   SBIT(FE,  0x98, 7); //(RD)Framing Error
SFR(SBUF, 0x99); //             0000'0000 Serial port 0 data Buffer
SFR(SBUF_1, 0x9A); //           0000'0000 Serial port 1 data Buffer
SFR(EIE, 0x9B); //              0000'0000 Extensive Interrupt Enable
   #define EI2C 0x01 //Enable Inter-Integrated Circuit
   #define EPI  0x02 //Enable Pin Interrupt
   #define ECAP 0x04 //Enable Capture
   #define EPWM 0x08 //Enable Pulse Width Modulator
   #define EWDT 0x10 //Enable Watchdog Timer
   #define EFB  0x20 //Enable Fault Brake
   #define ESPI 0x40 //Enable Serial Perhpheral Interface
   #define ET2  0x80 //Enable Timer 2
SFR(EIE1, 0x9C); //             0000'0000 Extensive Interrupt Enable 1
   #define ES_1 0x01 //Enable Serial 1
   #define ET3  0x02 //Enable Timer 3
   #define EWKT 0x04 //Enable Wake-up Timer
SFR(CHPCON, 0x9F); //TA         0000'00U0|0000'00C0 Chip Control
   #define IAPEN 0x01 //In Application Programming Enable
   #define BS    0x02 //Boot Select
   #define IAPFF 0x40 //In Application Programming Fault Flag
   #define SWRST 0x80 //Software Reset
SFR(P2, 0xA0); //               0000'000X Port 2
   SBIT(RST, 0xA0, 0); //Reset
   SBIT(P20, 0xA0, 0); //Port 2 Bit 0
   SBIT(P2_0, 0xA0, 0); //Port 2 Bit 0
SFR(AUXR1, 0xA2); //            0000'0000|1U00'0000|U100'0000|UUU0'0000 Auxiliary Register 1
   #define UART0PX 0x04 //Universal Anynchronous Receiver Transmitter 0 Pin eXchange
   #define GF2     0x08 //General Purpose Flag 2
   #define HARDF   0x20 //Hard Fault Reset Flag
   #define RSTPINF 0x40 //External Reset Pin Flag
   #define SWRF    0x80 //Software Reset Flag
SFR(BODCON0, 0xA3); //TA        CCCC'XC0X|UUUU'XU1X|UUUU'XUUX Brown-out Detection Control 0
   #define BOS   0x01 //Brown-out Status
   #define BORF  0x02 //Brown-out Reset Flag
   #define BORST 0x04 //Brown-out Reset Enable
   #define BOF   0x08 //Brown-out Interrupt Flag
   #define BOV   0x30 //Brown-out Voltage Select
   #define BODEN 0x80 //Brown-out Detection Enable
SFR(IAPTRG, 0xA4); //TA         0000'0000 In Application Programming Trigger
   #define IAPGO 0x01 //In Application Programming Go
SFR(IAPUEN, 0xA5); //TA         0000'0000 In Application Programming Update Enable
   #define APUEN 0x01 //Application-ROM Update Enable
   #define LDUEN 0x02 //Loader-ROM Update Enable
   #define CFUEN 0x04 //Configuration Bytes Update Enable
SFR(IAPAL, 0xA6); //            0000'0000 In Application Programming Address Low Byte
SFR(IAPAH, 0xA7); //            0000'0000 In Application Programming Address High Byte
SFR(IE, 0xA8); //               0000'0000 Interrupt Enable
   SBIT(EX0,  0xA8, 0); //Enable External 0
   SBIT(ET0,  0xA8, 1); //Enable Timer 0
   SBIT(EX1,  0xA8, 2); //Enable External 1
   SBIT(ET1,  0xA8, 3); //Enable Timer 1
   SBIT(ES,   0xA8, 4); //Enable Serial
   SBIT(EBOD, 0xA8, 5); //Enable Brown Out Detection
   SBIT(EADC, 0xA8, 6); //Enable Analog Digital Converter
   SBIT(EA,   0xA8, 7); //Enable All
SFR(SADDR, 0xA9); //            0000'0000 Slave 0 Address
SFR(WDCON, 0xAA); //TA          0000'0111|0000'1UUU|0000'UUUU Watchdog Timer Control
   #define WDPS  0x07 //Watchdog Prescaler Select
   #define WDTRF 0x08 //Watchdog Timer Reset Flag
   #define WIDPD 0x10 //Watchdog Timer Running in Idle or Power-down Mode
   #define WDTF  0x20 //Watchdog Time-out Flag
   #define WDCLR 0x40 //Watchdog Clear
   #define WDTR  0x80 //Watchdog Timer Run
SFR(BODCON1, 0xAB); //TA        0000'0001|0000'0UUU Brown-out Detection Control 1
   #define BODFLT 0x01 //Brown Out Detect Filter Control
   #define LPBOD  0x06 //Low Power Brown Out Detect
SFR(P3M1, 0xAC); //             0000'0001 Port 3 Mode Select 1
   #define P3M1_0 0x01 //Port 3 Mode 1 Bit 0
SFR(P3S, 0xAC); //Page1         0000'0000 Port 3 Schmitt Trigger Input
   #define P3S_0 0x01 //Port 3 Schmitt Bit 0
SFR(P3M2, 0xAD); //             0000'0000 Port 3 Mode Select 2
   #define P3M2_0 0x01 //Port 3 Mode 2 Bit 0
SFR(P3SR, 0xAD); //Page1        0000'0000 Port 3 Slew Rate
   #define P3SR_0 0x01 //Port 3 Slew Rate Bit 0
SFR(IAPFD, 0xAE); //            0000'0000 In Application Programming Flash Data
SFR(IAPCN, 0xAF); //            0011'0000 In Application Programming Control
   #define FCTRL 0x0F //Flash Control
   #define FCEN  0x10 //Flash Control Enable
   #define FOEN  0x20 //Flash Overwrite Enable
   #define IAPB  0xC0 //In Application Programming Byte
SFR(P3, 0xB0); //               0000'0001|0000'000X Port 3
   SBIT(ACH1,  0xB0, 0); //ADC Channel 1
   SBIT(ADC1,  0xB0, 0); //AtoD Channel 1
   SBIT(AIN1,  0xB0, 0); //Analog In 1
   SBIT(INT0,  0xB0, 0); //Interrupt 0
   SBIT(OSCIN, 0xB0, 0); //Oscillator In
   SBIT(P30, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
SFR(P0M1, 0xB1); //             1111'1111 Port 0 Mode Select 1
   #define P0M1_0 0x01 //Port 0 Bit 0 Mode 1
   #define P0M1_1 0x02 //Port 0 Bit 1 Mode 1
   #define P0M1_2 0x04 //Port 0 Bit 2 Mode 1
   #define P0M1_3 0x08 //Port 0 Bit 3 Mode 1
   #define P0M1_4 0x10 //Port 0 Bit 4 Mode 1
   #define P0M1_5 0x20 //Port 0 Bit 5 Mode 1
   #define P0M1_6 0x40 //Port 0 Bit 6 Mode 1
   #define P0M1_7 0x80 //Port 0 Bit 7 Mode 1
SFR(P0S, 0xB1); //Page1         0000'0000 Port 0 Schmitt Trigger Input
   #define P0S_0 0x01 //Port 0 Bit 0 Schmitt
   #define P0S_1 0x02 //Port 0 Bit 1 Schmitt
   #define P0S_2 0x04 //Port 0 Bit 2 Schmitt
   #define P0S_3 0x08 //Port 0 Bit 3 Schmitt
   #define P0S_4 0x10 //Port 0 Bit 4 Schmitt
   #define P0S_5 0x20 //Port 0 Bit 5 Schmitt
   #define P0S_6 0x40 //Port 0 Bit 6 Schmitt
   #define P0S_7 0x80 //Port 0 Bit 7 Schmitt
SFR(P0M2, 0xB2); //             0000'0000 Port 0 Mode Select 2
   #define P0M2_0 0x01 //Port 0 Bit 0 Mode 2
   #define P0M2_1 0x02 //Port 0 Bit 1 Mode 2
   #define P0M2_2 0x04 //Port 0 Bit 2 Mode 2
   #define P0M2_3 0x08 //Port 0 Bit 3 Mode 2
   #define P0M2_4 0x10 //Port 0 Bit 4 Mode 2
   #define P0M2_5 0x20 //Port 0 Bit 5 Mode 2
   #define P0M2_6 0x40 //Port 0 Bit 6 Mode 2
   #define P0M2_7 0x80 //Port 0 Bit 7 Mode 2
SFR(P0SR, 0xB2); //Page1        0000'0000 Port 0 Slew Rate
   #define P0SR_0 0x01 //Port 0 Bit 0 Slew Rate
   #define P0SR_1 0x02 //Port 0 Bit 1 Slew Rate
   #define P0SR_2 0x04 //Port 0 Bit 2 Slew Rate
   #define P0SR_3 0x08 //Port 0 Bit 3 Slew Rate
   #define P0SR_4 0x10 //Port 0 Bit 4 Slew Rate
   #define P0SR_5 0x20 //Port 0 Bit 5 Slew Rate
   #define P0SR_6 0x40 //Port 0 Bit 6 Slew Rate
   #define P0SR_7 0x80 //Port 0 Bit 7 Slew Rate
SFR(P1M1, 0xB3); //             1111'1111 Port 1 Mode Select 1
   #define P1M1_0 0x01 //Port 1 Bit 0 Mode 1
   #define P1M1_1 0x02 //Port 1 Bit 1 Mode 1
   #define P1M1_2 0x04 //Port 1 Bit 2 Mode 1
   #define P1M1_3 0x08 //Port 1 Bit 3 Mode 1
   #define P1M1_4 0x10 //Port 1 Bit 4 Mode 1
   #define P1M1_5 0x20 //Port 1 Bit 5 Mode 1
   #define P1M1_6 0x40 //Port 1 Bit 6 Mode 1
   #define P1M1_7 0x80 //Port 1 Bit 7 Mode 1
SFR(P1S, 0xB3); //Page1         0000'0000 Port 1 Schmitt Trigger Input
   #define P1S_0 0x01 //Port 1 Bit 0 Schmitt
   #define P1S_1 0x02 //Port 1 Bit 1 Schmitt
   #define P1S_2 0x04 //Port 1 Bit 2 Schmitt
   #define P1S_3 0x08 //Port 1 Bit 3 Schmitt
   #define P1S_4 0x10 //Port 1 Bit 4 Schmitt
   #define P1S_5 0x20 //Port 1 Bit 5 Schmitt
   #define P1S_6 0x40 //Port 1 Bit 6 Schmitt
   #define P1S_7 0x80 //Port 1 Bit 7 Schmitt
SFR(P1M2, 0xB4); //             0000'0000 Port 1 Mode Select 2
   #define P1M2_0 0x01 //Port 1 Bit 0 Mode 2
   #define P1M2_1 0x02 //Port 1 Bit 1 Mode 2
   #define P1M2_2 0x04 //Port 1 Bit 2 Mode 2
   #define P1M2_3 0x08 //Port 1 Bit 3 Mode 2
   #define P1M2_4 0x10 //Port 1 Bit 4 Mode 2
   #define P1M2_5 0x20 //Port 1 Bit 5 Mode 2
   #define P1M2_6 0x40 //Port 1 Bit 6 Mode 2
   #define P1M2_7 0x80 //Port 1 Bit 7 Mode 2
SFR(P1SR, 0xB4); //Page1        0000'0000 Port 1 Slew Rate
   #define P1SR_0 0x01 //Port 1 Bit 0 Slew Rate
   #define P1SR_1 0x02 //Port 1 Bit 1 Slew Rate
   #define P1SR_2 0x04 //Port 1 Bit 2 Slew Rate
   #define P1SR_3 0x08 //Port 1 Bit 3 Slew Rate
   #define P1SR_4 0x10 //Port 1 Bit 4 Slew Rate
   #define P1SR_5 0x20 //Port 1 Bit 5 Slew Rate
   #define P1SR_6 0x40 //Port 1 Bit 6 Slew Rate
   #define P1SR_7 0x80 //Port 1 Bit 7 Slew Rate
SFR(P2S, 0xB5); //              0000'0000 P20 setting and Timer 0/1 output enable
   #define P2S_0 0x01 //Port 2 Bit 0 Schmitt
   #define T0OE  0x04 //Timer 0 Output Enable
   #define T1OE  0x08 //Timer 1 Output Enable
   #define P20UP 0x80 //Port 2 Bit 0 Pull-up Enable
SFR(IPH, 0xB7); //              0000'0000 Interrupt Priority High
   #define PX0H  0x01 //Priority External 0 High
   #define PT0H  0x02 //Priority Timer 0 High
   #define PX1H  0x04 //Priority External 1 High
   #define PT1H  0x08 //Priority Timer 1 High
   #define PSH   0x10 //Priority Serial Port High
   #define PBODH 0x20 //Priority Brown Out Detection High
   #define PADCH 0x40 //Priority Analog Digital Converter High
SFR(PWMINTC, 0xB7); //Page1     0000'0000 PWM Interrupt Control
   #define INTSEL0 0x01 //Interrupt Pair Select 0
   #define INTSEL1 0x02 //Interrupt Pair Select 1
   #define INTSEL2 0x04 //Interrupt Pair Select 2
   #define INTSEL  0x07 //Interrupt Pair Select
   #define INTTYP0 0x10 //Interrupt Type Select 0
   #define INTTYP1 0x20 //Interrupt Type Select 1
   #define INTTYP  0x30 //Interrupt Type Select
SFR(IP, 0xB8); //               0000'0000 Interrupt Priority
   SBIT(PX0,  0xB8, 0); //Priority External 0
   SBIT(PT0,  0xB8, 1); //Priority Timer 0
   SBIT(PX1,  0xB8, 2); //Priority External 1
   SBIT(PT1,  0xB8, 3); //Priority Timer 1
   SBIT(PS,   0xB8, 4); //Priority Serial
   SBIT(PBOD, 0xB8, 5); //Priority Brown Out Detection
   SBIT(PADC, 0xB8, 6); //Priority Analog Digital Converter
SFR(SADEN, 0xB9); //            0000'0000 Slave 0 Address Mask
SFR(SADEN_1, 0xBA); //          0000'0000 Slave 1 Address Mask
SFR(SADDR_1, 0xBB); //          0000'0000 Slave 1 Address
SFR(I2DAT, 0xBC); //            0000'0000 Inter-Integrated Circuit Data
SFR(I2STAT, 0xBD); //           1111'1000 Inter-Integrated Circuit Status
   #define I2STAT 0xF8 //Inter-Integrated Circuit Status
SFR(I2CLK, 0xBE); //            0000'1001 Inter-Integrated Circuit clock
SFR(I2TOC, 0xBF); //            0000'0000 Inter-Integrated Circuit Time-out Counter
   #define I2TOF   0x01 //Inter-Integrated Circuit Time-out Flag
   #define DIV     0x02 //Divider
   #define I2TOCEN 0x04 //Inter-Integrated Circuit Counter Enable
SFR(I2CON, 0xC0); //            0000'0000 Inter-Integrated Circuit control
   SBIT(I2CPX, 0xC0, 0); //Inter-Integrated Circuit Pin eXchange
   SBIT(AA,    0xC0, 2); //Acknowledge Assert
   SBIT(SI,    0xC0, 3); //Status Interrupt
   SBIT(STO,   0xC0, 4); //Stop
   SBIT(STA,   0xC0, 5); //Start
   SBIT(I2CEN, 0xC0, 6); //Inter-Integrated Circuit Enable
SFR(I2ADDR, 0xC1); //           0000'0000 Inter-Integrated Circuit Own Slave Address
   #define GC     0x01 //General Call Bit
   #define I2ADDR 0xFE //Inter-Integrated Circuit Own Slave Address
SFR(ADCRL, 0xC2); //            0000'0000 Analog Digital Coverter Result Low byte
SFR(ADCRH, 0xC3); //            0000'0000 Analog Digital Coverter Result High byte
SFR(T3CON, 0xC4); //            0000'0000 Timer 3 Control
   #define T3PS    0x07 //Timer 3 Prescaler
   #define TR3     0x80 //Timer 3 Run Control
   #define TF3     0x10 //Timer 3 Overflow Flag
   #define BRCK    0x20 //Serial Port 0 Baud Rate Clock Source
   #define SMOD0_1 0x40 //Serial Port 1 Serial Mode 0
   #define SMOD_1  0x80 //Serial Port 1 Serial Mode
SFR(PWM4H, 0xC4); //Page1       0000'0000 PWM4 duty high byte
SFR(RL3, 0xC5); //              0000'0000 Timer 3 Reload Low Byte
SFR(PWM5H, 0xC5); //Page1       0000'0000 PWM5 duty high byte
SFR(RH3, 0xC6); //              0000'0000 Timer 3 Reload High Byte
SFR(PIOCON1, 0xC6); //Page1     0000'0000 PWM I/O switch 1
   #define PIO11 0x02 //Pulse Width Modulator 1 Input Output Pin Select
   #define PIO12 0x04 //Pulse Width Modulator 1 Input Output Pin Select
   #define PIO13 0x08 //Pulse Width Modulator 1 Input Output Pin Select
   #define PIO15 0x20 //Pulse Width Modulator 1 Input Output Pin Select
SFR(TA, 0xC7); //               0000'0000 Timed Access Protection
SFR(T2CON, 0xC8); //            0000'0000 Timer/Counter 2 Control
   SBIT(CM_RL2, 0xC8, 0); //Compart Reload
   SBIT(TR2,    0xC8, 2); //Timer 2 Run
   SBIT(TF2,    0xC8, 7); //Timer 2 Flag
SFR(T2MOD, 0xC9); //            0000'0000 Timer 2 mode
   #define LDTS  0x03 //Auto-reLoad Trigger Select
   #define CMPCR 0x04 //Compare Match Auto-Clear
   #define CAPCR 0x08 //Capture Auto-Clear
   #define T2DIV 0x70 //Timer 2 Clock Divider
   #define LDEN  0x80 //Auto-reLoad Enable
SFR(RCMP2L, 0xCA); //           0000'0000 Timer 2 Compare Low Byte
SFR(RCMP2H, 0xCB); //           0000'0000 Timer 2 Compare High Byte
SFR(TL2, 0xCC); //              0000'0000 Timer/Counter 2 Low Byte
SFR(PWM4L, 0xCC); //Page1       0000'0000 PWM4 duty low byte
SFR(TH2, 0xCD); //              0000'0000 Timer/Counter 2 High Byte
SFR(PWM5L, 0xCD); //Page1       0000'0000 PWM5 duty low byte
SFR(ADCMPL, 0xCE); //           0000'0000 Analog Digital Coverter Compare Low byte
SFR(ADCMPH, 0xCF); //           0000'0000 Analog Digital Coverter Compare High byte
SFR(PSW, 0xD0); //              0000`0000 Program Status Word
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry
SFR(PWMPH, 0xD1); //            0000'0000 PWM Period High byte
SFR(PWM0H, 0xD2); //            0000'0000 PWM0 Duty High byte
SFR(PWM1H, 0xD3); //            0000'0000 PWM1 Duty High byte
SFR(PWM2H, 0xD4); //            0000'0000 PWM2 Duty High byte
SFR(PWM3H, 0xD5); //            0000'0000 PWM3 Duty High byte
SFR(PNP, 0xD6); //              0000'0000 PWM Negative Polarity Output Enable
   #define PNP0 0x01 //Pulse Width Modulator 0 Negative Polarity
   #define PNP1 0x02 //Pulse Width Modulator 1 Negative Polarity
   #define PNP2 0x04 //Pulse Width Modulator 2 Negative Polarity
   #define PNP3 0x08 //Pulse Width Modulator 3 Negative Polarity
   #define PNP4 0x10 //Pulse Width Modulator 4 Negative Polarity
   #define PNP5 0x20 //Pulse Width Modulator 5 Negative Polarity
SFR(FBD, 0xD7); //              0000'0000 Fault Brake Data
   #define FBD0   0x01 //Fault Brake Data 0
   #define FBD1   0x02 //Fault Brake Data 1
   #define FBD2   0x04 //Fault Brake Data 2
   #define FBD3   0x08 //Fault Brake Data 3
   #define FBD4   0x10 //Fault Brake Data 4
   #define FBD5   0x20 //Fault Brake Data 5
   #define FBINLS 0x40 //Fault Brake Pin Input Level Select
   #define FBF    0x80 //Fault Brake Flag
SFR(PWMCON0, 0xD8); //          0000'0000 PWM control 0
   SBIT(CLRPWM, 0xD8, 4); //Clear Pulse Width Modulator
   SBIT(PWMF,   0xD8, 5); //Pulse Width Modulator Flag
   SBIT(LOAD,   0xD8, 6); //Load
   SBIT(PWMRUN, 0xD8, 7); //Pusle Width Modulator Run
SFR(PWMPL, 0xD9); //            0000'0000 PWM Period Low byte
SFR(PWM0L, 0xDA); //            0000'0000 PWM0 Duty Low byte
SFR(PWM1L, 0xDB); //            0000'0000 PWM1 Duty Low byte
SFR(PWM2L, 0xDC); //            0000'0000 PWM2 Duty Low byte
SFR(PWM3L, 0xDD); //            0000'0000 PWM3 Duty Low byte
SFR(PIOCON0, 0xDE); //          0000'0000 PWM I/O switch 0
   #define PIO00 0x01 //Pulse width Modulator 0 Input Output Pin Select
   #define PIO01 0x02 //Pulse width Modulator 1 Input Output Pin Select
   #define PIO02 0x04 //Pulse width Modulator 2 Input Output Pin Select
   #define PIO03 0x08 //Pulse width Modulator 3 Input Output Pin Select
   #define PIO04 0x10 //Pulse width Modulator 4 Input Output Pin Select
   #define PIO05 0x20 //Pulse width Modulator 5 Input Output Pin Select
SFR(PWMCON1, 0xDF); //          0000'0000 PWM control 1
   #define PWMDIV 0x07 //Pulse width Modulator Clock Divider
   #define FBINEN 0x08 //Fault Brake Pin Input Enable
   #define PWMTYP 0x10 //Pulse width Modulation Type select
   #define GP     0x20 //Group Mode Enable
   #define PWMMOD 0xC0 //Pulse width Modulator Mode select
SFR(ACC, 0xE0); //              0000'0000 Accumulator
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7
SFR(ADCCON1, 0xE1); //          0000'0000 Analog Digital Coverter Control 1
   #define ADCEN   0x01 //Analog Digital Coverter Enable
   #define ADCEX   0x02 //Analog Digital Coverter eXternal Trigger Select
   #define ETGTYP  0x0C //External Trigger Type
   #define STADCPX 0x40 //Analog Digital Converter eXternal Start Pin
SFR(ADCCON2, 0xE2); //          0000'0000 Analog Digital Coverter Control 2
   #define ADCDLY_8 0x01 //Analog Digital Coverter External Trigger Delay Counter 8 Bit
   #define ADCMPO   0x10 //Analog Digital Coverter Comparator Output Value
   #define ADCMPEN  0x20 //Analog Digital Coverter Result Comparator Enable
   #define ADCMPOP  0x40 //Analog Digital Coverter Comparator Output Polarity
   #define ADFBEN   0x80 //Analog Digital Coverter Compare Result Asserting Fault Brake Enable
SFR(ADCDLY, 0xE3); //           0000'0000 Analog Digital Coverter Trigger Delay
SFR(C0L, 0xE4); //              0000'0000 Input Capture 0 Low Byte
SFR(C0H, 0xE5); //              0000'0000 Input Capture 0 High Byte
SFR(C1L, 0xE6); //              0000'0000 Input Capture 1 Low Byte
SFR(C1H, 0xE7); //              0000'0000 Input Capture 1 High Byte
SFR(ADCCON0, 0xE8); //          0000'0000 Analog Digital Coverter Control 0
   SBIT(ADCHS0,  0xE8, 0); //Analog Digital Channel Select 0
   SBIT(ADCHS1,  0xE8, 1); //Analog Digital Channel Select 1
   SBIT(ADCHS2,  0xE8, 2); //Analog Digital Channel Select 2
   SBIT(ADCHS3,  0xE8, 3); //Analog Digital Channel Select 3
   SBIT(ETGSEL0, 0xE8, 4); //External Trigger Select 0
   SBIT(ETGSEL1, 0xE8, 5); //External Trigger Select 1
   SBIT(ADCS,    0xE8, 6); //Analog Digital Converter Start
   SBIT(ADCF,    0xE8, 7); //Analog Digital Converter Flag
SFR(PICON, 0xE9); //            0000'0000 Pin Interrupt Control
   #define PIPS  0x03 //Pin Interrupt Port Select
   #define PITO  0x04 //Pin Interrupt Channel 0 Type Select
   #define PIT1  0x08 //Pin Interrupt Channel 1 Type Select
   #define PIT2  0x10 //Pin Interrupt Channel 2 Type Select
   #define PIT3  0x20 //Pin Interrupt Channel 3 Type Select
   #define PIT45 0x40 //Pin Interrupt Channel 4 & 5 Type Select
   #define PIT67 0x80 //Pin Interrupt Channel 6 & 7 Type Select
SFR(PINEN, 0xEA); //            0000'0000 Pin interrupt low level/falling edge enable
   #define PINEN0 0x01 //Pin Interrupt 0 Negative Polarity Enable
   #define PINEN1 0x02 //Pin Interrupt 1 Negative Polarity Enable
   #define PINEN2 0x04 //Pin Interrupt 2 Negative Polarity Enable
   #define PINEN3 0x08 //Pin Interrupt 3 Negative Polarity Enable
   #define PINEN4 0x10 //Pin Interrupt 4 Negative Polarity Enable
   #define PINEN5 0x20 //Pin Interrupt 5 Negative Polarity Enable
   #define PIN3N6 0x40 //Pin Interrupt 6 Negative Polarity Enable
   #define PINEN7 0x80 //Pin Interrupt 7 Negative Polarity Enable
SFR(PIPEN, 0xEB); //            0000'0000 Pin interrupt high level/rising edge enable
   #define PIPEN0 0x01 //Pin Interrupt 0 Positive Polarity Enable
   #define PIPEN1 0x02 //Pin Interrupt 1 Positive Polarity Enable
   #define PIPEN2 0x04 //Pin Interrupt 2 Positive Polarity Enable
   #define PIPEN3 0x08 //Pin Interrupt 3 Positive Polarity Enable
   #define PIPEN4 0x10 //Pin Interrupt 4 Positive Polarity Enable
   #define PIPEN5 0x20 //Pin Interrupt 5 Positive Polarity Enable
   #define PIP3N6 0x40 //Pin Interrupt 6 Positive Polarity Enable
   #define PIPEN7 0x80 //Pin Interrupt 7 Positive Polarity Enable
SFR(PIF, 0xEC); //              0000'0000 Pin interrupt flag
   #define PIF0 0x01 //Pin Interrupt Flag Channel 0
   #define PIF1 0x02 //Pin Interrupt Flag Channel 1
   #define PIF2 0x04 //Pin Interrupt Flag Channel 2
   #define PIF3 0x08 //Pin Interrupt Flag Channel 3
   #define PIF4 0x10 //Pin Interrupt Flag Channel 4
   #define PIF5 0x20 //Pin Interrupt Flag Channel 5
   #define PIF6 0x40 //Pin Interrupt Flag Channel 6
   #define PIF7 0x80 //Pin Interrupt Flag Channel 7
SFR(C2L, 0xED); //              0000'0000 Input capture 2 low byte
SFR(C2H, 0xEE); //              0000'0000 Input capture 2 high byte
SFR(EIP, 0xEF); //              0000'0000 Extensive interrupt priority
   #define PI2C 0x01 //Priority Inter-Integrated Circuit low bit
   #define PPI  0x02 //Priority Pin Interrupt low bit
   #define PCAP 0x04 //Priority Input Capture low bit
   #define PPWM 0x08 //Priority Pulse Width Modulator low bit
   #define PWDT 0x10 //Priority Watchdog Timer low bit
   #define PFB  0x20 //Priority Fault Brake low bit
   #define PSPI 0x40 //Priority Serial Peripheral Interface low bit
   #define PT2  0x80 //Priority Timer 2 low bit
SFR(B, 0xF0); //                0000'0000 B register
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7
SFR(CAPCON3, 0xF1); //          0000'0000 Input capture control 3
   #define CAP00 0x01 //Input Capture Channel 0 Pin Select 0
   #define CAP01 0x02 //Input Capture Channel 0 Pin Select 1
   #define CAP02 0x04 //Input Capture Channel 0 Pin Select 2
   #define CAP03 0x08 //Input Capture Channel 0 Pin Select 3
   #define CAP0  0x0F //Input Capture Channel 0 Pin Select
   #define CAP10 0x10 //Input Capture Channel 1 Pin Select 0
   #define CAP11 0x20 //Input Capture Channel 1 Pin Select 1
   #define CAP12 0x40 //Input Capture Channel 1 Pin Select 2
   #define CAP13 0x80 //Input Capture Channel 1 Pin Select 3
   #define CAP1  0xF0 //Input Capture Channel 1 Pin Select
SFR(CAPCON4, 0xF2); //          0000'0000 Input capture control 4
   #define CAP20 0x01 //Input Capture Channel 2 Pin Select 0
   #define CAP21 0x02 //Input Capture Channel 2 Pin Select 1
   #define CAP22 0x04 //Input Capture Channel 2 Pin Select 2
   #define CAP23 0x08 //Input Capture Channel 2 Pin Select 3
   #define CAP2  0x0F //Input Capture Channel 2 Pin Select
SFR(SPCR, 0xF3); //             0000'0000 Serial Peripheral Interface Control Register
   #define SPR0  0x01 //Serial Peripheral Rate 0
   #define SPR1  0x02 //Serial Peripheral Rate 1
   #define SPR   0x03 //Serial Peripheral Rate
   #define CPHA  0x04 //Clock Phase
   #define CPOL  0x08 //Clock Polarity
   #define MSTR  0x10 //Master Mode Enable
   #define LSBFE 0x20 //Least Significant Bit First Enable
   #define SPIEN 0x40 //Serial Peripheral Interface Enable
   #define SSOE  0x80 //Slave Select Output Enable
SFR(SPCR2, 0xF3); //Page1       0000'0000 Serial Peripheral Interface Control Register 2
   #define SPIS0 0x01 //Serial Peripheral Interval Select 0
   #define SPIS1 0x02 //Serial Peripheral Interval Select 1
   #define SPIS  0x03 //Serial Peripheral Interval Select
SFR(SPSR, 0xF4); //             0000'0000 Serial Peripheral Interface Status Register
   #define TXBUF   0x04 //Transmit Buffer Status
   #define DISMODF 0x08 //Disable Mode Fault Detection
   #define MODF    0x10 //Mode Fault Flag
   #define SPIOVF  0x20 //Serial Peripheral Interface Overrun Flag
   #define WCOL    0x40 //Write Collision Flag
   #define SPIF    0x80 //Serial Peripheral Interface Complete Flag
SFR(SPDR, 0xF5); //             0000'0000 Serial Peripheral Interface Data Register
SFR(AINDIDS, 0xF6); //          0000'0000 Analog In Digital Input Disconnect
   #define P17DIDS 0x01 //Port 1 Bit 7 Digital Input Disable
   #define P30DIDS 0x02 //Port 3 Bit 0 Digital Input Disable
   #define P07DIDS 0x04 //Port 0 Bit 7 Digital Input Disable
   #define P06DIDS 0x08 //Port 0 Bit 6 Digital Input Disable
   #define P05DIDS 0x10 //Port 0 Bit 5 Digital Input Disable
   #define P04DIDS 0x20 //Port 0 Bit 4 Digital Input Disable
   #define P03DIDS 0x40 //Port 0 Bit 3 Digital Input Disable
   #define P11DIDS 0x80 //Port 1 Bit 1 Digital Input Disable
SFR(EIPH, 0xF7); //             0000'0000 Extensive interrupt priority high
   #define PI2CH 0x01 //Priority Inter-Integrated Circuit High
   #define PPIH  0x02 //Priority Pin Interrupt High
   #define PCAPH 0x04 //Priority Input Capture High
   #define PPWMH 0x08 //Priority Pulse Width Modulator High
   #define PWDTH 0x10 //Priority Watchdog Timer High
   #define PFBH  0x20 //Priority Fault Brake High
   #define PSPIH 0x40 //Priority Serial Peripheral Interface High
   #define PT2H  0x80 //Priority Timer 2 High
SFR(SCON_1, 0xF8); //           0000'0000 Serial port 1 control
   SBIT(RI_1,  0xF8, 0); //Receive Interrupt 1
   SBIT(TI_1,  0xF8, 1); //Transmit Interrupt 1
   SBIT(RB8_1, 0xF8, 2); //Receive Bit 8 1
   SBIT(TB8_1, 0xF8, 3); //Transmit Bit 8 1
   SBIT(REN_1, 0xF8, 4); //Receive Enable 1
   SBIT(SM2_1, 0xF8, 5); //Serial Mode 2 1
   SBIT(SM1_1, 0xF8, 6); //Serial Mode 1 1
   SBIT(SM0_1, 0xF8, 7); //(WR)Serial Mode 0 1
   SBIT(FE_1,  0xF8, 7); //(RD)Framing Error 1
SFR(PDTEN, 0xF9); //TA          0000'0000 PWM Dead Time Enable
   #define PDT01EN  0x01 //PWM 0 & 1 Dead Time Enable
   #define PDT23EN  0x02 //PWM 2 & 3 Dead Time Enable
   #define PDT45EN  0x04 //PWM 4 & 5 Dead Time Enable
   #define PDTCNT_8 0x10 //PWM Dead Time Counter 8-bit
SFR(PDTCNT, 0xFA); //TA         0000'0000 PWM Dead-time Counter
SFR(PMEN, 0xFB); //             0000'0000 PWM Mask Enable
   #define PMEN0 0x01 //PWM 0 Mask Enable
   #define PMEN1 0x02 //PWM 1 Mask Enable
   #define PMEN2 0x04 //PWM 2 Mask Enable
   #define PMEN3 0x08 //PWM 3 Mask Enable
   #define PMEN4 0x10 //PWM 4 Mask Enable
   #define PMEN5 0x20 //PWM 5 Mask Enable
SFR(PMD, 0xFC); //              0000'0000 PWM Mask Data
   #define PMD0 0x01 //PWM 0 Mask Data
   #define PMD1 0x02 //PWM 1 Mask Data
   #define PMD2 0x04 //PWM 2 Mask Data
   #define PMD3 0x08 //PWM 3 Mask Data
   #define PMD4 0x10 //PWM 4 Mask Data
   #define PMD5 0x20 //PWM 5 Mask Data
SFR(PORDIS, 0xFD); //TA         0000'0000 Power On Reset Disable
SFR(EIP1, 0xFE); //             0000'0000 Extensive Interrupt Priority 1
   #define PS_1 0x01 //Priority Serial Port 1 Low Bit
   #define PT3  0x02 //Priority Timer 3 Low Bit
   #define PWKT 0x04 //Priority Wake-up Timer Low Bit
SFR(EIPH1, 0xFF); //            0000'0000 Extensive Interrupt Priority High 1
   #define PSH_1 0x01 //Priority Serial Port 1 High Bit
   #define PT3H  0x02 //Priority Timer 3 High Bit
   #define PWKTH 0x04 //Priority Wake-up Timer High Bit

//Interrupt numbers: Address = ( Number * 8 ) + 3
//Vectors are named after their corresponding interrupt
//enable register bit, so that we don't have to make up
//names and can be consisten across different 8051 MCUs
   #define X0_VECTOR  0  // 0x03 External Interrupt 0
   #define T0_VECTOR  1  // 0x0B Timer 0
   #define X1_VECTOR  2  // 0x13 External Interrupt 1
   #define T1_VECTOR  3  // 0x1B Timer 1
   #define S_VECTOR   4  // 0x23 Serial Port 0
   #define T2_VECTOR  5  // 0x2B Timer 2
   #define I2C_VECTOR 6  // 0x33 Inter-Integrated Circuit
   #define PI_VECTOR  7  // 0x3B Pin Interrupt
   #define BOD_VECTOR 8  // 0x43 Brown-out
   #define SPI_VECTOR 9  // 0x4B Serial Peripheral Interface
   #define WDT_VECTOR 10 // 0x53 Watchdog timer
   #define ADC_VECTOR 11 // 0x5B Analog Digital Converter
   #define CAP_VECTOR 12 // 0x63 Input Capture
   #define PWM_VECTOR 13 // 0x6B Pulse Width Modulator
   #define FB_VECTOR  14 // 0x73 Fault Brake Event
   #define S1_VECTOR  15 // 0x7B Serial Port 1
   #define T3_VECTOR  16 // 0x83 Timer 3
   #define WKT_VECTOR 17 // 0x8B Self Wake-up Timer

#endif