// PlatformIO compatible header file N76E616.h 20210823.
// For Nuvoton N76E616.

#ifndef N76E616_H
#define N76E616_H
#include <compiler.h>

SFR(P0, 0x80);
   SBIT(T0,   0x80, 0); //Timer 0
   SBIT(INT0, 0x80, 1); //Interrupt 0
   SBIT(CLO,  0x80, 7); //Clock
   SBIT(ACH0, 0x80, 0); //ADC Channel 0
   SBIT(ACH1, 0x80, 1); //ADC Channel 1
   SBIT(ACH2, 0x80, 2); //ADC Channel 2
   SBIT(ACH3, 0x80, 3); //ADC Channel 3
   SBIT(ACH4, 0x80, 4); //ADC Channel 4
   SBIT(ACH5, 0x80, 5); //ADC Channel 5
   SBIT(ACH6, 0x80, 6); //ADC Channel 6
   SBIT(ACH7, 0x80, 7); //ADC Channel 7
   SBIT(ADC0, 0x80, 0); //AtoD Channel 0
   SBIT(ADC1, 0x80, 1); //AtoD Channel 1
   SBIT(ADC2, 0x80, 2); //AtoD Channel 2
   SBIT(ADC3, 0x80, 3); //AtoD Channel 3
   SBIT(ADC4, 0x80, 4); //AtoD Channel 4
   SBIT(ADC5, 0x80, 5); //AtoD Channel 5
   SBIT(ADC6, 0x80, 6); //AtoD Channel 6
   SBIT(ADC7, 0x80, 7); //AtoD Channel 7
   SBIT(AIN0, 0x80, 0); //Analog Input 0
   SBIT(AIN1, 0x80, 1); //Analog Input 1
   SBIT(AIN2, 0x80, 2); //Analog Input 2
   SBIT(AIN3, 0x80, 3); //Analog Input 3
   SBIT(AIN4, 0x80, 4); //Analog Input 4
   SBIT(AIN5, 0x80, 5); //Analog Input 5
   SBIT(AIN6, 0x80, 6); //Analog Input 6
   SBIT(AIN7, 0x80, 7); //Analog Input 7
   SBIT(P00, 0x80, 0); //Port 0 Bit 0
   SBIT(P01, 0x80, 1); //Port 0 Bit 1
   SBIT(P02, 0x80, 2); //Port 0 Bit 2
   SBIT(P03, 0x80, 3); //Port 0 Bit 3
   SBIT(P04, 0x80, 4); //Port 0 Bit 4
   SBIT(P05, 0x80, 5); //Port 0 Bit 5
   SBIT(P06, 0x80, 6); //Port 0 Bit 6
   SBIT(P07, 0x80, 7); //Port 0 Bit 7
   SBIT(P0_0, 0x80, 0); //Port 0 Bit 0
   SBIT(P0_1, 0x80, 1); //Port 0 Bit 1
   SBIT(P0_2, 0x80, 2); //Port 0 Bit 2
   SBIT(P0_3, 0x80, 3); //Port 0 Bit 3
   SBIT(P0_4, 0x80, 4); //Port 0 Bit 4
   SBIT(P0_5, 0x80, 5); //Port 0 Bit 5
   SBIT(P0_6, 0x80, 6); //Port 0 Bit 6
   SBIT(P0_7, 0x80, 7); //Port 0 Bit 7
SFR(SP, 0x81); //               Stack Pointer
SFR(DPTR, 0x82); //             Data Pointer
SFR(DPL,  0x82); //             Data Pointer Low
SFR(DPH, 0x83); //              Data Pointer High
SFR(RWK, 0x86); //              Wake-up Timer Reload
SFR(PCON, 0x87); //             Power Control
   #define IDL   0x01 //Idle
   #define PD    0x02 //Power Down
   #define STOP  0x02 //Stop
   #define GF0   0x04 //General Flag 0
   #define GF1   0x08 //General Flag 1
   #define POF   0x10 //Power On Flag
   #define SMOD0 0x40 //Serial Mode 0
   #define SMOD  0x80 //Serial Mode
SFR(TCON, 0x88); //             Timer Control
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag
SFR(TMOD, 0x89); //             Timer Mode
   #define T0_M0   0x01 //Timer 0 Mode 0
   #define T0_M1   0x02 //Timer 0 Mode 1
   #define T0_M    0x03 //Timer 0 Mode
   #define T0_CT   0x04 //Timer 0 Counter Timer
   #define T0_GATE 0x08 //Timer 0 Gate
   #define T1_M0   0x10 //Timer 1 Mode 0
   #define T1_M1   0x20 //Timer 1 Mode 1
   #define T1_M    0x30 //Timer 1 Mode
   #define T1_CT   0x40 //Timer 1 Counter Timer
   #define T1_GATE 0x80 //Timer 1 Gate
   #define M00   0x01 //Mode 0 Timer 0
   #define M10   0x02 //Mode 1 Timer 0
   #define M0    0x03 //Timer 0 Mode
   #define CT0   0x04 //Counter Timer 0
   #define GATE0 0x08 //Gate 0
   #define M01   0x10 //Mode 1 Timer 1
   #define M11   0x20 //Mode 1 Timer 1
   #define M1    0x30 //Timer 1 Mode
   #define CT1   0x40 //Counter Timer 1
   #define GATE1 0x80 //Gate 1
SFR(TL0, 0x8A); //              Timer 0 Low
SFR(TL1, 0x8B); //              Timer 1 Low
SFR(TH0, 0x8C); //              Timer 0 High
SFR(TH1, 0x8D); //              Timer 1 High
SFR(CKCON, 0x8E); //            Clock Control
   #define T0M    0x08 //Timer 0 Mode
   #define T1M    0x10 //Timer 1 Mode
SFR(WKCON, 0x8F); //            Wake-up Configuration
   #define WKPS   0x07 //Wake-up Timer Prescaler
   #define WKTR   0x08 //Wake-up Timer Run
   #define WKTF   0x10 //Wake-up Timer Flag
   #define WKTCKS 0x20 //Wake-up Timer Clock
SFR(P1, 0x90);
   SBIT(INT1,  0x90, 3); //Interrupt 1
   SBIT(T1,    0x90, 4); //Timer 1
   SBIT(T2AO1, 0x90, 5); //Timer 2A Output 1
   SBIT(T2AO2, 0x90, 6); //Timer 2A Output 2
   SBIT(T2BO1, 0x90, 7); //Timer 2B Output 1
   SBIT(P10, 0x90, 0); //Port 1 Bit 0
   SBIT(P11, 0x90, 1); //Port 1 Bit 1
   SBIT(P12, 0x90, 2); //Port 1 Bit 2
   SBIT(P13, 0x90, 3); //Port 1 Bit 3
   SBIT(P14, 0x90, 4); //Port 1 Bit 4
   SBIT(P15, 0x90, 5); //Port 1 Bit 5
   SBIT(P16, 0x90, 6); //Port 1 Bit 6
   SBIT(P17, 0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
SFR(SFRS, 0x91); //TA           SFR Select
   #define SFRPSEL 0x01 //SFR Page Select
   #define SFRPAGE 0x01 //SFR Page
SFR(CKDIV, 0x95); //            Clock Divider
SFR(CKSWT, 0x96); //TA          Clock Switch
   #define OSC    0x07 //Oscillator Selection Bits
   #define ECLKST 0x08 //External Clock Input Status
   #define HIRCST 0x20 //High-speed Internal Resistor Capacitor Status
   #define LXTST  0x40 //Low-speed eXternal Status
   #define HXTST  0x80 //High-speed eXternal Status
SFR(CKEN, 0x97); //TA           Clock Enable
   #define CKSWTF 0x01 //Clock Switch Fault Flag
   #define HIRCEN 0x20 //High-speed Internal Resistor Capacitor Enable
   #define EXTEN  0xC0 //External Clock Source Enable
SFR(SCON, 0x98); //             Serial Control
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //(WR)Serial Mode 0
   SBIT(FE,  0x98, 7); //(RD)Framing Error
SFR(SBUF, 0x99); //             Serial Buffer
SFR(SBUF_1, 0x9A); //           Serial 1 Buffer
SFR(EIE, 0x9B); //              Extensive Interrupt Enable
   #define EI2C 0x01 //Enable Inter-Integrated Circuit
   #define EPI  0x02 //Enable Pin Interrupt
   #define ET2A 0x04 //Enable Timer 2A
   #define ET2B 0x08 //Enable Timer 2B
   #define EWDT 0x10 //Enable Watchdog Timer
   #define ET2C 0x20 //Enable Timer 2C
   #define ET2D 0x80 //Enable Timer 2D
SFR(EIE1, 0x9C); //             Extensive Interrupt Enable 1
   #define ES_1 0x01 //Enable Serial 1
   #define ET3  0x02 //Enable Timer 3
   #define EWKT 0x04 //Enable Wake-up Timer
SFR(CHPCON, 0x9F); //TA         Chip Control
   #define IAPEN 0x01 //In Application Programming Enable
   #define BS    0x02 //Boot Select
   #define IAPFF 0x40 //In Application Programming Fault Flag
   #define SWRST 0x80 //Software Reset
SFR(P2, 0xA0); //               Port 2
   SBIT(T2BO2, 0xA0, 0); //Timer 2B Output 2
   SBIT(RXD,   0xA0, 1); //Receive Data
   SBIT(TXD,   0xA0, 2); //Transmit Data
   SBIT(SDA,   0xA0, 3); //Serial Data
   SBIT(SCL,   0xA0, 4); //Serial Clock
   SBIT(T2CO1, 0xA0, 6); //Timer 2C Output 1
   SBIT(T2CO2, 0xA0, 7); //Timer 2C Output 2
   SBIT(P20, 0xA0, 0); //Port 2 Bit 0
   SBIT(P21, 0xA0, 1); //Port 2 Bit 1
   SBIT(P22, 0xA0, 2); //Port 2 Bit 2
   SBIT(P23, 0xA0, 3); //Port 2 Bit 3
   SBIT(P24, 0xA0, 4); //Port 2 Bit 4
   SBIT(P25, 0xA0, 5); //Port 2 Bit 5
   SBIT(P26, 0xA0, 6); //Port 2 Bit 6
   SBIT(P27, 0xA0, 7); //Port 2 Bit 7
   SBIT(P2_0, 0xA0, 0); //Port 2 Bit 0
   SBIT(P2_1, 0xA0, 1); //Port 2 Bit 1
   SBIT(P2_2, 0xA0, 2); //Port 2 Bit 2
   SBIT(P2_3, 0xA0, 3); //Port 2 Bit 3
   SBIT(P2_4, 0xA0, 4); //Port 2 Bit 4
   SBIT(P2_5, 0xA0, 5); //Port 2 Bit 5
   SBIT(P2_6, 0xA0, 6); //Port 2 Bit 6
   SBIT(P2_7, 0xA0, 7); //Port 2 Bit 7
SFR(AUXR1, 0xA2); //            Auxiliary register 1
   #define DPS     0x01 //Data Pointer Select
   #define GF2     0x08 //General Flag 2
   #define T0LXTM  0x10 //Timer 0 Low-speed Crystal Mode
   #define T1LXTM  0x20 //Timer 1 Low-speed Crystal Mode
   #define RSTPINF 0x40 //Reset Pin Flag
   #define SWRF    0x80 //Software Reset Flag
SFR(BODCON0, 0xA3); //TA        Brown-out Detection Control 0
   #define BOS   0x01 //Brown-out Status
   #define BORF  0x02 //Brown-out Reset Flag
   #define BORST 0x04 //Brown-out Reset Enable
   #define BOF   0x08 //Brown-out Interrupt Flag
   #define BOV   0x30 //Brown-out Voltage Select
   #define BODEN 0x80 //Brown-out Detection Enable
SFR(IAPTRG, 0xA4); //TA         In Application Programming Trigger
   #define IAPGO 0x01 //In Application Programming Go
SFR(IAPUEN, 0xA5); //TA         In Application Programming Update Enable
   #define APUEN 0x01 //Application-ROM Update Enable
   #define LDUEN 0x02 //Loader-ROM Update Enable
   #define CFUEN 0x04 //Configuration Bytes Update Enable
SFR(IAPAL, 0xA6); //            In Application Programming Address Low
SFR(IAPAH, 0xA7); //            In Application Programming Address High
SFR(IE, 0xA8); //               Interrupt Enable
   SBIT(EX0,  0xA8, 0); //Enable External 0
   SBIT(ET0,  0xA8, 1); //Enable Timer 0
   SBIT(EX1,  0xA8, 2); //Enable External 1
   SBIT(ET1,  0xA8, 3); //Enable Timer 1
   SBIT(ES,   0xA8, 4); //Enable Serial
   SBIT(EBOD, 0xA8, 5); //Enable Brown Out Detection
   SBIT(EADC, 0xA8, 6); //Enable Analog Digital Converter
   SBIT(EA,   0xA8, 7); //Enable All
SFR(SADDR, 0xA9); //            Slave Address
SFR(WDCON, 0xAA); //TA          Watchdog Control
   #define WDPS  0x07 //Watchdog Prescaler Select
   #define WDTRF 0x08 //Watchdog Timer Reset Flag
   #define WIDPD 0x10 //Watchdog Idle or Power-down
   #define WDTF  0x20 //Watchdog Time-out Flag
   #define WDCLR 0x40 //Watchdog Clear
   #define WDTEN 0x80 //Watchdog Timer Enable
SFR(BODCON1, 0xAB); //TA        Brown-out Detection Control 1
   #define BODFLT 0x01 //Brown Out Detect Filter Control
   #define LPBOD  0x06 //Low Power Brown Out Detect
SFR(P3M1, 0xAC); //             Port 3 Mode 1
   #define P3M1_0 0x01 //Port 3 Bit 0 Mode 1
   #define P3M1_1 0x02 //Port 3 Bit 1 Mode 1
   #define P3M1_2 0x04 //Port 3 Bit 2 Mode 1
   #define P3M1_3 0x08 //Port 3 Bit 3 Mode 1
   #define P3M1_4 0x10 //Port 3 Bit 4 Mode 1
   #define P3M1_5 0x20 //Port 3 Bit 5 Mode 1
   #define T0OE   0x40 //Timer 0 Output Enable
   #define T1OE   0x80 //Timer 1 Output Enable
SFR(P3S, 0xAC); //Page1         Port 3 Schmitt
   #define P3S_0 0x01 //Port 3 Bit 0 Schmitt
   #define P3S_1 0x02 //Port 3 Bit 1 Schmitt
   #define P3S_2 0x04 //Port 3 Bit 2 Schmitt
   #define P3S_3 0x08 //Port 3 Bit 3 Schmitt
   #define P3S_4 0x10 //Port 3 Bit 4 Schmitt
   #define P3S_5 0x20 //Port 3 Bit 5 Schmitt
   #define P3S_6 0x40 //Port 3 Bit 6 Schmitt
SFR(P3M2, 0xAD); //             Port 3 Mode 2
   #define P3M2_0 0x01 //Port 3 Bit 0 Mode 2
   #define P3M2_1 0x02 //Port 3 Bit 1 Mode 2
   #define P3M2_2 0x04 //Port 3 Bit 2 Mode 2
   #define P3M2_3 0x08 //Port 3 Bit 3 Mode 2
   #define P3M2_4 0x10 //Port 3 Bit 4 Mode 2
   #define P3M2_5 0x20 //Port 3 Bit 5 Mode 2
   #define P36UP  0x40 //Port 3 Bit 6 Pull-up
   #define CLOEN  0x80 //Clock Output Enable
SFR(IAPFD, 0xAE); //            In Application Programming flash data
SFR(IAPCN, 0xAF); //            In Application Programming control
   #define FCTRL 0x0F //Flash Control
   #define FCEN  0x10 //Flash Control Enable
   #define FOEN  0x20 //Flash Overwrite Enable
   #define IAPB  0xC0 //In Application Programming Byte
SFR(P3, 0xB0); //               Port 3
   SBIT(T2DO1, 0xB0, 0); //Timer 2D Output 1
   SBIT(T2DO2, 0xB0, 1); //Timer 2D Output 2
   SBIT(ICPDA, 0xB0, 4); //In Circuit Programming Data
   SBIT(OCDDA, 0xB0, 4); //On Chip Debugging Data
   SBIT(ICPCK, 0xB0, 5); //In Circuit Programming Data
   SBIT(OCDCK, 0xB0, 5); //On Chip Debugging Data
   SBIT(RST,   0xB0, 6); //Reset
   SBIT(P30, 0xB0, 0); //Port 3 Bit 0
   SBIT(P31, 0xB0, 1); //Port 3 Bit 1
   SBIT(P32, 0xB0, 2); //Port 3 Bit 2
   SBIT(P33, 0xB0, 3); //Port 3 Bit 3
   SBIT(P34, 0xB0, 4); //Port 3 Bit 4
   SBIT(P35, 0xB0, 5); //Port 3 Bit 5
   SBIT(P36, 0xB0, 6); //Port 3 Bit 6
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_1, 0xB0, 1); //Port 3 Bit 1
   SBIT(P3_2, 0xB0, 2); //Port 3 Bit 2
   SBIT(P3_3, 0xB0, 3); //Port 3 Bit 3
   SBIT(P3_4, 0xB0, 4); //Port 3 Bit 4
   SBIT(P3_5, 0xB0, 5); //Port 3 Bit 5
   SBIT(P3_6, 0xB0, 6); //Port 3 Bit 6
SFR(P0M1, 0xB1); //             Port 0 Mode 1
   #define P0M1_0 0x01 //Port 0 Bit 0 Mode 1
   #define P0M1_1 0x02 //Port 0 Bit 1 Mode 1
   #define P0M1_2 0x04 //Port 0 Bit 2 Mode 1
   #define P0M1_3 0x08 //Port 0 Bit 3 Mode 1
   #define P0M1_4 0x10 //Port 0 Bit 4 Mode 1
   #define P0M1_5 0x20 //Port 0 Bit 5 Mode 1
   #define P0M1_6 0x40 //Port 0 Bit 6 Mode 1
   #define P0M1_7 0x80 //Port 0 Bit 7 Mode 1
SFR(P0S, 0xB1); //Page1         Port 0 Schmitt
   #define P0S_0 0x01 //Port 0 Bit 0 Schmitt
   #define P0S_1 0x02 //Port 0 Bit 1 Schmitt
   #define P0S_2 0x04 //Port 0 Bit 2 Schmitt
   #define P0S_3 0x08 //Port 0 Bit 3 Schmitt
   #define P0S_4 0x10 //Port 0 Bit 4 Schmitt
   #define P0S_5 0x20 //Port 0 Bit 5 Schmitt
   #define P0S_6 0x40 //Port 0 Bit 6 Schmitt
   #define P0S_7 0x80 //Port 0 Bit 7 Schmitt
SFR(P0M2, 0xB2); //             Port 0 Mode 2
   #define P0M2_0 0x01 //Port 0 Bit 0 Mode 2
   #define P0M2_1 0x02 //Port 0 Bit 1 Mode 2
   #define P0M2_2 0x04 //Port 0 Bit 2 Mode 2
   #define P0M2_3 0x08 //Port 0 Bit 3 Mode 2
   #define P0M2_4 0x10 //Port 0 Bit 4 Mode 2
   #define P0M2_5 0x20 //Port 0 Bit 5 Mode 2
   #define P0M2_6 0x40 //Port 0 Bit 6 Mode 2
   #define P0M2_7 0x80 //Port 0 Bit 7 Mode 2
SFR(P1M1, 0xB3); //             Port 1 Mode 1
   #define P1M1_0 0x01 //Port 1 Bit 0 Mode 1
   #define P1M1_1 0x02 //Port 1 Bit 1 Mode 1
   #define P1M1_2 0x04 //Port 1 Bit 2 Mode 1
   #define P1M1_3 0x08 //Port 1 Bit 3 Mode 1
   #define P1M1_4 0x10 //Port 1 Bit 4 Mode 1
   #define P1M1_5 0x20 //Port 1 Bit 5 Mode 1
   #define P1M1_6 0x40 //Port 1 Bit 6 Mode 1
   #define P1M1_7 0x80 //Port 1 Bit 7 Mode 1
SFR(P1S, 0xB3); //Page1         Port 1 Schmitt
   #define P1S_0 0x01 //Port 1 Bit 0 Schmitt
   #define P1S_1 0x02 //Port 1 Bit 1 Schmitt
   #define P1S_2 0x04 //Port 1 Bit 2 Schmitt
   #define P1S_3 0x08 //Port 1 Bit 3 Schmitt
   #define P1S_4 0x10 //Port 1 Bit 4 Schmitt
   #define P1S_5 0x20 //Port 1 Bit 5 Schmitt
   #define P1S_6 0x40 //Port 1 Bit 6 Schmitt
   #define P1S_7 0x80 //Port 1 Bit 7 Schmitt
SFR(P1M2, 0xB4); //             Port 1 Mode 2
   #define P1M2_0 0x01 //Port 1 Bit 0 Mode 2
   #define P1M2_1 0x02 //Port 1 Bit 1 Mode 2
   #define P1M2_2 0x04 //Port 1 Bit 2 Mode 2
   #define P1M2_3 0x08 //Port 1 Bit 3 Mode 2
   #define P1M2_4 0x10 //Port 1 Bit 4 Mode 2
   #define P1M2_5 0x20 //Port 1 Bit 5 Mode 2
   #define P1M2_6 0x40 //Port 1 Bit 6 Mode 2
   #define P1M2_7 0x80 //Port 1 Bit 7 Mode 2
SFR(P1OS, 0xB4); //Page1        Port 1 Output Strength
   #define P1OS_0 0x01 //Port 1 Bit 0 Output Strength
   #define P1OS_1 0x02 //Port 1 Bit 1 Output Strength
   #define P1OS_2 0x04 //Port 1 Bit 2 Output Strength
   #define P1OS_3 0x08 //Port 1 Bit 3 Output Strength
SFR(P2M1, 0xB5); //             Port 2 Mode 1
   #define P2M1_0 0x01 //Port 2 Bit 0 Mode 1
   #define P2M1_1 0x02 //Port 2 Bit 1 Mode 1
   #define P2M1_2 0x04 //Port 2 Bit 2 Mode 1
   #define P2M1_3 0x08 //Port 2 Bit 3 Mode 1
   #define P2M1_4 0x10 //Port 2 Bit 4 Mode 1
   #define P2M1_5 0x20 //Port 2 Bit 5 Mode 1
   #define P2M1_6 0x40 //Port 2 Bit 6 Mode 1
   #define P2M1_7 0x80 //Port 2 Bit 7 Mode 1
SFR(P2S, 0xB5); //Page1         Port 2 Schmitt
   #define P2S_0 0x01 //Port 2 Bit 0 Schmitt
   #define P2S_1 0x02 //Port 2 Bit 1 Schmitt
   #define P2S_2 0x04 //Port 2 Bit 2 Schmitt
   #define P2S_3 0x08 //Port 2 Bit 3 Schmitt
   #define P2S_4 0x10 //Port 2 Bit 4 Schmitt
   #define P2S_5 0x20 //Port 2 Bit 5 Schmitt
   #define P2S_6 0x40 //Port 2 Bit 6 Schmitt
   #define P2S_7 0x80 //Port 2 Bit 7 Schmitt
SFR(P2M2, 0xB6); //             Port 2 Mode 2
   #define P2M2_0 0x01 //Port 2 Bit 0 Mode 2
   #define P2M2_1 0x02 //Port 2 Bit 1 Mode 2
   #define P2M2_2 0x04 //Port 2 Bit 2 Mode 2
   #define P2M2_3 0x08 //Port 2 Bit 3 Mode 2
   #define P2M2_4 0x10 //Port 2 Bit 4 Mode 2
   #define P2M2_5 0x20 //Port 2 Bit 5 Mode 2
   #define P2M2_6 0x40 //Port 2 Bit 6 Mode 2
   #define P2M2_7 0x80 //Port 2 Bit 7 Mode 2
SFR(IPH, 0xB7); //              Interrupt Priority High
   #define PX0H  0x01 //Priority eXternal 0 High
   #define PT0H  0x02 //Priority Timer 0 High
   #define PX1H  0x04 //Priority eXternal 1 High
   #define PT1H  0x08 //Priority Timer 1 High
   #define PSH   0x10 //Priority Serial High
   #define PBODH 0x20 //Priority Brown Out Detector High
   #define PADCH 0x40 //Priority Analog Digital Converter High
SFR(IP, 0xB8); //               Interrupt Priority
   SBIT(PX0,  0xB8, 0); //Priority External 0
   SBIT(PT0,  0xB8, 1); //Priority Timer 0
   SBIT(PX1,  0xB8, 2); //Priority External 1
   SBIT(PT1,  0xB8, 3); //Priority Timer 1
   SBIT(PS,   0xB8, 4); //Priority Serial
   SBIT(PBOD, 0xB8, 5); //Priority Brown Out Detection
   SBIT(PADC, 0xB8, 6); //Priority Analog Digital Converter
SFR(SADEN, 0xB9); //            Slave 0 Address Mask
SFR(SADEN_1, 0xBA); //          Slave 1 Address Mask
SFR(SADDR_1, 0xBB); //          Slave 1 Address
SFR(I2DAT, 0xBC); //            Inter-Integrated Circuit Data
SFR(I2STAT, 0xBD); //           Inter-Integrated Circuit Status
   #define I2STAT 0xF8 //Inter-Integrated Circuit Status
SFR(I2CLK, 0xBE); //            Inter-Integrated Circuit clock
SFR(I2TOC, 0xBF); //            Inter-Integrated Circuit Time-out Counter
   #define I2TOF   0x01 //Inter-Integrated Circuit Time-out Flag
   #define DIV     0x02 //Divider
   #define I2TOCEN 0x04 //Inter-Integrated Circuit Counter Enable
SFR(I2CON, 0xC0); //            Inter-Integrated Circuit control
   SBIT(AA,    0xC0, 2); //Acknowledge Assert
   SBIT(SI,    0xC0, 3); //Status Interrupt
   SBIT(STO,   0xC0, 4); //Stop
   SBIT(STA,   0xC0, 5); //Start
   SBIT(I2CEN, 0xC0, 6); //Inter-Integrated Circuit Enable
SFR(I2ADDR, 0xC1); //           Inter-Integrated Circuit Address
   #define GC     0x01 //General Call
   #define I2ADDR 0xFE //Inter-Integrated Circuit Address
SFR(ADCRL, 0xC2); //            Analog Digital Coverter Result Low
SFR(ADCRH, 0xC3); //            Analog Digital Coverter Result High
SFR(T3CON, 0xC4); //            Timer 3 Control
   #define T3PS    0x07 //Timer 3 Prescaler
   #define TR3     0x80 //Timer 3 Run
   #define TF3     0x10 //Timer 3 Flag
   #define BRCK    0x20 //Baud Rate Clock Source (UART-0)
   #define SMOD0_1 0x40 //Serial Mode 0 UART-1
   #define SMOD_1  0x80 //Serial Mode UART-1
SFR(R3L, 0xC5); //              Timer 3 Reload Low
SFR(R3H, 0xC6); //              Timer 3 Rload High
SFR(TA, 0xC7); //               Timed Access
SFR(T2CON, 0xC8); //            Timer 2 Control
   SBIT(TR2A, 0xC8, 0); //Timer 2A Run
   SBIT(TR2B, 0xC8, 1); //Timer 2B Run
   SBIT(TR2C, 0xC8, 2); //Timer 2C Run
   SBIT(TR2D, 0xC8, 3); //Timer 2D Run
   SBIT(TF2A, 0xC8, 4); //Timer 2A Flag
   SBIT(TF2B, 0xC8, 5); //Timer 2B Flag
   SBIT(TF2C, 0xC8, 6); //Timer 2C Flag
   SBIT(TF2D, 0xC8, 7); //Timer 2D Flag
SFR(T2MOD0, 0xC9); //           Timer 2 Mode 0
   #define T2APS 0x07 //Timer 2A Prescaler
   #define T2AM  0x08 //Timer 2A Mode
   #define T2BPS 0x70 //Timer 2B Prescaler
   #define T2BM  0x80 //Timer 2B Mode
SFR(T2MOD1, 0xCA); //           Timer 2 Mode 1
   #define T2CPS 0x07 //Timer 2C Prescaler
   #define T2CM  0x08 //Timer 2C Mode
   #define T2DPS 0x70 //Timer 2D Prescaler
   #define T2DM  0x80 //Timer 2D Mode
SFR(T2OE, 0xCB); //             Timer 2 Output Enable
   #define T2AOE1 0x01 //Timer 2A Output Enable 1
   #define T2AOE2 0x02 //Timer 2A Output Enable 2
   #define T2BOE1 0x04 //Timer 2B Output Enable 1
   #define T2BOE2 0x08 //Timer 2B Output Enable 2
   #define T2COE1 0x10 //Timer 2C Output Enable 1
   #define T2COE2 0x20 //Timer 2C Output Enable 2
   #define T2DOE1 0x40 //Timer 2D Output Enable 1
   #define T2DOE2 0x80 //Timer 2D Output Enable 2
SFR(R2AL, 0xCC); //             Reload 2A Low
SFR(R2AH, 0xCD); //             Reload 2A High
SFR(R2BL, 0xCE); //             Reload 2B Low
SFR(R2BH, 0xCF); //             Reload 2B High
SFR(PSW, 0xD0); //              Program Status Word
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry
SFR(R2CL, 0xD4); //             Reload 2C Low
SFR(R2CH, 0xD5); //             Reload 2C High
SFR(R2DL, 0xD6); //             Reload 2D Low
SFR(R2DH, 0xD7); //             Reload 2D High
SFR(P5, 0xD8); //               Port 5
   SBIT(STADC, 0xD8, 0); //Start Analog Digital Conversion
   SBIT(RXD_1, 0xD8, 6); //Receive Data 1
   SBIT(TXD_1, 0xD8, 7); //Transmit Data 1
   SBIT(P50, 0xD8, 0); //Port 5 Bit 0
   SBIT(P51, 0xD8, 1); //Port 5 Bit 1
   SBIT(P52, 0xD8, 2); //Port 5 Bit 2
   SBIT(P53, 0xD8, 3); //Port 5 Bit 3
   SBIT(P54, 0xD8, 4); //Port 5 Bit 4
   SBIT(P55, 0xD8, 5); //Port 5 Bit 5
   SBIT(P56, 0xD8, 6); //Port 5 Bit 6
   SBIT(P57, 0xD8, 7); //Port 5 Bit 7
   SBIT(P5_0, 0xD8, 0); //Port 5 Bit 0
   SBIT(P5_1, 0xD8, 1); //Port 5 Bit 1
   SBIT(P5_2, 0xD8, 2); //Port 5 Bit 2
   SBIT(P5_3, 0xD8, 3); //Port 5 Bit 3
   SBIT(P5_4, 0xD8, 4); //Port 5 Bit 4
   SBIT(P5_5, 0xD8, 5); //Port 5 Bit 5
   SBIT(P5_6, 0xD8, 6); //Port 5 Bit 6
   SBIT(P5_7, 0xD8, 7); //Port 5 Bit 7
SFR(P4, 0xD9); //(only byte addressable) Port 4
   #define P40 0x01 //Port 4 Bit 0
   #define P41 0x02 //Port 4 Bit 1
   #define P42 0x04 //Port 4 Bit 2
   #define P43 0x08 //Port 4 Bit 3
   #define P44 0x10 //Port 4 Bit 4
   #define P45 0x20 //Port 4 Bit 5
   #define P46 0x40 //Port 4 Bit 6
   #define P4_0 0x01 //Port 4 Bit 0
   #define P4_1 0x02 //Port 4 Bit 1
   #define P4_2 0x04 //Port 4 Bit 2
   #define P4_3 0x08 //Port 4 Bit 3
   #define P4_4 0x10 //Port 4 Bit 4
   #define P4_5 0x20 //Port 4 Bit 5
   #define P4_6 0x40 //Port 4 Bit 6
SFR(P4M1, 0xDA); //             Port 4 Mode 1
   #define P4M1_0 0x01 //Port 4 Bit 0 Mode 1
   #define P4M1_1 0x02 //Port 4 Bit 1 Mode 1
   #define P4M1_2 0x04 //Port 4 Bit 2 Mode 1
   #define P4M1_3 0x08 //Port 4 Bit 3 Mode 1
   #define P4M1_4 0x10 //Port 4 Bit 4 Mode 1
   #define P4M1_5 0x20 //Port 4 Bit 5 Mode 1
   #define P4M1_6 0x40 //Port 4 Bit 6 Mode 1
SFR(P4S, 0xDA); //Page1         Port 4 Schmitt
   #define P4S_0 0x01 //Port 4 Bit 0 Schmitt
   #define P4S_1 0x02 //Port 4 Bit 1 Schmitt
   #define P4S_2 0x04 //Port 4 Bit 2 Schmitt
   #define P4S_3 0x08 //Port 4 Bit 3 Schmitt
   #define P4S_4 0x10 //Port 4 Bit 4 Schmitt
   #define P4S_5 0x20 //Port 4 Bit 5 Schmitt
   #define P4S_6 0x40 //Port 4 Bit 6 Schmitt
SFR(P4M2, 0xDB); //             Port 4 Mode 2
   #define P4M2_0 0x01 //Port 4 Bit 0 Mode 2
   #define P4M2_1 0x02 //Port 4 Bit 1 Mode 2
   #define P4M2_2 0x04 //Port 4 Bit 2 Mode 2
   #define P4M2_3 0x08 //Port 4 Bit 3 Mode 2
   #define P4M2_4 0x10 //Port 4 Bit 4 Mode 2
   #define P4M2_5 0x20 //Port 4 Bit 5 Mode 2
   #define P4M2_6 0x40 //Port 4 Bit 6 Mode 2
SFR(P5M1, 0xDC); //             Port 5 Mode 1
   #define P5M1_0 0x01 //Port 5 Bit 0 Mode 1
   #define P5M1_1 0x02 //Port 5 Bit 1 Mode 1
   #define P5M1_2 0x04 //Port 5 Bit 2 Mode 1
   #define P5M1_3 0x08 //Port 5 Bit 3 Mode 1
   #define P5M1_4 0x10 //Port 5 Bit 4 Mode 1
   #define P5M1_5 0x20 //Port 5 Bit 5 Mode 1
   #define P5M1_6 0x40 //Port 5 Bit 6 Mode 1
   #define P5M1_7 0x80 //Port 5 Bit 7 Mode 1
SFR(P5S, 0xDC); //Page1         Port 5 Schmitt
   #define P5S_0 0x01 //Port 5 Bit 0 Schmitt
   #define P5S_1 0x02 //Port 5 Bit 1 Schmitt
   #define P5S_2 0x04 //Port 5 Bit 2 Schmitt
   #define P5S_3 0x08 //Port 5 Bit 3 Schmitt
   #define P5S_4 0x10 //Port 5 Bit 4 Schmitt
   #define P5S_5 0x20 //Port 5 Bit 5 Schmitt
   #define P5S_6 0x40 //Port 5 Bit 6 Schmitt
   #define P5S_7 0x80 //Port 5 Bit 7 Schmitt
SFR(P5M2, 0xDD); //             Port 5 Mode 2
   #define P5M2_0 0x01 //Port 5 Bit 0 Mode 2
   #define P5M2_1 0x02 //Port 5 Bit 1 Mode 2
   #define P5M2_2 0x04 //Port 5 Bit 2 Mode 2
   #define P5M2_3 0x08 //Port 5 Bit 3 Mode 2
   #define P5M2_4 0x10 //Port 5 Bit 4 Mode 2
   #define P5M2_5 0x20 //Port 5 Bit 5 Mode 2
   #define P5M2_6 0x40 //Port 5 Bit 6 Mode 2
   #define P5M2_7 0x80 //Port 5 Bit 7 Mode 2
SFR(ACC, 0xE0); //              Accumulator
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7
SFR(ADCCON1, 0xE1); //          Analog Digital Coverter Control 1
   #define ADCEN   0x01 //Analog Digital Coverter Enable
   #define ADCEX   0x02 //Analog Digital Coverter eXternal Trigger Select
   #define ADCDIV  0x70 //Analog Digital Coverter  Divider
SFR(ADCCON2, 0xE2); //          Analog Digital Coverter Control 2
   #define ADCMPO   0x10 //Analog Digital Coverter Comparator Output
   #define ADCMPEN  0x20 //Analog Digital Coverter Comparator Enable
   #define ADCMPOP  0x40 //Analog Digital Coverter Comparator Output Polarity
SFR(ADCMPL, 0xE3); //           Analog Digital Coverter Compare Low
SFR(ADCMPH, 0xE4); //           Analog Digital Coverter Compare High
SFR(LCDSEG0, 0xE5); //          Liquid Crystal Display Segment 0
   #define SEG0EN 0x01 //Segment 0 Enable
   #define SEG1EN 0x02 //Segment 1 Enable
   #define SEG2EN 0x04 //Segment 2 Enable
   #define SEG3EN 0x08 //Segment 3 Enable
   #define SEG4EN 0x10 //Segment 4 Enable
   #define SEG5EN 0x20 //Segment 5 Enable
   #define SEG6EN 0x40 //Segment 6 Enable
   #define SEG7EN 0x80 //Segment 7 Enable
SFR(LCDSEG1, 0xE6); //          Liquid Crystal Display Segment 1
   #define SEG8EN  0x01 //Segment 8 Enable
   #define SEG9EN  0x02 //Segment 9 Enable
   #define SEG10EN 0x04 //Segment 10 Enable
   #define SEG11EN 0x08 //Segment 11 Enable
   #define SEG12EN 0x10 //Segment 12 Enable
   #define SEG13EN 0x20 //Segment 13 Enable
   #define SEG14EN 0x40 //Segment 14 Enable
   #define SEG15EN 0x80 //Segment 15 Enable
SFR(LCDSEG2, 0xE7); //          Liquid Crystal Display Segment 2
   #define SEG16EN 0x01 //Segment 16 Enable
   #define SEG17EN 0x02 //Segment 17 Enable
   #define SEG18EN 0x04 //Segment 18 Enable
   #define SEG19EN 0x08 //Segment 19 Enable
   #define SEG20EN 0x10 //Segment 20 Enable
   #define SEG21EN 0x20 //Segment 21 Enable
   #define SEG22EN 0x40 //Segment 22 Enable
   #define SEG23EN 0x80 //Segment 23 Enable
SFR(ADCCON0, 0xE8); //          Liquid Crystal Display Segment 3
   SBIT(ADCHS0,  0xE8, 0); //Analog Digital Channel Select 0
   SBIT(ADCHS1,  0xE8, 1); //Analog Digital Channel Select 1
   SBIT(ADCHS2,  0xE8, 2); //Analog Digital Channel Select 2
   SBIT(ADCHS3,  0xE8, 3); //Analog Digital Channel Select 3
   SBIT(ADCS,    0xE8, 6); //Analog Digital Converter Start
   SBIT(ADCF,    0xE8, 7); //Analog Digital Converter Flag
SFR(PICON, 0xE9); //            Pin Interrupt Control
   #define PIPS 0x07 //Pin Interrupt Port Select
SFR(PINEN, 0xEA); //            Pin interrupt low level/falling edge enable
   #define PINEN0 0x01 //Pin Interrupt 0 Negative Polarity Enable
   #define PINEN1 0x02 //Pin Interrupt 1 Negative Polarity Enable
   #define PINEN2 0x04 //Pin Interrupt 2 Negative Polarity Enable
   #define PINEN3 0x08 //Pin Interrupt 3 Negative Polarity Enable
   #define PINEN4 0x10 //Pin Interrupt 4 Negative Polarity Enable
   #define PINEN5 0x20 //Pin Interrupt 5 Negative Polarity Enable
   #define PIN3N6 0x40 //Pin Interrupt 6 Negative Polarity Enable
   #define PINEN7 0x80 //Pin Interrupt 7 Negative Polarity Enable
SFR(PIPEN, 0xEB); //            Pin interrupt high level/rising edge enable
   #define PIPEN0 0x01 //Pin Interrupt 0 Positive Polarity Enable
   #define PIPEN1 0x02 //Pin Interrupt 1 Positive Polarity Enable
   #define PIPEN2 0x04 //Pin Interrupt 2 Positive Polarity Enable
   #define PIPEN3 0x08 //Pin Interrupt 3 Positive Polarity Enable
   #define PIPEN4 0x10 //Pin Interrupt 4 Positive Polarity Enable
   #define PIPEN5 0x20 //Pin Interrupt 5 Positive Polarity Enable
   #define PIP3N6 0x40 //Pin Interrupt 6 Positive Polarity Enable
   #define PIPEN7 0x80 //Pin Interrupt 7 Positive Polarity Enable
SFR(PIF, 0xEC); //              Pin interrupt flag
   #define PIF0 0x01 //Pin Interrupt Flag Channel 0
   #define PIF1 0x02 //Pin Interrupt Flag Channel 1
   #define PIF2 0x04 //Pin Interrupt Flag Channel 2
   #define PIF3 0x08 //Pin Interrupt Flag Channel 3
   #define PIF4 0x10 //Pin Interrupt Flag Channel 4
   #define PIF5 0x20 //Pin Interrupt Flag Channel 5
   #define PIF6 0x40 //Pin Interrupt Flag Channel 6
   #define PIF7 0x80 //Pin Interrupt Flag Channel 7
SFR(PITYP, 0xED); //            Pin Interrupt Type
   #define PIT0 0x01 //Pin Interrupt 0 Type
   #define PIT1 0x02 //Pin Interrupt 1 Type
   #define PIT2 0x04 //Pin Interrupt 2 Type
   #define PIT3 0x08 //Pin Interrupt 3 Type
   #define PIT4 0x10 //Pin Interrupt 4 Type
   #define PIT5 0x20 //Pin Interrupt 5 Type
   #define PIT6 0x40 //Pin Interrupt 6 Type
   #define PIT7 0x80 //Pin Interrupt 7 Type
SFR(LCDSEG3, 0xEE);
   #define SEG24EN 0x01 //Segment 24 Enable
   #define SEG25EN 0x02 //Segment 25 Enable
   #define SEG26EN 0x04 //Segment 26 Enable
   #define SEG27EN 0x08 //Segment 27 Enable
   #define SEG28EN 0x10 //Segment 28 Enable
   #define SEG29EN 0x20 //Segment 29 Enable
   #define SEG30EN 0x40 //Segment 30 Enable
   #define SEG31EN 0x80 //Segment 31 Enable
SFR(EIP, 0xEF); //              Extensive interrupt priority
   #define PI2C 0x01 //Priority Inter-Integrated Circuit
   #define PPI  0x02 //Priority Pin Interrupt
   #define PT2A 0x04 //Priority Timer 2A
   #define PT2B 0x08 //Priority Timer 2B
   #define PWDT 0x10 //Priority Watchdog Timer
   #define PT2C 0x20 //Priority Timer 2C
   #define PT2D 0x80 //Priority Timer 2D
SFR(B, 0xF0); //                B register
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7
SFR(ADCAQT, 0xF2); //           Analog Digital Converter Acquisition Time
SFR(P0DIDS, 0xF6); //           Port 0 Digital Input Disconnect
   #define P00DIDS 0x01 //Port 0 Bit 0 Digital Input Disable
   #define P01DIDS 0x02 //Port 0 Bit 1 Digital Input Disable
   #define P02DIDS 0x04 //Port 0 Bit 2 Digital Input Disable
   #define P03DIDS 0x08 //Port 0 Bit 3 Digital Input Disable
   #define P04DIDS 0x10 //Port 0 Bit 4 Digital Input Disable
   #define P05DIDS 0x20 //Port 0 Bit 5 Digital Input Disable
   #define P06DIDS 0x40 //Port 0 Bit 6 Digital Input Disable
   #define P07DIDS 0x80 //Port 0 Bit 7 Digital Input Disable
SFR(EIPH, 0xF7); //             Extensive Interrupt Priority High
   #define PI2CH 0x01 //Priority Inter-Integrated Circuit High
   #define PPIH  0x02 //Priority Pin Interrupt High
   #define PT2AH 0x04 //Priority Timer 2A High
   #define PT2BH 0x08 //Priority Timer 2B High
   #define PWDTH 0x10 //Priority Watchdog Timer High
   #define PT2CH 0x20 //Priority Timer 2C High
   #define PT2DH 0x80 //Priority Timer 2D High
SFR(SCON_1, 0xF8); //           Serial port 1 control
   SBIT(RI_1,  0xF8, 0); //Receive Interrupt 1
   SBIT(TI_1,  0xF8, 1); //Transmit Interrupt 1
   SBIT(RB8_1, 0xF8, 2); //Receive Bit 8 1
   SBIT(TB8_1, 0xF8, 3); //Transmit Bit 8 1
   SBIT(REN_1, 0xF8, 4); //Receive Enable 1
   SBIT(SM2_1, 0xF8, 5); //Serial Mode 2 1
   SBIT(SM1_1, 0xF8, 6); //Serial Mode 1 1
   SBIT(SM0_1, 0xF8, 7); //(WR)Serial Mode 0 1
   SBIT(FE_1,  0xF8, 7); //(RD)Framing Error 1
SFR(LCDCON, 0xF9); //           Liquid Crystal Display Control
   #define RSEL    0x03 //Resistor Select
   #define DUTY    0x0C //Duty
   #define BIAS    0x10 //Bias
   #define VLCDADJ 0x40 //Liquid Crystal Display Voltage Adjust
   #define LCDEN   0x80 //Liquid Crystal Display Enable
SFR(LCDCLK, 0xFA); //           Liquid Crystal Display Clock
   #define LCDDIV 0x07 //Liquid Crystal Display clock Divider
   #define LCDCKS 0x30 //Liquid Crystal Display Clock Source
SFR(LCDPTR, 0xFB); //           Liquid Crystal Display  Data Pointer
SFR(LCDDAT, 0xFC); //Page0      Liquid Crystal Display Data
SFR(EIP1, 0xFE); //             Extensive Interrupt Priority 1
   #define PS_1 0x01 //Priority Serial Port 1 low
   #define PT3  0x02 //Priority Timer 3 low
   #define PWKT 0x04 //Priority Wake-up Timer low
SFR(EIPH1, 0xFF); //            Extensive Interrupt Priority High 1
   #define PSH_1 0x01 //Priority Serial port 1 high
   #define PT3H  0x02 //Priority Timer 3 high
   #define PWKTH 0x04 //Priority Wake-up Timer high

// Interrupt numbers: Address = ( Number * 8 ) + 3
// Vectors are named after their corresponding interrupt
// enable register bit, so that we don't have to make up
// names and can be consisten across different 8051 MCUs
   #define X0_VECTOR   0 // 0x03 External Interrupt 0
   #define T0_VECTOR   1 // 0x0B Timer 0
   #define X1_VECTOR   2 // 0x13 External Interrupt 1
   #define T1_VECTOR   3 // 0x1B Timer 1
   #define S_VECTOR    4 // 0x23 Serial Port 0
   #define T2_VECTOR   5 // 0x2B Timer 2
   #define I2C_VECTOR 6  // 0x33 Inter-Integrated Circuit
   #define PI_VECTOR   7 // 0x3B Pin Interrupt
   #define BOD_VECTOR  8 // 0x43 Brown-out
   //       -          9 // 0x4B       -
   #define WDT_VECTOR 10 // 0x53 Watchdog Timer
   #define ADC_VECTOR 11 // 0x5B Analog Digital Converter
   #define T2B_VECTOR 12 // 0x63 Timer 2B
   #define T2C_VECTOR 13 // 0x6B Timer 2C
   #define T2D_VECTOR 14 // 0x73 Timer 2D
   #define S1_VECTOR  15 // 0x7B Serial Port 1
   #define T3_VECTOR  16 // 0x83 Timer 3
   #define WKT_VECTOR 17 // 0x8B Self Wake-up Timer

#endif