// PlatformIO compatible header file N78E05.h 20210823.
// For Nuvoton N78E055A N78E059A.

#ifndef N78E05_H
#define N78E05_H
#include <compiler.h>

SFR(P0, 0x80);
   SBIT(P00, 0x80, 0); //Port 0 Bit 0
   SBIT(P01, 0x80, 1); //Port 0 Bit 1
   SBIT(P02, 0x80, 2); //Port 0 Bit 2
   SBIT(P03, 0x80, 3); //Port 0 Bit 3
   SBIT(P04, 0x80, 4); //Port 0 Bit 4
   SBIT(P05, 0x80, 5); //Port 0 Bit 5
   SBIT(P06, 0x80, 6); //Port 0 Bit 6
   SBIT(P07, 0x80, 7); //Port 0 Bit 7
   SBIT(P0_0, 0x80, 0); //Port 0 Bit 0
   SBIT(P0_1, 0x80, 1); //Port 0 Bit 1
   SBIT(P0_2, 0x80, 2); //Port 0 Bit 2
   SBIT(P0_3, 0x80, 3); //Port 0 Bit 3
   SBIT(P0_4, 0x80, 4); //Port 0 Bit 4
   SBIT(P0_5, 0x80, 5); //Port 0 Bit 5
   SBIT(P0_6, 0x80, 6); //Port 0 Bit 6
   SBIT(P0_7, 0x80, 7); //Port 0 Bit 7
SFR(SP, 0x81);
SFR(DPTR, 0x82);
SFR(DPL,  0x82);
SFR(DPH, 0x83);
SFR(P0OR, 0x86);
SFR(PCON, 0x87);
SFR(TCON, 0x88);
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag
SFR(TMOD, 0x89);
SFR(TL0, 0x8A);
SFR(TL1, 0x8B);
SFR(TH0, 0x8C);
SFR(TH1, 0x8D);
SFR(AUXR, 0x8E);
SFR(P1, 0x90);
   SBIT(T2,   0x90, 0); //Timer 2
   SBIT(T2EX, 0x90, 1); //Timer 2 Extra
   SBIT(P10, 0x90, 0); //Port 1 Bit 0
   SBIT(P11, 0x90, 1); //Port 1 Bit 1
   SBIT(P12, 0x90, 2); //Port 1 Bit 2
   SBIT(P13, 0x90, 3); //Port 1 Bit 3
   SBIT(P14, 0x90, 4); //Port 1 Bit 4
   SBIT(P15, 0x90, 5); //Port 1 Bit 5
   SBIT(P16, 0x90, 6); //Port 1 Bit 6
   SBIT(P17, 0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
SFR(RSR, 0x96);
SFR(IRCCAL, 0x97);
SFR(SCON, 0x98);
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //(WR)Serial Mode 0
   SBIT(FE,  0x98, 7); //(RD)Framing Error
SFR(SBUF, 0x99);
SFR(CHPCON, 0x9F);
SFR(P2, 0xA0);
   SBIT(P20, 0xA0, 0); //Port 2 Bit 0
   SBIT(P21, 0xA0, 1); //Port 2 Bit 1
   SBIT(P22, 0xA0, 2); //Port 2 Bit 2
   SBIT(P23, 0xA0, 3); //Port 2 Bit 3
   SBIT(P24, 0xA0, 4); //Port 2 Bit 4
   SBIT(P25, 0xA0, 5); //Port 2 Bit 5
   SBIT(P26, 0xA0, 6); //Port 2 Bit 6
   SBIT(P27, 0xA0, 7); //Port 2 Bit 7
   SBIT(P2_0, 0xA0, 0); //Port 2 Bit 0
   SBIT(P2_1, 0xA0, 1); //Port 2 Bit 1
   SBIT(P2_2, 0xA0, 2); //Port 2 Bit 2
   SBIT(P2_3, 0xA0, 3); //Port 2 Bit 3
   SBIT(P2_4, 0xA0, 4); //Port 2 Bit 4
   SBIT(P2_5, 0xA0, 5); //Port 2 Bit 5
   SBIT(P2_6, 0xA0, 6); //Port 2 Bit 6
   SBIT(P2_7, 0xA0, 7); //Port 2 Bit 7
SFR(XRAMAH, 0xA1);
SFR(ISPTRG, 0xA4);
SFR(ISPAL, 0xA6);
SFR(ISPAH, 0xA7);
SFR(IE, 0xA8);
   SBIT(EX0,  0xA8, 0); //Enable External 0
   SBIT(ET0,  0xA8, 1); //Enable Timer 0
   SBIT(EX1,  0xA8, 2); //Enable External 1
   SBIT(ET1,  0xA8, 3); //Enable Timer 1
   SBIT(ES,   0xA8, 4); //Enable Serial
   SBIT(ET2,  0xA8, 5); //Enable Timer 2
   SBIT(EADC, 0xA8, 6); //Enable ADC
   SBIT(EA,   0xA8, 7); //Enable All
SFR(WDCON, 0xAA);
SFR(PDCON, 0xAB);
SFR(PMC, 0xAC);
SFR(ISPFD, 0xAE);
SFR(ISPCN, 0xAF);
SFR(P3, 0xB0);
   SBIT(RXD,  0xB0, 0); //Receive Data
   SBIT(TXD,  0xB0, 1); //Transmit Data
   SBIT(INT0, 0xB0, 2); //Interrupt 0
   SBIT(INT1, 0xB0, 3); //Interrupt 1
   SBIT(T0,   0xB0, 4); //Timer 0
   SBIT(T1,   0xB0, 5); //Timer 1
   SBIT(WR,   0xB0, 6); //Write
   SBIT(RD,   0xB0, 7); //Read
   SBIT(P30, 0xB0, 0); //Port 3 Bit 0
   SBIT(P31, 0xB0, 1); //Port 3 Bit 1
   SBIT(P32, 0xB0, 2); //Port 3 Bit 2
   SBIT(P33, 0xB0, 3); //Port 3 Bit 3
   SBIT(P34, 0xB0, 4); //Port 3 Bit 4
   SBIT(P35, 0xB0, 5); //Port 3 Bit 5
   SBIT(P36, 0xB0, 6); //Port 3 Bit 6
   SBIT(P37, 0xB0, 7); //Port 3 Bit 7
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_1, 0xB0, 1); //Port 3 Bit 1
   SBIT(P3_2, 0xB0, 2); //Port 3 Bit 2
   SBIT(P3_3, 0xB0, 3); //Port 3 Bit 3
   SBIT(P3_4, 0xB0, 4); //Port 3 Bit 4
   SBIT(P3_5, 0xB0, 5); //Port 3 Bit 5
   SBIT(P3_6, 0xB0, 6); //Port 3 Bit 6
   SBIT(P3_7, 0xB0, 7); //Port 3 Bit 7
SFR(IP, 0xB8);
   SBIT(PX0,  0xB8, 0); //Priority External 0
   SBIT(PT0,  0xB8, 1); //Priority Timer 0
   SBIT(PX1,  0xB8, 2); //Priority External 1
   SBIT(PT1,  0xB8, 3); //Priority Timer 1
   SBIT(PS,   0xB8, 4); //Priority Serial
   SBIT(PT2,  0xB8, 5); //Priority Timer 2
   SBIT(PADC, 0xB8, 6); //Priority ADC
SFR(IPH, 0xBA);
SFR(EIPH, 0xBB);
SFR(EIP, 0xBC);
SFR(EIE, 0xBD);
SFR(XICON, 0xC0);
   SBIT(IT2, 0xC0, 0); //Interrupt Type 2
   SBIT(IE2, 0xC0, 1); //Interrupt Edge 2
   SBIT(EX2, 0xC0, 2); //Enable eXternal 2
   SBIT(PX2, 0xC0, 3); //Priority eXternal 2
   SBIT(IT3, 0xC0, 4); //Interrupt Type 3
   SBIT(IE3, 0xC0, 5); //Interrupt Edge 3
   SBIT(EX3, 0xC0, 6); //Enable eXternal 3
   SBIT(PX3, 0xC0, 7); //Priority eXternal 3
SFR(TA, 0xC7);
SFR(T2CON, 0xC8);
   SBIT(CP_RL2, 0xC8, 0); //Capture Reload 2
   SBIT(C_T2,   0xC8, 1); //Counter Timer 2
   SBIT(TR2,    0xC8, 2); //Timer 2 Run
   SBIT(EXEN2,  0xC8, 3); //External Enable 2
   SBIT(TCLK,   0xC8, 4); //Transmit Clock
   SBIT(RCLK,   0xC8, 5); //Receive Clock
   SBIT(EXF2,   0xC8, 6); //External Flag 2
   SBIT(TF2,    0xC8, 7); //Timer 2 Flag
SFR(T2MOD, 0xC9);
SFR(RCAP2L, 0xCA);
SFR(RCAP2H, 0xCB);
SFR(TL2, 0xCC);
SFR(TH2, 0xCD);
SFR(PWMCON1, 0xCE);
SFR(PWM4, 0xCF);
SFR(PSW, 0xD0);
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry
SFR(P4, 0xD8);
   SBIT(INT3, 0xD8, 2); //Interrupt 3
   SBIT(INT2, 0xD8, 3); //Interrupt 4
   SBIT(P40, 0xD8, 0); //Port 4 Bit 0
   SBIT(P41, 0xD8, 1); //Port 4 Bit 1
   SBIT(P42, 0xD8, 2); //Port 4 Bit 2
   SBIT(P43, 0xD8, 3); //Port 4 Bit 3
   SBIT(P44, 0xD8, 4); //Port 4 Bit 4
   SBIT(P45, 0xD8, 5); //Port 4 Bit 5
   SBIT(P46, 0xD8, 6); //Port 4 Bit 6
   SBIT(P47, 0xD8, 7); //Port 4 Bit 7
   SBIT(P4_0, 0xD8, 0); //Port 4 Bit 0
   SBIT(P4_1, 0xD8, 1); //Port 4 Bit 1
   SBIT(P4_2, 0xD8, 2); //Port 4 Bit 2
   SBIT(P4_3, 0xD8, 3); //Port 4 Bit 3
   SBIT(P4_4, 0xD8, 4); //Port 4 Bit 4
   SBIT(P4_5, 0xD8, 5); //Port 4 Bit 5
   SBIT(P4_6, 0xD8, 6); //Port 4 Bit 6
   SBIT(P4_7, 0xD8, 7); //Port 4 Bit 7
SFR(PWMP, 0xD9);
SFR(PWM0, 0xDA);
SFR(PWM1, 0xDB);
SFR(PWMCON0, 0xDC);
SFR(PWM2, 0xDD);
SFR(PWM3, 0xDE);
SFR(ACC, 0xE0);
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7
SFR(B, 0xF0);
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7
SFR(SPCR, 0xF3);
SFR(SPSR, 0xF4);
SFR(SPDR, 0xF5);

#endif