// PlatformIO compatible header file N79E85.h 20210823.
// For Nuvoton N79E855 N79E854.

#ifndef N79E85_H
#define N79E85_H
#include <compiler.h>

SFR(P0, 0x80);
   SBIT(P00, 0x80, 0); //Port 0 Bit 0
   SBIT(P01, 0x80, 1); //Port 0 Bit 1
   SBIT(P02, 0x80, 2); //Port 0 Bit 2
   SBIT(P03, 0x80, 3); //Port 0 Bit 3
   SBIT(P04, 0x80, 4); //Port 0 Bit 4
   SBIT(P05, 0x80, 5); //Port 0 Bit 5
   SBIT(P06, 0x80, 6); //Port 0 Bit 6
   SBIT(P07, 0x80, 7); //Port 0 Bit 7
   SBIT(P0_0, 0x80, 0); //Port 0 Bit 0
   SBIT(P0_1, 0x80, 1); //Port 0 Bit 1
   SBIT(P0_2, 0x80, 2); //Port 0 Bit 2
   SBIT(P0_3, 0x80, 3); //Port 0 Bit 3
   SBIT(P0_4, 0x80, 4); //Port 0 Bit 4
   SBIT(P0_5, 0x80, 5); //Port 0 Bit 5
   SBIT(P0_6, 0x80, 6); //Port 0 Bit 6
   SBIT(P0_7, 0x80, 7); //Port 0 Bit 7
SFR(SP, 0x81);
SFR(DPTR, 0x82);
SFR(DPL,  0x82);
SFR(DPH, 0x83);
SFR(PCON, 0x87);
SFR(TCON, 0x88);
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag
SFR(TMOD, 0x89);
SFR(TL0, 0x8A);
SFR(TL1, 0x8B);
SFR(TH0, 0x8C);
SFR(TH1, 0x8D);
SFR(CKCON, 0x8E);
SFR(P1, 0x90);
   SBIT(TXD,  0x90, 0); //Transmit Data
   SBIT(RXD,  0x90, 1); //Receive Data
   SBIT(SCL,  0x90, 2); //Serial Clock
   SBIT(T0,   0x90, 2); //Timer 0
   SBIT(INT0, 0x90, 3); //Interrupt 0
   SBIT(SDA,  0x90, 3); //Serial Data
   SBIT(INT1, 0x90, 4); //Interrupt 1
   SBIT(PWM1, 0x90, 6); //Pulse Width Modulator 1
   SBIT(PWM2, 0x90, 7); //Pulse Width Modulator 2
   SBIT(P10, 0x90, 0); //Port 1 Bit 0
   SBIT(P11, 0x90, 1); //Port 1 Bit 1
   SBIT(P12, 0x90, 2); //Port 1 Bit 2
   SBIT(P13, 0x90, 3); //Port 1 Bit 3
   SBIT(P14, 0x90, 4); //Port 1 Bit 4
   SBIT(P15, 0x90, 5); //Port 1 Bit 5
   SBIT(P16, 0x90, 6); //Port 1 Bit 6
   SBIT(P17, 0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
SFR(CAPCON0, 0x92);
SFR(CAPCON1, 0x93);
SFR(CAPCON2, 0x94);
SFR(DIVM, 0x95);
SFR(P3M1, 0x96);
SFR(P3M2, 0x97);
SFR(SCON, 0x98);
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //(WR)Serial Mode 0
   SBIT(FE,  0x98, 7); //(RD)Framing Error
SFR(SBUF, 0x99);
SFR(SHBDA, 0x9C); //TA protect
SFR(CHPCON, 0x9F); //TA protect
SFR(P2, 0xA0);
   SBIT(TXD2, 0xA0, 6); //Transmit Data 2
   SBIT(RXD2, 0xA0, 7); //Receive Data 2
   SBIT(P20, 0xA0, 0); //Port 2 Bit 0
   SBIT(P21, 0xA0, 1); //Port 2 Bit 1
   SBIT(P22, 0xA0, 2); //Port 2 Bit 2
   SBIT(P23, 0xA0, 3); //Port 2 Bit 3
   SBIT(P24, 0xA0, 4); //Port 2 Bit 4
   SBIT(P25, 0xA0, 5); //Port 2 Bit 5
   SBIT(P26, 0xA0, 6); //Port 2 Bit 6
   SBIT(P2_0, 0xA0, 0); //Port 2 Bit 0
   SBIT(P2_1, 0xA0, 1); //Port 2 Bit 1
   SBIT(P2_2, 0xA0, 2); //Port 2 Bit 2
   SBIT(P2_3, 0xA0, 3); //Port 2 Bit 3
   SBIT(P2_4, 0xA0, 4); //Port 2 Bit 4
   SBIT(P2_5, 0xA0, 5); //Port 2 Bit 5
   SBIT(P2_6, 0xA0, 6); //Port 2 Bit 6
SFR(AUXR1, 0xA2);
SFR(PMCR, 0xA3); //TA protect
SFR(ISPTRG, 0xA4); //TA protect
SFR(ISPAL, 0xA6);
SFR(ISPAH, 0xA7);
SFR(IE, 0xA8);
   SBIT(EX0,  0xA8, 0); //Enable External 0
   SBIT(ET0,  0xA8, 1); //Enable Timer 0
   SBIT(EX1,  0xA8, 2); //Enable External 1
   SBIT(ET1,  0xA8, 3); //Enable Timer 1
   SBIT(ES,   0xA8, 4); //Enable Serial
   SBIT(EBO,  0xA8, 5); //Enable Brown Out Detect
   SBIT(EBOD, 0xA8, 5); //Enable Brown Out Detect
   SBIT(EADC, 0xA8, 6); //Enable ADC
   SBIT(EA,   0xA8, 7); //Enable All
SFR(SADDR, 0xA9);
SFR(WDCON1, 0xAB); //TA protect
SFR(ISPFD, 0xAE);
SFR(ISPCN, 0xAF);
SFR(P3, 0xB0);
   SBIT(CLKOUT, 0xB0, 0); //Clock Out
   SBIT(P30, 0xB0, 0); //Port 3 Bit 0
   SBIT(P31, 0xB0, 1); //Port 3 Bit 1
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_1, 0xB0, 1); //Port 3 Bit 1
SFR(P0M1, 0xB1);
SFR(P0M2, 0xB2);
SFR(P1M1, 0xB3);
SFR(P1M2, 0xB4);
SFR(P2M1, 0xB5);
SFR(P2M2, 0xB6);
SFR(IPH, 0xB7);
SFR(IP, 0xB8);
   SBIT(PX0,  0xB8, 0); //Priority External 0
   SBIT(PT0,  0xB8, 1); //Priority Timer 0
   SBIT(PX1,  0xB8, 2); //Priority External 1
   SBIT(PT1,  0xB8, 3); //Priority Timer 1
   SBIT(PS,   0xB8, 4); //Priority Serial
   SBIT(PBO,  0xB8, 5); //Priority Brown Out Detect
   SBIT(PBOD, 0xB8, 5); //Priority Brown Out Detect
   SBIT(PADC, 0xB8, 6); //Priority ADC
   SBIT(PCAP, 0xB8, 7); //Priority Input Capture
SFR(SADEN, 0xB9);
SFR(I2DAT, 0xBC);
SFR(I2STA, 0xBD);
SFR(I2CLK, 0xBE);
SFR(I2TOC, 0xBF);
SFR(I2CON, 0xC0);
   SBIT(AA,    0xC0, 2); //Acknowledge Assert
   SBIT(SI,    0xC0, 3); //Status Interrupt
   SBIT(STO,   0xC0, 4); //Stop
   SBIT(STA,   0xC0, 5); //Start
   SBIT(I2CEN, 0xC0, 6); //Inter-Integrated Circuit Enable
SFR(I2ADDR, 0xC1);
SFR(TA, 0xC7);
SFR(T2CON, 0xC8);
   SBIT(CP_RL2, 0xC8, 0); //Capture Reload
   SBIT(TR2,    0xC8, 2); //Timer 2 Run
   SBIT(TF2,    0xC8, 7); //Timer 2 Flag
SFR(T2MOD, 0xC9);
SFR(RCOMP2L, 0xCA);
SFR(RCOMP2H, 0xCB);
SFR(TL2, 0xCC);
SFR(TH2, 0xCD);
SFR(PSW, 0xD0);
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry
SFR(PWMPH, 0xD1);
SFR(PWM0H, 0xD2);
SFR(PWM1H, 0xD3);
SFR(PWM2H, 0xD5);
SFR(PWM3H, 0xD6);
SFR(PWMCON2, 0xD7);
SFR(WDCON0, 0xD8); //TA protect
   SBIT(WPS0,  0xD8, 0); //Watchdog Prescaler Select 0
   SBIT(WPS1,  0xD8, 1); //Watchdog Prescaler Select 1
   SBIT(WPS2,  0xD8, 2); //Watchdog Prescaler Select 2
   SBIT(WDTRF, 0xD8, 3); //Watchdog Timer Reset Flag
   SBIT(WIDPD, 0xD8, 4); //Watchdog Idle & Power Down
   SBIT(WDTF,  0xD8, 5); //Watchdog Time-out Flag
   SBIT(WDCLR, 0xD8, 6); //Watchdog Clear
   SBIT(WDTEN, 0xD8, 7); //Watchdog Timer Enable
SFR(PWMPL, 0xD9);
SFR(PWM0L, 0xDA);
SFR(PWM1L, 0xDB);
SFR(PWMCON0, 0xDC);
SFR(PWM2L, 0xDD);
SFR(PWM3L, 0xDE);
SFR(PWMCON1, 0xDF);
SFR(ACC, 0xE0);
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7
SFR(ADCCON1, 0xE1);
SFR(ADCH, 0xE2);
SFR(C0L, 0xE4);
SFR(C0H, 0xE5);
SFR(C1L, 0xE6);
SFR(C1H, 0xE7);
SFR(EIE, 0xE8);
   SBIT(EI2C,  0xE8, 0); //Enable Inter-Integrated Circuit
   SBIT(EKB,   0xE8, 1); //Enable Keyboard
   SBIT(ECPTF, 0xE8, 2); //Enable Capture Flag
   SBIT(EWDI,  0xE8, 4); //Enable Watchdog Interrupt
   SBIT(EPWM,  0xE8, 5); //Enable Pulse Width Modulator
   SBIT(ESPI,  0xE8, 6); //Enable Serial Peripheral Interface
   SBIT(ET2,   0xE8, 7); //Enable Timer 2
SFR(KBIE, 0xE9);
SFR(KBIF, 0xEA);
SFR(KBLS0, 0xEB);
SFR(KBLS1, 0xEC);
SFR(C2L, 0xED);
SFR(C2H, 0xEE);
SFR(B, 0xF0);
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7
SFR(SPCR, 0xF3);
SFR(SPSR, 0xF4);
SFR(SPDR, 0xF5);
SFR(P0DIDS, 0xF6);
SFR(EIPH, 0xF7);
SFR(ADCCON0, 0xF8);
   SBIT(AADR0, 0xF8, 0); //Analog Address 0
   SBIT(AADR1, 0xF8, 1); //Analog Address 1
   SBIT(AADR2, 0xF8, 2); //Analog Address 2
   SBIT(ADCS,  0xF8, 3); //ADC Start & Status
   SBIT(ADCI,  0xF8, 4); //ADC Interrupt Flag
   SBIT(ADCEX, 0xF8, 5); //ADC External Start Enable
   SBIT(ADC0,  0xF8, 6); //ADC Result Low Bit 0
   SBIT(ADC1,  0xF8, 7); //ADC Result Low Bit 1
   #define ADCL 0xC0      //ADC Result Low 2-bits
SFR(EIP, 0xFF);

#endif