// PlatformIO compatible header file W79Ex051.h 20210823.
// For Nuvoton W79E4051 W79E2051.

#ifndef W79Ex051_H
#define W79Ex051_H
#include <compiler.h>

SFR(SP, 0x81);
SFR(DPTR, 0x82);
SFR(DPL,  0x82);
SFR(DPH, 0x83);
SFR(PCON, 0x87);
SFR(TCON, 0x88);
   SBIT(IT0, 0x88, 0); //Interrupt 0 Type
   SBIT(IE0, 0x88, 1); //Interrupt 0 Edge
   SBIT(IT1, 0x88, 2); //Interrupt 1 Type
   SBIT(IE1, 0x88, 3); //Interrupt 1 Edge
   SBIT(TR0, 0x88, 4); //Timer 0 Run
   SBIT(TF0, 0x88, 5); //Timer 0 Flag
   SBIT(TR1, 0x88, 6); //Timer 1 Run
   SBIT(TF1, 0x88, 7); //Timer 1 Flag
SFR(TMOD, 0x89);
SFR(TL0, 0x8A);
SFR(TL1, 0x8B);
SFR(TH0, 0x8C);
SFR(TH1, 0x8D);
SFR(CKCON, 0x8E);
SFR(CLKREG, 0x8F);
SFR(P1, 0x90);
   SBIT(P10, 0x90, 0); //Port 1 Bit 0
   SBIT(P11, 0x90, 1); //Port 1 Bit 1
   SBIT(P12, 0x90, 2); //Port 1 Bit 2
   SBIT(P13, 0x90, 3); //Port 1 Bit 3
   SBIT(P14, 0x90, 4); //Port 1 Bit 4
   SBIT(P15, 0x90, 5); //Port 1 Bit 5
   SBIT(P16, 0x90, 6); //Port 1 Bit 6
   SBIT(P17, 0x90, 7); //Port 1 Bit 7
   SBIT(P1_0, 0x90, 0); //Port 1 Bit 0
   SBIT(P1_1, 0x90, 1); //Port 1 Bit 1
   SBIT(P1_2, 0x90, 2); //Port 1 Bit 2
   SBIT(P1_3, 0x90, 3); //Port 1 Bit 3
   SBIT(P1_4, 0x90, 4); //Port 1 Bit 4
   SBIT(P1_5, 0x90, 5); //Port 1 Bit 5
   SBIT(P1_6, 0x90, 6); //Port 1 Bit 6
   SBIT(P1_7, 0x90, 7); //Port 1 Bit 7
SFR(ACCK, 0x96);
SFR(ACSR, 0x97);
SFR(SCON, 0x98);
   SBIT(RI,  0x98, 0); //Receive Interrupt
   SBIT(TI,  0x98, 1); //Transmit Interrupt
   SBIT(RB8, 0x98, 2); //Receive Bit 8
   SBIT(TB8, 0x98, 3); //Transmit Bit 8
   SBIT(REN, 0x98, 4); //Receive Enable
   SBIT(SM2, 0x98, 5); //Serial Mode 2
   SBIT(SM1, 0x98, 6); //Serial Mode 1
   SBIT(SM0, 0x98, 7); //(WR)Serial Mode 0
   SBIT(FE,  0x98, 7); //(RD)Framing Error
SFR(SBUF, 0x99);
SFR(P2, 0xA0);
   SBIT(P20, 0xA0, 0); //Port 2 Bit 0
   SBIT(P21, 0xA0, 1); //Port 2 Bit 1
   SBIT(P2_0, 0xA0, 0); //Port 2 Bit 0
   SBIT(P2_1, 0xA0, 1); //Port 2 Bit 1
SFR(AUXR1, 0xA2);
SFR(AUXR2, 0xA3);
SFR(IE, 0xA8);
   SBIT(EX0, 0xA8, 0); //Enable External 0
   SBIT(ET0, 0xA8, 1); //Enable Timer 0
   SBIT(EX1, 0xA8, 2); //Enable External 1
   SBIT(ET1, 0xA8, 3); //Enable Timer 1
   SBIT(ES,  0xA8, 4); //Enable Serial
   SBIT(EC,  0xA8, 6); //Enable Comparator
   SBIT(ECM, 0xA8, 6); //Enable Comparator
   SBIT(EA,  0xA8, 7); //Enable All
SFR(SADDR, 0xA9);
SFR(P3, 0xB0);
   SBIT(P30, 0xB0, 0); //Port 3 Bit 0
   SBIT(P31, 0xB0, 1); //Port 3 Bit 1
   SBIT(P32, 0xB0, 2); //Port 3 Bit 2
   SBIT(P33, 0xB0, 3); //Port 3 Bit 3
   SBIT(P34, 0xB0, 4); //Port 3 Bit 4
   SBIT(P35, 0xB0, 5); //Port 3 Bit 5
   SBIT(P36, 0xB0, 6); //Port 3 Bit 6
   SBIT(P37, 0xB0, 7); //Port 3 Bit 7
   SBIT(P3_0, 0xB0, 0); //Port 3 Bit 0
   SBIT(P3_1, 0xB0, 1); //Port 3 Bit 1
   SBIT(P3_2, 0xB0, 2); //Port 3 Bit 2
   SBIT(P3_3, 0xB0, 3); //Port 3 Bit 3
   SBIT(P3_4, 0xB0, 4); //Port 3 Bit 4
   SBIT(P3_5, 0xB0, 5); //Port 3 Bit 5
   SBIT(P3_6, 0xB0, 6); //Port 3 Bit 6
   SBIT(P3_7, 0xB0, 7); //Port 3 Bit 7
SFR(P1M1, 0xB3);
SFR(IP0H, 0xB7);
SFR(IP,  0xB8);
SFR(IP0, 0xB8);
   SBIT(PX0, 0xB8, 0); //Priority External 0
   SBIT(PT0, 0xB8, 1); //Priority Timer 0
   SBIT(PX1, 0xB8, 2); //Priority External 1
   SBIT(PT1, 0xB8, 3); //Priority Timer 1
   SBIT(PS,  0xB8, 4); //Priority Serial
   SBIT(PC,  0xB8, 6); //Priority Comparator
   SBIT(PCM, 0xB8, 6); //Priority Comparator
SFR(SADEN, 0xB9);
SFR(NVMADDR, 0xC6);
SFR(TA, 0xC7);
SFR(NVMCON, 0xCE);
SFR(NVMDAT, 0xCF);
SFR(PSW, 0xD0);
   SBIT(P,   0xD0, 0); //Parity
   SBIT(F1,  0xD0, 1); //Flag 1
   SBIT(OV,  0xD0, 2); //Overflow
   SBIT(RS0, 0xD0, 3); //Register Select 0
   SBIT(RS1, 0xD0, 4); //Register Select 1
   SBIT(F0,  0xD0, 5); //Flag 0
   SBIT(AC,  0xD0, 6); //Auxiliary Carry
   SBIT(CY,  0xD0, 7); //Carry
SFR(PWMPH, 0xD1);
SFR(PWM0H, 0xD2);
SFR(PWMCON3, 0xD7);
SFR(WDCON, 0xD8);
   SBIT(WDCLR, 0xD8, 0); //Watchdog Clear
   SBIT(EWRST, 0xD8, 1); //Enable Watchdog Reset
   SBIT(WTRF,  0xD8, 2); //Watchdog Timer Reset Flag
   SBIT(WDIF,  0xD8, 3); //Watchdog Interrupt Flag
   SBIT(WD0,   0xD8, 4); //Watchdog Timeout 0
   SBIT(WD1,   0xD8, 5); //Watchdog Timeout 1
   SBIT(WDRUN, 0xD8, 7); //Watchdog Run
SFR(PWMPL, 0xD9);
SFR(PWM0L, 0xDA);
SFR(PWMCON1, 0xDC);
SFR(ACC, 0xE0);
   SBIT(ACC0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC7, 0xE0, 7); //Accumulator Bit 7
   SBIT(ACC_0, 0xE0, 0); //Accumulator Bit 0
   SBIT(ACC_1, 0xE0, 1); //Accumulator Bit 1
   SBIT(ACC_2, 0xE0, 2); //Accumulator Bit 2
   SBIT(ACC_3, 0xE0, 3); //Accumulator Bit 3
   SBIT(ACC_4, 0xE0, 4); //Accumulator Bit 4
   SBIT(ACC_5, 0xE0, 5); //Accumulator Bit 5
   SBIT(ACC_6, 0xE0, 6); //Accumulator Bit 6
   SBIT(ACC_7, 0xE0, 7); //Accumulator Bit 7
SFR(EIE, 0xE8);
   SBIT(EWDI, 0xE8, 4); //Enable Watchdog Interrupt
   SBIT(EPWM, 0xE8, 5); //Enable Pulse Width Modulator
   SBIT(EBOV, 0xE8, 6); //Enable Brown Out Vector
SFR(B, 0xF0);
   SBIT(B0, 0xF0, 0); //B Bit 0
   SBIT(B1, 0xF0, 1); //B Bit 1
   SBIT(B2, 0xF0, 2); //B Bit 2
   SBIT(B3, 0xF0, 3); //B Bit 3
   SBIT(B4, 0xF0, 4); //B Bit 4
   SBIT(B5, 0xF0, 5); //B Bit 5
   SBIT(B6, 0xF0, 6); //B Bit 6
   SBIT(B7, 0xF0, 7); //B Bit 7
   SBIT(B_0, 0xF0, 0); //B Bit 0
   SBIT(B_1, 0xF0, 1); //B Bit 1
   SBIT(B_2, 0xF0, 2); //B Bit 2
   SBIT(B_3, 0xF0, 3); //B Bit 3
   SBIT(B_4, 0xF0, 4); //B Bit 4
   SBIT(B_5, 0xF0, 5); //B Bit 5
   SBIT(B_6, 0xF0, 6); //B Bit 6
   SBIT(B_7, 0xF0, 7); //B Bit 7
SFR(PCMPIDS, 0xF6);
SFR(IP1H, 0xF7);
SFR(IP1, 0xF8);
   SBIT(PWDI, 0xF8, 4); //Priority Watchdog Interrupt
   SBIT(PPWM, 0xF8, 5); //Priority Pulse Width Modulator
   SBIT(PBO,  0xF8, 6); //Priority Brown Out Detect
   SBIT(PBOD, 0xB8, 6); //Priority Brown Out Detect
   SBIT(PBOV, 0xF8, 6); //Priority Brown Out Vector

#endif